=== modified file '.bzrignore'
--- .bzrignore	2005-08-26 02:31:37 +0000
+++ .bzrignore	2005-08-04 19:31:20 +0000
@@ -16,5 +16,3 @@
 test.log
 ./tmp
 build
-./ID
-./tags

=== modified file 'HACKING'
--- HACKING	2005-08-25 12:46:42 +0000
+++ HACKING	2005-08-17 02:11:25 +0000
@@ -20,10 +20,7 @@
   function runs.  Import statements have a cost, so try to make sure
   they don't run inside hot functions.
 
-* Please write PEP-8__ compliant code.  
-
-  One often-missed requirement is that the first line of docstrings
-  should be a self-contained one-sentence summary.
+* Please write PEP-8__ compliant code.
 
 __ http://www.python.org/peps/pep-0008.html
 
@@ -44,56 +41,3 @@
 mentioned, but new commands, changes in behaviour or fixed nontrivial
 bugs should be listed.  See the existing entries for an idea of what
 should be done.
-
-
-
-Writing output
-==============
-
-(The strategy described here is what we want to get to, but it's not
-consistently followed in the code at the moment.)
-
-bzrlib is intended to be a generically reusable library.  It shouldn't
-write messages to stdout or stderr, because some programs that use it
-might want to display that information through a GUI or some other
-mechanism.
-
-We can distinguish two types of output from the library:
-
- 1. Structured data representing the progress or result of an
-    operation.  For example, for a commit command this will be a list
-    of the modified files and the finally committed revision number
-    and id.
-
-    These should be exposed either through the return code or by calls
-    to a callback parameter.
-
-    A special case of this is progress indicators for long-lived
-    operations, where the caller should pass a ProgressBar object.
-
- 2. Unstructured log/debug messages, mostly for the benefit of the
-    developers or users trying to debug problems.  This should always
-    be sent through ``bzrlib.trace`` and Python ``logging``, so that
-    it can be redirected by the client.
-
-The distinction between the two is a bit subjective, but in general if
-there is any chance that a library would want to see something as
-structured data, we should make it so.
-
-The policy about how output is presented in the text-mode client
-should be only in the command-line tool.
-
-Writing tests
-=============
-In general tests should be placed in a file named test_FOO.py where 
-FOO is the logical thing under test. That file should be placed in the
-tests subdirectory under the package being tested.
-
-For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
-
-Running tests
-=============
-Currently, bzr selftest is used to invoke tests.
-You can provide a pattern argument to run a subset. For example, 
-to run just the whitebox tests, run bzr selftest --pattern .*whitebox.*
-

=== removed file 'Makefile'
--- Makefile	2005-09-01 06:32:52 +0000
+++ Makefile	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-all:
-	chmod u+x ./bzr
-
-check:
-	./bzr selftest
-
-.PHONY: all
-
-
-# build emacs cross-reference
-tag_files=./bzr ./bzrlib/*py ./bzrlib/selftest/*.py
-TAGS: $(tag_files)
-	ctags-exuberant -e $(tag_files)

=== modified file 'NEWS'
--- NEWS	2005-09-05 09:11:03 +0000
+++ NEWS	2005-08-22 16:31:16 +0000
@@ -1,58 +1,10 @@
-development head
-
-  INTERNALS:
-
-    * Refactor xml packing/unpacking.
-
-
-bzr-0.0.7 2005-09-02
+bzr development head
 
   NEW FEATURES:
 
     * ``bzr shell-complete`` command contributed by Clint Adams to
       help with intelligent shell completion.
 
-    * New expert command ``bzr find-merge-base`` for debugging merges.
-
-
-  ENHANCEMENTS:
-
-    * Much better merge support.
-
-    * merge3 conflicts are now reported with markers like '<<<<<<<'
-      (seven characters) which is the same as CVS and pleases things
-      like emacs smerge.
-
-
-  BUG FIXES:
-
-    * ``bzr upgrade`` no longer fails when trying to fix trees that
-      mention revisions that are not present.
-
-    * Fixed bugs in listing plugins from ``bzr plugins``.
-
-    * Fix case of $EDITOR containing options for the editor.
-
-    * Fix log -r refusing to show the last revision.
-      (Patch from Goffredo Baroncelli.)
-
-
-  CHANGES:
-
-    * ``bzr log --show-ids`` shows the revision ids of all parents.
-
-    * Externally provided commands on your $BZRPATH no longer need
-      to recognize --bzr-usage to work properly, and can just handle
-      --help themselves.
-
-
-  LIBRARY:
-
-    * Changed trace messages to go through the standard logging
-      framework, so that they can more easily be redirected by
-      libraries.
-
-
 
 bzr-0.0.6 2005-08-18
 
@@ -81,7 +33,7 @@
       specified by putting it into .bzr/email within a branch.  (Based
       on a patch from Heikki Paajanen.)
 
-
+    
   ENHANCEMENTS:
 
     * Faster working tree operations.

=== modified file 'TODO'
--- TODO	2005-09-01 12:34:34 +0000
+++ TODO	2005-08-17 03:31:19 +0000
@@ -24,7 +24,7 @@
 
   2005-11-05      mbp  Flowers for stephane
 
-* print a message at the end of running the tests telling them that the
+* print a message at the end of running the tests telling them tht the
   test log and output exists but can be removed
 
 * tests for running the commit editor, and fix problem of not passing in 
@@ -201,7 +201,6 @@
 * sometimes gives "conflicting add" even when the contents are in fact
   the same???
 
-* BZRDIR should be in branch.py not __init__.py.
 
 Medium things
 -------------

=== modified file 'bzr'
--- bzr	2005-08-25 07:46:11 +0000
+++ bzr	2005-07-26 14:06:11 +0000
@@ -42,10 +42,7 @@
     sys.exit(1)
 os.unsetenv(REINVOKE)
 
-import bzrlib
-import bzrlib.commands
-import bzrlib.trace
+import bzrlib, bzrlib.commands
 
 if __name__ == '__main__':
-    bzrlib.trace.enable_default_logging()
     sys.exit(bzrlib.commands.main(sys.argv))

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-09-05 04:07:23 +0000
+++ bzrlib/__init__.py	2005-08-22 14:15:16 +0000
@@ -16,6 +16,10 @@
 
 """bzr library"""
 
+# TODO: Do less imports here
+from branch import Branch, ScratchBranch, find_branch
+from errors import BzrError
+
 BZRDIR = ".bzr"
 
 DEFAULT_IGNORE = ['.bzr.log',
@@ -38,14 +42,11 @@
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
 __author__ = "Martin Pool <mbp@canonical.com>"
-__version__ = '0.1pre'
+__version__ = '0.0.7pre'
 
 
 def get_bzr_revision():
     """If bzr is run from a branch, return (revno,revid) or None"""
-    import bzrlib.errors
-    from bzrlib.branch import Branch
-    
     try:
         branch = Branch(__path__[0])
         rh = branch.revision_history()
@@ -53,9 +54,6 @@
             return len(rh), rh[-1]
         else:
             return None
-    except bzrlib.errors.BzrError:
+    except BzrError:
         return None
     
-def test_suite():
-    import selftest
-    return selftest.test_suite()

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2005-09-01 07:28:14 +0000
+++ bzrlib/add.py	2005-07-23 14:06:37 +0000
@@ -14,10 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.trace import mutter, note, warning
-from bzrlib.errors import NotBranchError
-from bzrlib.branch import Branch
-from bzrlib.osutils import quotefn
+from trace import mutter, note
 
 def glob_expand_for_win32(file_list):
     import glob
@@ -34,67 +31,35 @@
             expanded_file_list += glob_files
     return expanded_file_list
 
-
-def add_reporter_null(path, kind, entry):
-    """Absorb add reports and do nothing."""
-    pass
-
-def add_reporter_print(path, kind, entry):
-    """Print a line to stdout for each file that's added."""
-    print "added", quotefn(path)
-    
-def _prepare_file_list(file_list):
-    """Prepare a file list for use by smart_add_*."""
+def smart_add(file_list, verbose=True, recurse=True):
+    """Add files to version, optionally recursing into directories.
+
+    This is designed more towards DWIM for humans than API simplicity.
+    For the specific behaviour see the help for cmd_add().
+    """
+    import os
     import sys
+    from bzrlib.osutils import quotefn, kind_marker
+    from bzrlib.errors import BadFileKindError, ForbiddenFileError
+    import bzrlib.branch
+    import bzrlib.osutils
+
     if sys.platform == 'win32':
         file_list = glob_expand_for_win32(file_list)
+        
     if not file_list:
         file_list = ['.']
-    file_list = list(file_list)
-    return file_list
-
-
-def smart_add(file_list, recurse=True, reporter=add_reporter_null):
-    """Add files to version, optionally recursing into directories.
-
-    This is designed more towards DWIM for humans than API simplicity.
-    For the specific behaviour see the help for cmd_add().
-
-    Returns the number of files added.
-    """
-    file_list = _prepare_file_list(file_list)
-    b = Branch(file_list[0], find_root=True)
-    return smart_add_branch(b, file_list, recurse, reporter)
-
-        
-def smart_add_branch(branch, file_list, recurse=True, reporter=add_reporter_null):
-    """Add files to version, optionally recursing into directories.
-
-    This is designed more towards DWIM for humans than API simplicity.
-    For the specific behaviour see the help for cmd_add().
-
-    This yields a sequence of (path, kind, file_id) for added files.
-
-    Returns the number of files added.
-    """
-    import os
-    import sys
-    from bzrlib.osutils import quotefn
-    from bzrlib.errors import BadFileKindError, ForbiddenFileError
-    import bzrlib.branch
-    import bzrlib.osutils
-
-    assert isinstance(recurse, bool)
-
-    file_list = _prepare_file_list(file_list)
+    
     user_list = file_list[:]
-    inv = branch.read_working_inventory()
-    tree = branch.working_tree()
+    assert not isinstance(file_list, basestring)
+    b = bzrlib.branch.Branch(file_list[0], find_root=True)
+    inv = b.read_working_inventory()
+    tree = b.working_tree()
     count = 0
 
     for f in file_list:
-        rf = branch.relpath(f)
-        af = branch.abspath(rf)
+        rf = b.relpath(f)
+        af = b.abspath(rf)
 
         kind = bzrlib.osutils.file_kind(af)
 
@@ -102,7 +67,7 @@
             if f in user_list:
                 raise BadFileKindError("cannot add %s of type %s" % (f, kind))
             else:
-                warning("skipping %s (can't add file of kind '%s')", f, kind)
+                print "skipping %s (can't add file of kind '%s')" % (f, kind)
                 continue
 
         mutter("smart add of %r, abs=%r" % (f, af))
@@ -112,29 +77,19 @@
             
         versioned = (inv.path2id(rf) != None)
 
-        if kind == 'directory':
-            try:
-                sub_branch = Branch(af, find_root=False)
-                sub_tree = True
-            except NotBranchError:
-                sub_tree = False
-        else:
-            sub_tree = False
-
         if rf == '':
             mutter("branch root doesn't need to be added")
-            sub_tree = False
         elif versioned:
             mutter("%r is already versioned" % f)
-        elif sub_tree:
-            mutter("%r is a bzr tree" %f)
         else:
-            entry = inv.add_path(rf, kind=kind)
-            mutter("added %r kind %r file_id={%s}" % (rf, kind, entry.file_id))
+            file_id = bzrlib.branch.gen_file_id(rf)
+            inv.add_path(rf, kind=kind, file_id=file_id)
+            mutter("added %r kind %r file_id={%s}" % (rf, kind, file_id))
             count += 1 
-            reporter(rf, kind, entry)
-
-        if kind == 'directory' and recurse and not sub_tree:
+
+            print 'added', quotefn(f)
+
+        if kind == 'directory' and recurse:
             for subf in os.listdir(af):
                 subp = os.path.join(rf, subf)
                 if subf == bzrlib.BZRDIR:
@@ -143,12 +98,12 @@
                     mutter("skip ignored sub-file %r" % subp)
                 else:
                     mutter("queue to add sub-file %r" % subp)
-                    file_list.append(branch.abspath(subp))
-
-
-    mutter('added %d entries', count)
-    
+                    file_list.append(b.abspath(subp))
+
     if count > 0:
-        branch._write_inventory(inv)
-
-    return count
+        if verbose:
+            note('added %d' % count)
+        b._write_inventory(inv)
+    else:
+        print "nothing new to add"
+        # should this return 1 to the shell?

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-09-05 09:27:11 +0000
+++ bzrlib/branch.py	2005-08-18 04:25:42 +0000
@@ -23,18 +23,14 @@
 from bzrlib.osutils import isdir, quotefn, compact_date, rand_bytes, \
      splitpath, \
      sha_file, appendpath, file_kind
-
 from bzrlib.errors import BzrError, InvalidRevisionNumber, InvalidRevisionId
 import bzrlib.errors
 from bzrlib.textui import show_status
 from bzrlib.revision import Revision
+from bzrlib.xml import unpack_xml
 from bzrlib.delta import compare_trees
 from bzrlib.tree import EmptyTree, RevisionTree
-import bzrlib.xml
-import bzrlib.ui
-
-
-
+        
 BZR_BRANCH_FORMAT = "Bazaar-NG branch, format 0.0.4\n"
 ## TODO: Maybe include checks for common corruption of newlines, etc?
 
@@ -128,7 +124,7 @@
         head, tail = os.path.split(f)
         if head == f:
             # reached the root, whatever that may be
-            raise bzrlib.errors.NotBranchError('%s is not in a branch' % orig_f)
+            raise bzrlib.errors.NotBranchError('%r is not in a branch' % orig_f)
         f = head
 
 
@@ -219,6 +215,7 @@
             self._lock.unlock()
 
 
+
     def lock_write(self):
         if self._lock_mode:
             if self._lock_mode != 'w':
@@ -234,6 +231,7 @@
             self._lock_count = 1
 
 
+
     def lock_read(self):
         if self._lock_mode:
             assert self._lock_mode in ('r', 'w'), \
@@ -246,6 +244,8 @@
             self._lock_mode = 'r'
             self._lock_count = 1
                         
+
+            
     def unlock(self):
         if not self._lock_mode:
             from errors import LockError
@@ -258,16 +258,19 @@
             self._lock = None
             self._lock_mode = self._lock_count = None
 
+
     def abspath(self, name):
         """Return absolute filename for something in the branch"""
         return os.path.join(self.base, name)
 
+
     def relpath(self, path):
         """Return path relative to this branch of something inside it.
 
         Raises an error if path is not in this branch."""
         return _relpath(self.base, path)
 
+
     def controlfilename(self, file_or_path):
         """Return location relative to branch."""
         if isinstance(file_or_path, basestring):
@@ -300,8 +303,11 @@
         else:
             raise BzrError("invalid controlfile mode %r" % mode)
 
+
+
     def _make_control(self):
         from bzrlib.inventory import Inventory
+        from bzrlib.xml import pack_xml
         
         os.mkdir(self.controlfilename([]))
         self.controlfile('README', 'w').write(
@@ -320,8 +326,7 @@
         # if we want per-tree root ids then this is the place to set
         # them; they're not needed for now and so ommitted for
         # simplicity.
-        f = self.controlfile('inventory','w')
-        bzrlib.xml.serializer_v4.write_inventory(Inventory(), f)
+        pack_xml(Inventory(), self.controlfile('inventory','w'))
 
 
     def _check_format(self):
@@ -362,12 +367,18 @@
     def read_working_inventory(self):
         """Read the working inventory."""
         from bzrlib.inventory import Inventory
+        from bzrlib.xml import unpack_xml
+        from time import time
+        before = time()
         self.lock_read()
         try:
             # ElementTree does its own conversion from UTF-8, so open in
             # binary.
-            f = self.controlfile('inventory', 'rb')
-            return bzrlib.xml.serializer_v4.read_inventory(f)
+            inv = unpack_xml(Inventory,
+                             self.controlfile('inventory', 'rb'))
+            mutter("loaded inventory of %d items in %f"
+                   % (len(inv), time() - before))
+            return inv
         finally:
             self.unlock()
             
@@ -379,12 +390,13 @@
         will be committed to the next revision.
         """
         from bzrlib.atomicfile import AtomicFile
+        from bzrlib.xml import pack_xml
         
         self.lock_write()
         try:
             f = AtomicFile(self.controlfilename('inventory'), 'wb')
             try:
-                bzrlib.xml.serializer_v4.write_inventory(inv, f)
+                pack_xml(inv, f)
                 f.commit()
             finally:
                 f.close()
@@ -398,11 +410,10 @@
                          """Inventory for the working copy.""")
 
 
-    def add(self, files, ids=None):
+    def add(self, files, verbose=False, ids=None):
         """Make files versioned.
 
-        Note that the command line normally calls smart_add instead,
-        which can automatically recurse.
+        Note that the command line normally calls smart_add instead.
 
         This puts the files in the Added state, so that they will be
         recorded by the next commit.
@@ -418,7 +429,12 @@
         TODO: Perhaps have an option to add the ids even if the files do
               not (yet) exist.
 
-        TODO: Perhaps yield the ids and paths as they're added.
+        TODO: Perhaps return the ids of the files?  But then again it
+              is easy to retrieve them if they're needed.
+
+        TODO: Adding a directory should optionally recurse down and
+              add all non-ignored children.  Perhaps do that in a
+              higher-level method.
         """
         # TODO: Re-adding a file that is removed in the working copy
         # should probably put it back with the previous ID.
@@ -460,6 +476,9 @@
                     file_id = gen_file_id(f)
                 inv.add_path(f, kind=kind, file_id=file_id)
 
+                if verbose:
+                    print 'added', quotefn(f)
+
                 mutter("add file %s file_id:{%s} kind=%r" % (f, file_id, kind))
 
             self._write_inventory(inv)
@@ -575,7 +594,7 @@
             f.close()
 
 
-    def get_revision_xml_file(self, revision_id):
+    def get_revision_xml(self, revision_id):
         """Return XML file object for revision object."""
         if not revision_id or not isinstance(revision_id, basestring):
             raise InvalidRevisionId(revision_id)
@@ -590,16 +609,12 @@
             self.unlock()
 
 
-    #deprecated
-    get_revision_xml = get_revision_xml_file
-
-
     def get_revision(self, revision_id):
         """Return the Revision object for a named revision"""
-        xml_file = self.get_revision_xml_file(revision_id)
+        xml_file = self.get_revision_xml(revision_id)
 
         try:
-            r = bzrlib.xml.serializer_v4.read_revision(xml_file)
+            r = unpack_xml(Revision, xml_file)
         except SyntaxError, e:
             raise bzrlib.errors.BzrError('failed to unpack revision_xml',
                                          [revision_id,
@@ -650,16 +665,14 @@
                parameter which can be either an integer revno or a
                string hash."""
         from bzrlib.inventory import Inventory
+        from bzrlib.xml import unpack_xml
 
-        f = self.get_inventory_xml_file(inventory_id)
-        return bzrlib.xml.serializer_v4.read_inventory(f)
+        return unpack_xml(Inventory, self.get_inventory_xml(inventory_id))
 
 
     def get_inventory_xml(self, inventory_id):
         """Get inventory XML as a file object."""
         return self.inventory_store[inventory_id]
-
-    get_inventory_xml_file = get_inventory_xml
             
 
     def get_inventory_sha1(self, inventory_id):
@@ -757,7 +770,7 @@
             return None
 
 
-    def missing_revisions(self, other, stop_revision=None, diverged_ok=False):
+    def missing_revisions(self, other, stop_revision=None):
         """
         If self and other have not diverged, return a list of the revisions
         present in other, but missing from self.
@@ -796,53 +809,55 @@
         if stop_revision is None:
             stop_revision = other_len
         elif stop_revision > other_len:
-            raise bzrlib.errors.NoSuchRevision(self, stop_revision)
+            raise NoSuchRevision(self, stop_revision)
         
         return other_history[self_len:stop_revision]
 
 
     def update_revisions(self, other, stop_revision=None):
         """Pull in all new revisions from other branch.
+        
+        >>> from bzrlib.commit import commit
+        >>> bzrlib.trace.silent = True
+        >>> br1 = ScratchBranch(files=['foo', 'bar'])
+        >>> br1.add('foo')
+        >>> br1.add('bar')
+        >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
+        >>> br2 = ScratchBranch()
+        >>> br2.update_revisions(br1)
+        Added 2 texts.
+        Added 1 inventories.
+        Added 1 revisions.
+        >>> br2.revision_history()
+        [u'REVISION-ID-1']
+        >>> br2.update_revisions(br1)
+        Added 0 texts.
+        Added 0 inventories.
+        Added 0 revisions.
+        >>> br1.text_store.total_size() == br2.text_store.total_size()
+        True
         """
-        from bzrlib.fetch import greedy_fetch
-
-        pb = bzrlib.ui.ui_factory.progress_bar()
+        from bzrlib.progress import ProgressBar
+
+        pb = ProgressBar()
+
         pb.update('comparing histories')
-
         revision_ids = self.missing_revisions(other, stop_revision)
 
-        if len(revision_ids) > 0:
-            count = greedy_fetch(self, other, revision_ids[-1], pb)[0]
-        else:
-            count = 0
-        self.append_revision(*revision_ids)
-        ## note("Added %d revisions." % count)
-        pb.clear()
-
-    def install_revisions(self, other, revision_ids, pb):
         if hasattr(other.revision_store, "prefetch"):
             other.revision_store.prefetch(revision_ids)
         if hasattr(other.inventory_store, "prefetch"):
             inventory_ids = [other.get_revision(r).inventory_id
                              for r in revision_ids]
             other.inventory_store.prefetch(inventory_ids)
-
-        if pb is None:
-            pb = bzrlib.ui.ui_factory.progress_bar()
                 
         revisions = []
         needed_texts = set()
         i = 0
-
-        failures = set()
-        for i, rev_id in enumerate(revision_ids):
-            pb.update('fetching revision', i+1, len(revision_ids))
-            try:
-                rev = other.get_revision(rev_id)
-            except bzrlib.errors.NoSuchRevision:
-                failures.add(rev_id)
-                continue
-
+        for rev_id in revision_ids:
+            i += 1
+            pb.update('fetching revision', i, len(revision_ids))
+            rev = other.get_revision(rev_id)
             revisions.append(rev)
             inv = other.get_inventory(str(rev.inventory_id))
             for key, entry in inv.iter_entries():
@@ -853,22 +868,20 @@
 
         pb.clear()
                     
-        count, cp_fail = self.text_store.copy_multi(other.text_store, 
-                                                    needed_texts)
-        #print "Added %d texts." % count 
+        count = self.text_store.copy_multi(other.text_store, needed_texts)
+        print "Added %d texts." % count 
         inventory_ids = [ f.inventory_id for f in revisions ]
-        count, cp_fail = self.inventory_store.copy_multi(other.inventory_store, 
-                                                         inventory_ids)
-        #print "Added %d inventories." % count 
+        count = self.inventory_store.copy_multi(other.inventory_store, 
+                                                inventory_ids)
+        print "Added %d inventories." % count 
         revision_ids = [ f.revision_id for f in revisions]
-
-        count, cp_fail = self.revision_store.copy_multi(other.revision_store, 
-                                                          revision_ids,
-                                                          permit_failure=True)
-        assert len(cp_fail) == 0 
-        return count, failures
-       
-
+        count = self.revision_store.copy_multi(other.revision_store, 
+                                               revision_ids)
+        for revision_id in revision_ids:
+            self.append_revision(revision_id)
+        print "Added %d revisions." % count
+                    
+        
     def commit(self, *args, **kw):
         from bzrlib.commit import commit
         commit(self, *args, **kw)
@@ -876,19 +889,9 @@
 
     def lookup_revision(self, revision):
         """Return the revision identifier for a given revision information."""
-        revno, info = self._get_revision_info(revision)
+        revno, info = self.get_revision_info(revision)
         return info
 
-
-    def revision_id_to_revno(self, revision_id):
-        """Given a revision id, return its revno"""
-        history = self.revision_history()
-        try:
-            return history.index(revision_id) + 1
-        except ValueError:
-            raise bzrlib.errors.NoSuchRevision(self, revision_id)
-
-
     def get_revision_info(self, revision):
         """Return (revno, revision id) for revision identifier.
 
@@ -897,34 +900,6 @@
         revision can also be a string, in which case it is parsed for something like
             'date:' or 'revid:' etc.
         """
-        revno, rev_id = self._get_revision_info(revision)
-        if revno is None:
-            raise bzrlib.errors.NoSuchRevision(self, revision)
-        return revno, rev_id
-
-    def get_rev_id(self, revno, history=None):
-        """Find the revision id of the specified revno."""
-        if revno == 0:
-            return None
-        if history is None:
-            history = self.revision_history()
-        elif revno <= 0 or revno > len(history):
-            raise bzrlib.errors.NoSuchRevision(self, revno)
-        return history[revno - 1]
-
-    def _get_revision_info(self, revision):
-        """Return (revno, revision id) for revision specifier.
-
-        revision can be an integer, in which case it is assumed to be revno
-        (though this will translate negative values into positive ones)
-        revision can also be a string, in which case it is parsed for something
-        like 'date:' or 'revid:' etc.
-
-        A revid is always returned.  If it is None, the specifier referred to
-        the null revision.  If the revid does not occur in the revision
-        history, revno will be None.
-        """
-        
         if revision is None:
             return 0, None
         revno = None
@@ -934,48 +909,40 @@
             pass
         revs = self.revision_history()
         if isinstance(revision, int):
+            if revision == 0:
+                return 0, None
+            # Mabye we should do this first, but we don't need it if revision == 0
             if revision < 0:
                 revno = len(revs) + revision + 1
             else:
                 revno = revision
-            rev_id = self.get_rev_id(revno, revs)
         elif isinstance(revision, basestring):
             for prefix, func in Branch.REVISION_NAMESPACES.iteritems():
                 if revision.startswith(prefix):
-                    result = func(self, revs, revision)
-                    if len(result) > 1:
-                        revno, rev_id = result
-                    else:
-                        revno = result[0]
-                        rev_id = self.get_rev_id(revno, revs)
+                    revno = func(self, revs, revision)
                     break
             else:
-                raise BzrError('No namespace registered for string: %r' %
-                               revision)
-        else:
-            raise TypeError('Unhandled revision type %s' % revision)
+                raise BzrError('No namespace registered for string: %r' % revision)
 
-        if revno is None:
-            if rev_id is None:
-                raise bzrlib.errors.NoSuchRevision(self, revision)
-        return revno, rev_id
+        if revno is None or revno <= 0 or revno > len(revs):
+            raise BzrError("no such revision %s" % revision)
+        return revno, revs[revno-1]
 
     def _namespace_revno(self, revs, revision):
         """Lookup a revision by revision number"""
         assert revision.startswith('revno:')
         try:
-            return (int(revision[6:]),)
+            return int(revision[6:])
         except ValueError:
             return None
     REVISION_NAMESPACES['revno:'] = _namespace_revno
 
     def _namespace_revid(self, revs, revision):
         assert revision.startswith('revid:')
-        rev_id = revision[len('revid:'):]
         try:
-            return revs.index(rev_id) + 1, rev_id
+            return revs.index(revision[6:]) + 1
         except ValueError:
-            return None, rev_id
+            return None
     REVISION_NAMESPACES['revid:'] = _namespace_revid
 
     def _namespace_last(self, revs, revision):
@@ -983,11 +950,11 @@
         try:
             offset = int(revision[5:])
         except ValueError:
-            return (None,)
+            return None
         else:
             if offset <= 0:
                 raise BzrError('You must supply a positive value for --revision last:XXX')
-            return (len(revs) - offset + 1,)
+            return len(revs) - offset + 1
     REVISION_NAMESPACES['last:'] = _namespace_last
 
     def _namespace_tag(self, revs, revision):
@@ -1068,14 +1035,14 @@
                 # TODO: Handle timezone.
                 dt = datetime.datetime.fromtimestamp(r.timestamp)
                 if first >= dt and (last is None or dt >= last):
-                    return (i+1,)
+                    return i+1
         else:
             for i in range(len(revs)):
                 r = self.get_revision(revs[i])
                 # TODO: Handle timezone.
                 dt = datetime.datetime.fromtimestamp(r.timestamp)
                 if first <= dt and (last is None or dt <= last):
-                    return (i+1,)
+                    return i+1
     REVISION_NAMESPACES['date:'] = _namespace_date
 
     def revision_tree(self, revision_id):
@@ -1146,6 +1113,8 @@
 
             inv.rename(file_id, to_dir_id, to_tail)
 
+            print "%s => %s" % (from_rel, to_rel)
+
             from_abs = self.abspath(from_rel)
             to_abs = self.abspath(to_rel)
             try:
@@ -1170,11 +1139,7 @@
 
         Note that to_name is only the last component of the new name;
         this doesn't change the directory.
-
-        This returns a list of (from_path, to_path) pairs for each
-        entry that is moved.
         """
-        result = []
         self.lock_write()
         try:
             ## TODO: Option to move IDs only
@@ -1215,7 +1180,7 @@
             for f in from_paths:
                 name_tail = splitpath(f)[-1]
                 dest_path = appendpath(to_name, name_tail)
-                result.append((f, dest_path))
+                print "%s => %s" % (f, dest_path)
                 inv.rename(inv.path2id(f), to_dir_id, name_tail)
                 try:
                     os.rename(self.abspath(f), self.abspath(dest_path))
@@ -1227,8 +1192,6 @@
         finally:
             self.unlock()
 
-        return result
-
 
     def revert(self, filenames, old_tree=None, backups=True):
         """Restore selected files to the versions from a previous tree.
@@ -1316,56 +1279,6 @@
             self.unlock()
 
 
-    def get_parent(self):
-        """Return the parent location of the branch.
-
-        This is the default location for push/pull/missing.  The usual
-        pattern is that the user can override it by specifying a
-        location.
-        """
-        import errno
-        _locs = ['parent', 'pull', 'x-pull']
-        for l in _locs:
-            try:
-                return self.controlfile(l, 'r').read().strip('\n')
-            except IOError, e:
-                if e.errno != errno.ENOENT:
-                    raise
-        return None
-
-
-    def set_parent(self, url):
-        # TODO: Maybe delete old location files?
-        from bzrlib.atomicfile import AtomicFile
-        self.lock_write()
-        try:
-            f = AtomicFile(self.controlfilename('parent'))
-            try:
-                f.write(url + '\n')
-                f.commit()
-            finally:
-                f.close()
-        finally:
-            self.unlock()
-
-    def check_revno(self, revno):
-        """\
-        Check whether a revno corresponds to any revision.
-        Zero (the NULL revision) is considered valid.
-        """
-        if revno != 0:
-            self.check_real_revno(revno)
-            
-    def check_real_revno(self, revno):
-        """\
-        Check whether a revno corresponds to a real revision.
-        Zero (the NULL revision) is considered invalid
-        """
-        if revno < 1 or revno > self.revno():
-            raise InvalidRevisionNumber(revno)
-        
-        
-
 
 class ScratchBranch(Branch):
     """Special test class: a branch that cleans up after itself.
@@ -1413,8 +1326,6 @@
         os.rmdir(base)
         copytree(self.base, base, symlinks=True)
         return ScratchBranch(base=base)
-
-
         
     def __del__(self):
         self.destroy()
@@ -1490,42 +1401,3 @@
     """Return a new tree-root file id."""
     return gen_file_id('TREE_ROOT')
 
-
-def pull_loc(branch):
-    # TODO: Should perhaps just make attribute be 'base' in
-    # RemoteBranch and Branch?
-    if hasattr(branch, "baseurl"):
-        return branch.baseurl
-    else:
-        return branch.base
-
-
-def copy_branch(branch_from, to_location, revision=None):
-    """Copy branch_from into the existing directory to_location.
-
-    revision
-        If not None, only revisions up to this point will be copied.
-        The head of the new branch will be that revision.
-
-    to_location
-        The name of a local directory that exists but is empty.
-    """
-    from bzrlib.merge import merge
-    from bzrlib.branch import Branch
-
-    assert isinstance(branch_from, Branch)
-    assert isinstance(to_location, basestring)
-    
-    br_to = Branch(to_location, init=True)
-    br_to.set_root_id(branch_from.get_root_id())
-    if revision is None:
-        revno = branch_from.revno()
-    else:
-        revno, rev_id = branch_from.get_revision_info(revision)
-    br_to.update_revisions(branch_from, stop_revision=revno)
-    merge((to_location, -1), (to_location, 0), this_dir=to_location,
-          check_clean=False, ignore_zero=True)
-    
-    from_location = pull_loc(branch_from)
-    br_to.set_parent(pull_loc(branch_from))
-

=== removed file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-09-05 09:27:11 +0000
+++ bzrlib/builtins.py	1970-01-01 00:00:00 +0000
@@ -1,1328 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import sys
-import os
-
-import bzrlib
-import bzrlib.trace
-from bzrlib.trace import mutter, note, log_error, warning
-from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
-from bzrlib.branch import find_branch
-from bzrlib import BZRDIR
-from bzrlib.commands import Command
-
-
-class cmd_status(Command):
-    """Display status summary.
-
-    This reports on versioned and unknown files, reporting them
-    grouped by state.  Possible states are:
-
-    added
-        Versioned in the working copy but not in the previous revision.
-
-    removed
-        Versioned in the previous revision but removed or deleted
-        in the working copy.
-
-    renamed
-        Path of this file changed from the previous revision;
-        the text may also have changed.  This includes files whose
-        parent directory was renamed.
-
-    modified
-        Text has changed since the previous revision.
-
-    unchanged
-        Nothing about this file has changed since the previous revision.
-        Only shown with --all.
-
-    unknown
-        Not versioned and not matching an ignore pattern.
-
-    To see ignored files use 'bzr ignored'.  For details in the
-    changes to file texts, use 'bzr diff'.
-
-    If no arguments are specified, the status of the entire working
-    directory is shown.  Otherwise, only the status of the specified
-    files or directories is reported.  If a directory is given, status
-    is reported for everything inside that directory.
-
-    If a revision is specified, the changes since that revision are shown.
-    """
-    takes_args = ['file*']
-    takes_options = ['all', 'show-ids', 'revision']
-    aliases = ['st', 'stat']
-    
-    def run(self, all=False, show_ids=False, file_list=None):
-        if file_list:
-            b = find_branch(file_list[0])
-            file_list = [b.relpath(x) for x in file_list]
-            # special case: only one path was given and it's the root
-            # of the branch
-            if file_list == ['']:
-                file_list = None
-        else:
-            b = find_branch('.')
-            
-        from bzrlib.status import show_status
-        show_status(b, show_unchanged=all, show_ids=show_ids,
-                    specific_files=file_list)
-
-
-class cmd_cat_revision(Command):
-    """Write out metadata for a revision."""
-
-    hidden = True
-    takes_args = ['revision_id']
-    
-    def run(self, revision_id):
-        b = find_branch('.')
-        sys.stdout.write(b.get_revision_xml_file(revision_id).read())
-
-
-class cmd_revno(Command):
-    """Show current revision number.
-
-    This is equal to the number of revisions on this branch."""
-    def run(self):
-        print find_branch('.').revno()
-
-
-class cmd_revision_info(Command):
-    """Show revision number and revision id for a given revision identifier.
-    """
-    hidden = True
-    takes_args = ['revision_info*']
-    takes_options = ['revision']
-    def run(self, revision=None, revision_info_list=None):
-        from bzrlib.branch import find_branch
-
-        revs = []
-        if revision is not None:
-            revs.extend(revision)
-        if revision_info_list is not None:
-            revs.extend(revision_info_list)
-        if len(revs) == 0:
-            raise BzrCommandError('You must supply a revision identifier')
-
-        b = find_branch('.')
-
-        for rev in revs:
-            print '%4d %s' % b.get_revision_info(rev)
-
-    
-class cmd_add(Command):
-    """Add specified files or directories.
-
-    In non-recursive mode, all the named items are added, regardless
-    of whether they were previously ignored.  A warning is given if
-    any of the named files are already versioned.
-
-    In recursive mode (the default), files are treated the same way
-    but the behaviour for directories is different.  Directories that
-    are already versioned do not give a warning.  All directories,
-    whether already versioned or not, are searched for files or
-    subdirectories that are neither versioned or ignored, and these
-    are added.  This search proceeds recursively into versioned
-    directories.  If no names are given '.' is assumed.
-
-    Therefore simply saying 'bzr add' will version all files that
-    are currently unknown.
-
-    TODO: Perhaps adding a file whose directly is not versioned should
-    recursively add that parent, rather than giving an error?
-    """
-    takes_args = ['file*']
-    takes_options = ['verbose', 'no-recurse']
-    
-    def run(self, file_list, verbose=False, no_recurse=False):
-        # verbose currently has no effect
-        from bzrlib.add import smart_add, add_reporter_print
-        smart_add(file_list, not no_recurse, add_reporter_print)
-
-
-
-class cmd_mkdir(Command):
-    """Create a new versioned directory.
-
-    This is equivalent to creating the directory and then adding it.
-    """
-    takes_args = ['dir+']
-
-    def run(self, dir_list):
-        b = None
-        
-        for d in dir_list:
-            os.mkdir(d)
-            if not b:
-                b = find_branch(d)
-            b.add([d])
-            print 'added', d
-
-
-class cmd_relpath(Command):
-    """Show path of a file relative to root"""
-    takes_args = ['filename']
-    hidden = True
-    
-    def run(self, filename):
-        print find_branch(filename).relpath(filename)
-
-
-
-class cmd_inventory(Command):
-    """Show inventory of the current working copy or a revision."""
-    takes_options = ['revision', 'show-ids']
-    
-    def run(self, revision=None, show_ids=False):
-        b = find_branch('.')
-        if revision == None:
-            inv = b.read_working_inventory()
-        else:
-            if len(revision) > 1:
-                raise BzrCommandError('bzr inventory --revision takes'
-                    ' exactly one revision identifier')
-            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
-
-        for path, entry in inv.entries():
-            if show_ids:
-                print '%-50s %s' % (path, entry.file_id)
-            else:
-                print path
-
-
-class cmd_move(Command):
-    """Move files to a different directory.
-
-    examples:
-        bzr move *.txt doc
-
-    The destination must be a versioned directory in the same branch.
-    """
-    takes_args = ['source$', 'dest']
-    def run(self, source_list, dest):
-        b = find_branch('.')
-
-        # TODO: glob expansion on windows?
-        b.move([b.relpath(s) for s in source_list], b.relpath(dest))
-
-
-class cmd_rename(Command):
-    """Change the name of an entry.
-
-    examples:
-      bzr rename frob.c frobber.c
-      bzr rename src/frob.c lib/frob.c
-
-    It is an error if the destination name exists.
-
-    See also the 'move' command, which moves files into a different
-    directory without changing their name.
-
-    TODO: Some way to rename multiple files without invoking bzr for each
-    one?"""
-    takes_args = ['from_name', 'to_name']
-    
-    def run(self, from_name, to_name):
-        b = find_branch('.')
-        b.rename_one(b.relpath(from_name), b.relpath(to_name))
-
-
-
-class cmd_mv(Command):
-    """Move or rename a file.
-
-    usage:
-        bzr mv OLDNAME NEWNAME
-        bzr mv SOURCE... DESTINATION
-
-    If the last argument is a versioned directory, all the other names
-    are moved into it.  Otherwise, there must be exactly two arguments
-    and the file is changed to a new name, which must not already exist.
-
-    Files cannot be moved between branches.
-    """
-    takes_args = ['names*']
-    def run(self, names_list):
-        if len(names_list) < 2:
-            raise BzrCommandError("missing file argument")
-        b = find_branch(names_list[0])
-
-        rel_names = [b.relpath(x) for x in names_list]
-        
-        if os.path.isdir(names_list[-1]):
-            # move into existing directory
-            for pair in b.move(rel_names[:-1], rel_names[-1]):
-                print "%s => %s" % pair
-        else:
-            if len(names_list) != 2:
-                raise BzrCommandError('to mv multiple files the destination '
-                                      'must be a versioned directory')
-            for pair in b.move(rel_names[0], rel_names[1]):
-                print "%s => %s" % pair
-            
-    
-
-
-class cmd_pull(Command):
-    """Pull any changes from another branch into the current one.
-
-    If the location is omitted, the last-used location will be used.
-    Both the revision history and the working directory will be
-    updated.
-
-    This command only works on branches that have not diverged.  Branches are
-    considered diverged if both branches have had commits without first
-    pulling from the other.
-
-    If branches have diverged, you can use 'bzr merge' to pull the text changes
-    from one into the other.
-    """
-    takes_args = ['location?']
-
-    def run(self, location=None):
-        from bzrlib.merge import merge
-        import tempfile
-        from shutil import rmtree
-        import errno
-        from bzrlib.branch import pull_loc
-        
-        br_to = find_branch('.')
-        stored_loc = None
-        try:
-            stored_loc = br_to.controlfile("x-pull", "rb").read().rstrip('\n')
-        except IOError, e:
-            if e.errno != errno.ENOENT:
-                raise
-        if location is None:
-            if stored_loc is None:
-                raise BzrCommandError("No pull location known or specified.")
-            else:
-                print "Using last location: %s" % stored_loc
-                location = stored_loc
-        cache_root = tempfile.mkdtemp()
-        from bzrlib.branch import DivergedBranches
-        br_from = find_branch(location)
-        location = pull_loc(br_from)
-        old_revno = br_to.revno()
-        try:
-            from branch import find_cached_branch, DivergedBranches
-            br_from = find_cached_branch(location, cache_root)
-            location = pull_loc(br_from)
-            old_revno = br_to.revno()
-            try:
-                br_to.update_revisions(br_from)
-            except DivergedBranches:
-                raise BzrCommandError("These branches have diverged."
-                    "  Try merge.")
-                
-            merge(('.', -1), ('.', old_revno), check_clean=False)
-            if location != stored_loc:
-                br_to.controlfile("x-pull", "wb").write(location + "\n")
-        finally:
-            rmtree(cache_root)
-
-
-
-class cmd_branch(Command):
-    """Create a new copy of a branch.
-
-    If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
-    be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
-
-    To retrieve the branch as of a particular revision, supply the --revision
-    parameter, as in "branch foo/bar -r 5".
-    """
-    takes_args = ['from_location', 'to_location?']
-    takes_options = ['revision']
-    aliases = ['get', 'clone']
-
-    def run(self, from_location, to_location=None, revision=None):
-        from bzrlib.branch import copy_branch, find_cached_branch
-        import tempfile
-        import errno
-        from shutil import rmtree
-        cache_root = tempfile.mkdtemp()
-        try:
-            if revision is None:
-                revision = [None]
-            elif len(revision) > 1:
-                raise BzrCommandError(
-                    'bzr branch --revision takes exactly 1 revision value')
-            try:
-                br_from = find_cached_branch(from_location, cache_root)
-            except OSError, e:
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Source location "%s" does not'
-                                          ' exist.' % to_location)
-                else:
-                    raise
-            if to_location is None:
-                to_location = os.path.basename(from_location.rstrip("/\\"))
-            try:
-                os.mkdir(to_location)
-            except OSError, e:
-                if e.errno == errno.EEXIST:
-                    raise BzrCommandError('Target directory "%s" already'
-                                          ' exists.' % to_location)
-                if e.errno == errno.ENOENT:
-                    raise BzrCommandError('Parent of "%s" does not exist.' %
-                                          to_location)
-                else:
-                    raise
-            try:
-                copy_branch(br_from, to_location, revision[0])
-            except bzrlib.errors.NoSuchRevision:
-                rmtree(to_location)
-                msg = "The branch %s has no revision %d." % (from_location, revision[0])
-                raise BzrCommandError(msg)
-        finally:
-            rmtree(cache_root)
-
-
-class cmd_renames(Command):
-    """Show list of renamed files.
-
-    TODO: Option to show renames between two historical versions.
-
-    TODO: Only show renames under dir, rather than in the whole branch.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        b = find_branch(dir)
-        old_inv = b.basis_tree().inventory
-        new_inv = b.read_working_inventory()
-
-        renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
-        renames.sort()
-        for old_name, new_name in renames:
-            print "%s => %s" % (old_name, new_name)        
-
-
-class cmd_info(Command):
-    """Show statistical information about a branch."""
-    takes_args = ['branch?']
-    
-    def run(self, branch=None):
-        import info
-
-        b = find_branch(branch)
-        info.show_info(b)
-
-
-class cmd_remove(Command):
-    """Make a file unversioned.
-
-    This makes bzr stop tracking changes to a versioned file.  It does
-    not delete the working copy.
-    """
-    takes_args = ['file+']
-    takes_options = ['verbose']
-    
-    def run(self, file_list, verbose=False):
-        b = find_branch(file_list[0])
-        b.remove([b.relpath(f) for f in file_list], verbose=verbose)
-
-
-class cmd_file_id(Command):
-    """Print file_id of a particular file or directory.
-
-    The file_id is assigned when the file is first added and remains the
-    same through all revisions where the file exists, even when it is
-    moved or renamed.
-    """
-    hidden = True
-    takes_args = ['filename']
-    def run(self, filename):
-        b = find_branch(filename)
-        i = b.inventory.path2id(b.relpath(filename))
-        if i == None:
-            raise BzrError("%r is not a versioned file" % filename)
-        else:
-            print i
-
-
-class cmd_file_path(Command):
-    """Print path of file_ids to a file or directory.
-
-    This prints one line for each directory down to the target,
-    starting at the branch root."""
-    hidden = True
-    takes_args = ['filename']
-    def run(self, filename):
-        b = find_branch(filename)
-        inv = b.inventory
-        fid = inv.path2id(b.relpath(filename))
-        if fid == None:
-            raise BzrError("%r is not a versioned file" % filename)
-        for fip in inv.get_idpath(fid):
-            print fip
-
-
-class cmd_revision_history(Command):
-    """Display list of revision ids on this branch."""
-    hidden = True
-    def run(self):
-        for patchid in find_branch('.').revision_history():
-            print patchid
-
-
-class cmd_directories(Command):
-    """Display list of versioned directories in this branch."""
-    def run(self):
-        for name, ie in find_branch('.').read_working_inventory().directories():
-            if name == '':
-                print '.'
-            else:
-                print name
-
-
-class cmd_init(Command):
-    """Make a directory into a versioned branch.
-
-    Use this to create an empty branch, or before importing an
-    existing project.
-
-    Recipe for importing a tree of files:
-        cd ~/project
-        bzr init
-        bzr add -v .
-        bzr status
-        bzr commit -m 'imported project'
-    """
-    def run(self):
-        from bzrlib.branch import Branch
-        Branch('.', init=True)
-
-
-class cmd_diff(Command):
-    """Show differences in working tree.
-    
-    If files are listed, only the changes in those files are listed.
-    Otherwise, all changes for the tree are listed.
-
-    TODO: Allow diff across branches.
-
-    TODO: Option to use external diff command; could be GNU diff, wdiff,
-          or a graphical diff.
-
-    TODO: Python difflib is not exactly the same as unidiff; should
-          either fix it up or prefer to use an external diff.
-
-    TODO: If a directory is given, diff everything under that.
-
-    TODO: Selected-file diff is inefficient and doesn't show you
-          deleted files.
-
-    TODO: This probably handles non-Unix newlines poorly.
-
-    examples:
-        bzr diff
-        bzr diff -r1
-        bzr diff -r1:2
-    """
-    
-    takes_args = ['file*']
-    takes_options = ['revision', 'diff-options']
-    aliases = ['di', 'dif']
-
-    def run(self, revision=None, file_list=None, diff_options=None):
-        from bzrlib.diff import show_diff
-
-        if file_list:
-            b = find_branch(file_list[0])
-            file_list = [b.relpath(f) for f in file_list]
-            if file_list == ['']:
-                # just pointing to top-of-tree
-                file_list = None
-        else:
-            b = find_branch('.')
-
-        if revision is not None:
-            if len(revision) == 1:
-                show_diff(b, revision[0], specific_files=file_list,
-                          external_diff_options=diff_options)
-            elif len(revision) == 2:
-                show_diff(b, revision[0], specific_files=file_list,
-                          external_diff_options=diff_options,
-                          revision2=revision[1])
-            else:
-                raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
-        else:
-            show_diff(b, None, specific_files=file_list,
-                      external_diff_options=diff_options)
-
-        
-
-
-class cmd_deleted(Command):
-    """List files deleted in the working tree.
-
-    TODO: Show files deleted since a previous revision, or between two revisions.
-    """
-    def run(self, show_ids=False):
-        b = find_branch('.')
-        old = b.basis_tree()
-        new = b.working_tree()
-
-        ## TODO: Much more efficient way to do this: read in new
-        ## directories with readdir, rather than stating each one.  Same
-        ## level of effort but possibly much less IO.  (Or possibly not,
-        ## if the directories are very large...)
-
-        for path, ie in old.inventory.iter_entries():
-            if not new.has_id(ie.file_id):
-                if show_ids:
-                    print '%-50s %s' % (path, ie.file_id)
-                else:
-                    print path
-
-
-class cmd_modified(Command):
-    """List files modified in working tree."""
-    hidden = True
-    def run(self):
-        from bzrlib.delta import compare_trees
-
-        b = find_branch('.')
-        td = compare_trees(b.basis_tree(), b.working_tree())
-
-        for path, id, kind in td.modified:
-            print path
-
-
-
-class cmd_added(Command):
-    """List files added in working tree."""
-    hidden = True
-    def run(self):
-        b = find_branch('.')
-        wt = b.working_tree()
-        basis_inv = b.basis_tree().inventory
-        inv = wt.inventory
-        for file_id in inv:
-            if file_id in basis_inv:
-                continue
-            path = inv.id2path(file_id)
-            if not os.access(b.abspath(path), os.F_OK):
-                continue
-            print path
-                
-        
-
-class cmd_root(Command):
-    """Show the tree root directory.
-
-    The root is the nearest enclosing directory with a .bzr control
-    directory."""
-    takes_args = ['filename?']
-    def run(self, filename=None):
-        """Print the branch root."""
-        b = find_branch(filename)
-        print getattr(b, 'base', None) or getattr(b, 'baseurl')
-
-
-class cmd_log(Command):
-    """Show log of this branch.
-
-    To request a range of logs, you can use the command -r begin:end
-    -r revision requests a specific revision, -r :end or -r begin: are
-    also valid.
-
-    --message allows you to give a regular expression, which will be evaluated
-    so that only matching entries will be displayed.
-
-    TODO: Make --revision support uuid: and hash: [future tag:] notation.
-  
-    """
-
-    takes_args = ['filename?']
-    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
-                     'long', 'message', 'short',]
-    
-    def run(self, filename=None, timezone='original',
-            verbose=False,
-            show_ids=False,
-            forward=False,
-            revision=None,
-            message=None,
-            long=False,
-            short=False):
-        from bzrlib.log import log_formatter, show_log
-        import codecs
-
-        direction = (forward and 'forward') or 'reverse'
-        
-        if filename:
-            b = find_branch(filename)
-            fp = b.relpath(filename)
-            if fp:
-                file_id = b.read_working_inventory().path2id(fp)
-            else:
-                file_id = None  # points to branch root
-        else:
-            b = find_branch('.')
-            file_id = None
-
-        if revision is None:
-            rev1 = None
-            rev2 = None
-        elif len(revision) == 1:
-            rev1 = rev2 = b.get_revision_info(revision[0])[0]
-        elif len(revision) == 2:
-            rev1 = b.get_revision_info(revision[0])[0]
-            rev2 = b.get_revision_info(revision[1])[0]
-        else:
-            raise BzrCommandError('bzr log --revision takes one or two values.')
-
-        if rev1 == 0:
-            rev1 = None
-        if rev2 == 0:
-            rev2 = None
-
-        mutter('encoding log as %r' % bzrlib.user_encoding)
-
-        # use 'replace' so that we don't abort if trying to write out
-        # in e.g. the default C locale.
-        outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
-
-        if not short:
-            log_format = 'long'
-        else:
-            log_format = 'short'
-        lf = log_formatter(log_format,
-                           show_ids=show_ids,
-                           to_file=outf,
-                           show_timezone=timezone)
-
-        show_log(b,
-                 lf,
-                 file_id,
-                 verbose=verbose,
-                 direction=direction,
-                 start_revision=rev1,
-                 end_revision=rev2,
-                 search=message)
-
-
-
-class cmd_touching_revisions(Command):
-    """Return revision-ids which affected a particular file.
-
-    A more user-friendly interface is "bzr log FILE"."""
-    hidden = True
-    takes_args = ["filename"]
-    def run(self, filename):
-        b = find_branch(filename)
-        inv = b.read_working_inventory()
-        file_id = inv.path2id(b.relpath(filename))
-        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
-            print "%6d %s" % (revno, what)
-
-
-class cmd_ls(Command):
-    """List files in a tree.
-
-    TODO: Take a revision or remote path and list that tree instead.
-    """
-    hidden = True
-    def run(self, revision=None, verbose=False):
-        b = find_branch('.')
-        if revision == None:
-            tree = b.working_tree()
-        else:
-            tree = b.revision_tree(b.lookup_revision(revision))
-
-        for fp, fc, kind, fid in tree.list_files():
-            if verbose:
-                if kind == 'directory':
-                    kindch = '/'
-                elif kind == 'file':
-                    kindch = ''
-                else:
-                    kindch = '???'
-
-                print '%-8s %s%s' % (fc, fp, kindch)
-            else:
-                print fp
-
-
-
-class cmd_unknowns(Command):
-    """List unknown files."""
-    def run(self):
-        from bzrlib.osutils import quotefn
-        for f in find_branch('.').unknowns():
-            print quotefn(f)
-
-
-
-class cmd_ignore(Command):
-    """Ignore a command or pattern.
-
-    To remove patterns from the ignore list, edit the .bzrignore file.
-
-    If the pattern contains a slash, it is compared to the whole path
-    from the branch root.  Otherwise, it is comapred to only the last
-    component of the path.
-
-    Ignore patterns are case-insensitive on case-insensitive systems.
-
-    Note: wildcards must be quoted from the shell on Unix.
-
-    examples:
-        bzr ignore ./Makefile
-        bzr ignore '*.class'
-    """
-    takes_args = ['name_pattern']
-    
-    def run(self, name_pattern):
-        from bzrlib.atomicfile import AtomicFile
-        import os.path
-
-        b = find_branch('.')
-        ifn = b.abspath('.bzrignore')
-
-        if os.path.exists(ifn):
-            f = open(ifn, 'rt')
-            try:
-                igns = f.read().decode('utf-8')
-            finally:
-                f.close()
-        else:
-            igns = ''
-
-        # TODO: If the file already uses crlf-style termination, maybe
-        # we should use that for the newly added lines?
-
-        if igns and igns[-1] != '\n':
-            igns += '\n'
-        igns += name_pattern + '\n'
-
-        try:
-            f = AtomicFile(ifn, 'wt')
-            f.write(igns.encode('utf-8'))
-            f.commit()
-        finally:
-            f.close()
-
-        inv = b.working_tree().inventory
-        if inv.path2id('.bzrignore'):
-            mutter('.bzrignore is already versioned')
-        else:
-            mutter('need to make new .bzrignore file versioned')
-            b.add(['.bzrignore'])
-
-
-
-class cmd_ignored(Command):
-    """List ignored files and the patterns that matched them.
-
-    See also: bzr ignore"""
-    def run(self):
-        tree = find_branch('.').working_tree()
-        for path, file_class, kind, file_id in tree.list_files():
-            if file_class != 'I':
-                continue
-            ## XXX: Slightly inefficient since this was already calculated
-            pat = tree.is_ignored(path)
-            print '%-50s %s' % (path, pat)
-
-
-class cmd_lookup_revision(Command):
-    """Lookup the revision-id from a revision-number
-
-    example:
-        bzr lookup-revision 33
-    """
-    hidden = True
-    takes_args = ['revno']
-    
-    def run(self, revno):
-        try:
-            revno = int(revno)
-        except ValueError:
-            raise BzrCommandError("not a valid revision-number: %r" % revno)
-
-        print find_branch('.').lookup_revision(revno)
-
-
-class cmd_export(Command):
-    """Export past revision to destination directory.
-
-    If no revision is specified this exports the last committed revision.
-
-    Format may be an "exporter" name, such as tar, tgz, tbz2.  If none is
-    given, try to find the format with the extension. If no extension
-    is found exports to a directory (equivalent to --format=dir).
-
-    Root may be the top directory for tar, tgz and tbz2 formats. If none
-    is given, the top directory will be the root name of the file."""
-    # TODO: list known exporters
-    takes_args = ['dest']
-    takes_options = ['revision', 'format', 'root']
-    def run(self, dest, revision=None, format=None, root=None):
-        import os.path
-        b = find_branch('.')
-        if revision is None:
-            rev_id = b.last_patch()
-        else:
-            if len(revision) != 1:
-                raise BzrError('bzr export --revision takes exactly 1 argument')
-            revno, rev_id = b.get_revision_info(revision[0])
-        t = b.revision_tree(rev_id)
-        root, ext = os.path.splitext(dest)
-        if not format:
-            if ext in (".tar",):
-                format = "tar"
-            elif ext in (".gz", ".tgz"):
-                format = "tgz"
-            elif ext in (".bz2", ".tbz2"):
-                format = "tbz2"
-            else:
-                format = "dir"
-        t.export(dest, format, root)
-
-
-class cmd_cat(Command):
-    """Write a file's text from a previous revision."""
-
-    takes_options = ['revision']
-    takes_args = ['filename']
-
-    def run(self, filename, revision=None):
-        if revision == None:
-            raise BzrCommandError("bzr cat requires a revision number")
-        elif len(revision) != 1:
-            raise BzrCommandError("bzr cat --revision takes exactly one number")
-        b = find_branch('.')
-        b.print_file(b.relpath(filename), revision[0])
-
-
-class cmd_local_time_offset(Command):
-    """Show the offset in seconds from GMT to local time."""
-    hidden = True    
-    def run(self):
-        print bzrlib.osutils.local_time_offset()
-
-
-
-class cmd_commit(Command):
-    """Commit changes into a new revision.
-    
-    If no arguments are given, the entire tree is committed.
-
-    If selected files are specified, only changes to those files are
-    committed.  If a directory is specified then the directory and everything 
-    within it is committed.
-
-    A selected-file commit may fail in some cases where the committed
-    tree would be invalid, such as trying to commit a file in a
-    newly-added directory that is not itself committed.
-
-    TODO: Run hooks on tree to-be-committed, and after commit.
-
-    TODO: Strict commit that fails if there are unknown or deleted files.
-    """
-    takes_args = ['selected*']
-    takes_options = ['message', 'file', 'verbose', 'unchanged']
-    aliases = ['ci', 'checkin']
-
-    # TODO: Give better message for -s, --summary, used by tla people
-    
-    def run(self, message=None, file=None, verbose=True, selected_list=None,
-            unchanged=False):
-        from bzrlib.errors import PointlessCommit
-        from bzrlib.msgeditor import edit_commit_message
-        from bzrlib.status import show_status
-        from cStringIO import StringIO
-
-        b = find_branch('.')
-        if selected_list:
-            selected_list = [b.relpath(s) for s in selected_list]
-            
-        if not message and not file:
-            catcher = StringIO()
-            show_status(b, specific_files=selected_list,
-                        to_file=catcher)
-            message = edit_commit_message(catcher.getvalue())
-            
-            if message is None:
-                raise BzrCommandError("please specify a commit message"
-                                      " with either --message or --file")
-        elif message and file:
-            raise BzrCommandError("please specify either --message or --file")
-        
-        if file:
-            import codecs
-            message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
-
-        try:
-            b.commit(message, verbose=verbose,
-                     specific_files=selected_list,
-                     allow_pointless=unchanged)
-        except PointlessCommit:
-            # FIXME: This should really happen before the file is read in;
-            # perhaps prepare the commit; get the message; then actually commit
-            raise BzrCommandError("no changes to commit",
-                                  ["use --unchanged to commit anyhow"])
-
-
-class cmd_check(Command):
-    """Validate consistency of branch history.
-
-    This command checks various invariants about the branch storage to
-    detect data corruption or bzr bugs.
-
-    If given the --update flag, it will update some optional fields
-    to help ensure data consistency.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        from bzrlib.check import check
-
-        check(find_branch(dir))
-
-
-class cmd_scan_cache(Command):
-    hidden = True
-    def run(self):
-        from bzrlib.hashcache import HashCache
-
-        c = HashCache('.')
-        c.read()
-        c.scan()
-            
-        print '%6d stats' % c.stat_count
-        print '%6d in hashcache' % len(c._cache)
-        print '%6d files removed from cache' % c.removed_count
-        print '%6d hashes updated' % c.update_count
-        print '%6d files changed too recently to cache' % c.danger_count
-
-        if c.needs_write:
-            c.write()
-            
-
-
-class cmd_upgrade(Command):
-    """Upgrade branch storage to current format.
-
-    The check command or bzr developers may sometimes advise you to run
-    this command.
-    """
-    takes_args = ['dir?']
-
-    def run(self, dir='.'):
-        from bzrlib.upgrade import upgrade
-        upgrade(find_branch(dir))
-
-
-
-class cmd_whoami(Command):
-    """Show bzr user id."""
-    takes_options = ['email']
-    
-    def run(self, email=False):
-        try:
-            b = bzrlib.branch.find_branch('.')
-        except:
-            b = None
-        
-        if email:
-            print bzrlib.osutils.user_email(b)
-        else:
-            print bzrlib.osutils.username(b)
-
-
-class cmd_selftest(Command):
-    """Run internal test suite"""
-    hidden = True
-    takes_options = ['verbose', 'pattern']
-    def run(self, verbose=False, pattern=".*"):
-        import bzrlib.ui
-        from bzrlib.selftest import selftest
-        # we don't want progress meters from the tests to go to the
-        # real output; and we don't want log messages cluttering up
-        # the real logs.
-        save_ui = bzrlib.ui.ui_factory
-        bzrlib.trace.info('running tests...')
-        try:
-            bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
-            result = selftest(verbose=verbose, pattern=pattern)
-            if result:
-                bzrlib.trace.info('tests passed')
-            else:
-                bzrlib.trace.info('tests failed')
-            return int(not result)
-        finally:
-            bzrlib.ui.ui_factory = save_ui
-
-
-def show_version():
-    print "bzr (bazaar-ng) %s" % bzrlib.__version__
-    # is bzrlib itself in a branch?
-    bzrrev = bzrlib.get_bzr_revision()
-    if bzrrev:
-        print "  (bzr checkout, revision %d {%s})" % bzrrev
-    print bzrlib.__copyright__
-    print "http://bazaar-ng.org/"
-    print
-    print "bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and"
-    print "you may use, modify and redistribute it under the terms of the GNU"
-    print "General Public License version 2 or later."
-
-
-class cmd_version(Command):
-    """Show version of bzr."""
-    def run(self):
-        show_version()
-
-class cmd_rocks(Command):
-    """Statement of optimism."""
-    hidden = True
-    def run(self):
-        print "it sure does!"
-
-
-class cmd_find_merge_base(Command):
-    """Find and print a base revision for merging two branches.
-
-    TODO: Options to specify revisions on either side, as if
-          merging only part of the history.
-    """
-    takes_args = ['branch', 'other']
-    hidden = True
-    
-    def run(self, branch, other):
-        from bzrlib.revision import common_ancestor, MultipleRevisionSources
-        
-        branch1 = find_branch(branch)
-        branch2 = find_branch(other)
-
-        history_1 = branch1.revision_history()
-        history_2 = branch2.revision_history()
-
-        last1 = branch1.last_patch()
-        last2 = branch2.last_patch()
-
-        source = MultipleRevisionSources(branch1, branch2)
-        
-        base_rev_id = common_ancestor(last1, last2, source)
-
-        print 'merge base is revision %s' % base_rev_id
-        
-        return
-
-        if base_revno is None:
-            raise bzrlib.errors.UnrelatedBranches()
-
-        print ' r%-6d in %s' % (base_revno, branch)
-
-        other_revno = branch2.revision_id_to_revno(base_revid)
-        
-        print ' r%-6d in %s' % (other_revno, other)
-
-
-
-class cmd_merge(Command):
-    """Perform a three-way merge.
-    
-    The branch is the branch you will merge from.  By default, it will
-    merge the latest revision.  If you specify a revision, that
-    revision will be merged.  If you specify two revisions, the first
-    will be used as a BASE, and the second one as OTHER.  Revision
-    numbers are always relative to the specified branch.
-
-    By default bzr will try to merge in all new work from the other
-    branch, automatically determining an appropriate base.  If this
-    fails, you may need to give an explicit base.
-    
-    Examples:
-
-    To merge the latest revision from bzr.dev
-    bzr merge ../bzr.dev
-
-    To merge changes up to and including revision 82 from bzr.dev
-    bzr merge -r 82 ../bzr.dev
-
-    To merge the changes introduced by 82, without previous changes:
-    bzr merge -r 81..82 ../bzr.dev
-    
-    merge refuses to run if there are any uncommitted changes, unless
-    --force is given.
-    """
-    takes_args = ['branch?']
-    takes_options = ['revision', 'force', 'merge-type']
-
-    def run(self, branch='.', revision=None, force=False, 
-            merge_type=None):
-        from bzrlib.merge import merge
-        from bzrlib.merge_core import ApplyMerge3
-        if merge_type is None:
-            merge_type = ApplyMerge3
-
-        if revision is None or len(revision) < 1:
-            base = [None, None]
-            other = [branch, -1]
-        else:
-            if len(revision) == 1:
-                other = [branch, revision[0]]
-                base = [None, None]
-            else:
-                assert len(revision) == 2
-                if None in revision:
-                    raise BzrCommandError(
-                        "Merge doesn't permit that revision specifier.")
-                base = [branch, revision[0]]
-                other = [branch, revision[1]]
-
-        try:
-            merge(other, base, check_clean=(not force), merge_type=merge_type)
-        except bzrlib.errors.AmbiguousBase, e:
-            m = ("sorry, bzr can't determine the right merge base yet\n"
-                 "candidates are:\n  "
-                 + "\n  ".join(e.bases)
-                 + "\n"
-                 "please specify an explicit base with -r,\n"
-                 "and (if you want) report this to the bzr developers\n")
-            log_error(m)
-
-
-class cmd_revert(Command):
-    """Reverse all changes since the last commit.
-
-    Only versioned files are affected.  Specify filenames to revert only 
-    those files.  By default, any files that are changed will be backed up
-    first.  Backup files have a '~' appended to their name.
-    """
-    takes_options = ['revision', 'no-backup']
-    takes_args = ['file*']
-    aliases = ['merge-revert']
-
-    def run(self, revision=None, no_backup=False, file_list=None):
-        from bzrlib.merge import merge
-        from bzrlib.branch import Branch
-        from bzrlib.commands import parse_spec
-
-        if file_list is not None:
-            if len(file_list) == 0:
-                raise BzrCommandError("No files specified")
-        if revision is None:
-            revision = [-1]
-        elif len(revision) != 1:
-            raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
-        merge(('.', revision[0]), parse_spec('.'),
-              check_clean=False,
-              ignore_zero=True,
-              backup_files=not no_backup,
-              file_list=file_list)
-        if not file_list:
-            Branch('.').set_pending_merges([])
-
-
-class cmd_assert_fail(Command):
-    """Test reporting of assertion failures"""
-    hidden = True
-    def run(self):
-        assert False, "always fails"
-
-
-class cmd_help(Command):
-    """Show help on a command or other topic.
-
-    For a list of all available commands, say 'bzr help commands'."""
-    takes_options = ['long']
-    takes_args = ['topic?']
-    aliases = ['?']
-    
-    def run(self, topic=None, long=False):
-        import help
-        if topic is None and long:
-            topic = "commands"
-        help.help(topic)
-
-
-class cmd_shell_complete(Command):
-    """Show appropriate completions for context.
-
-    For a list of all available commands, say 'bzr shell-complete'."""
-    takes_args = ['context?']
-    aliases = ['s-c']
-    hidden = True
-    
-    def run(self, context=None):
-        import shellcomplete
-        shellcomplete.shellcomplete(context)
-
-
-class cmd_missing(Command):
-    """What is missing in this branch relative to other branch.
-    """
-    takes_args = ['remote?']
-    aliases = ['mis', 'miss']
-    # We don't have to add quiet to the list, because 
-    # unknown options are parsed as booleans
-    takes_options = ['verbose', 'quiet']
-
-    def run(self, remote=None, verbose=False, quiet=False):
-        from bzrlib.errors import BzrCommandError
-        from bzrlib.missing import show_missing
-
-        if verbose and quiet:
-            raise BzrCommandError('Cannot pass both quiet and verbose')
-
-        b = find_branch('.')
-        parent = b.get_parent()
-        if remote is None:
-            if parent is None:
-                raise BzrCommandError("No missing location known or specified.")
-            else:
-                if not quiet:
-                    print "Using last location: %s" % parent
-                remote = parent
-        elif parent is None:
-            # We only update x-pull if it did not exist, missing should not change the parent
-            b.controlfile('x-pull', 'wb').write(remote + '\n')
-        br_remote = find_branch(remote)
-
-        return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
-
-
-
-class cmd_plugins(Command):
-    """List plugins"""
-    hidden = True
-    def run(self):
-        import bzrlib.plugin
-        from inspect import getdoc
-        for plugin in bzrlib.plugin.all_plugins:
-            if hasattr(plugin, '__path__'):
-                print plugin.__path__[0]
-            elif hasattr(plugin, '__file__'):
-                print plugin.__file__
-            else:
-                print `plugin`
-                
-            d = getdoc(plugin)
-            if d:
-                print '\t', d.split('\n')[0]
-
-

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-08-27 04:42:41 +0000
+++ bzrlib/changeset.py	2005-08-17 08:32:56 +0000
@@ -626,7 +626,7 @@
                 return None
             return self.path
 
-    def summarize_name(self, reverse=False):
+    def summarize_name(self, changeset, reverse=False):
         """Produce a one-line summary of the filename.  Indicates renames as
         old => new, indicates creation as None => new, indicates deletion as
         old => None.
@@ -663,7 +663,7 @@
         :type reverse: bool
         :rtype: str
         """
-        mutter("Finding new path for %s" % self.summarize_name())
+        mutter("Finding new path for %s" % self.summarize_name(changeset))
         if reverse:
             parent = self.parent
             to_dir = self.dir
@@ -1065,7 +1065,7 @@
     def new_contents_conflict(self, filename, other_contents):
         raise NewContentsConflict(filename)
 
-    def finalize(self):
+    def finalize():
         pass
 
 def apply_changeset(changeset, inventory, dir, conflict_handler=None, 
@@ -1329,7 +1329,7 @@
             yield self.get_entry(file_id, tree)
 
     def get_entry(self, file_id, tree):
-        if not tree.has_or_had_id(file_id):
+        if file_id not in tree:
             return None
         return tree.tree.inventory[file_id]
 
@@ -1339,7 +1339,7 @@
         return entry.parent_id
 
     def get_path(self, file_id, tree):
-        if not tree.has_or_had_id(file_id):
+        if not tree.has_id(file_id):
             return None
         path = tree.id2path(file_id)
         if path == '':
@@ -1397,6 +1397,9 @@
         full_path_b = self.tree_b.readonly_path(id)
         stat_a = self.lstat(full_path_a)
         stat_b = self.lstat(full_path_b)
+        if stat_b is None:
+            cs_entry.new_parent = None
+            cs_entry.new_path = None
         
         cs_entry.metadata_change = self.make_mode_change(stat_a, stat_b)
         cs_entry.contents_change = self.make_contents_change(full_path_a,

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-09-04 02:59:56 +0000
+++ bzrlib/check.py	2005-08-04 22:12:40 +0000
@@ -15,8 +15,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import bzrlib.ui
-from bzrlib.trace import note, warning
 
 def _update_store_entry(obj, obj_id, branch, store_name, store):
     """This is just a meta-function, which handles both revision entries
@@ -75,7 +73,6 @@
     _update_store_entry(inv, inv_id, branch,
             'inventory-store', branch.inventory_store)
 
-
 def check(branch):
     """Run consistency checks on a branch.
 
@@ -84,19 +81,20 @@
     TODO: Check for extra files in the control directory.
     """
     from bzrlib.trace import mutter
-    from bzrlib.errors import BzrCheckError, NoSuchRevision
+    from bzrlib.errors import BzrCheckError
     from bzrlib.osutils import fingerprint_file
+    from bzrlib.progress import ProgressBar
     from bzrlib.inventory import ROOT_ID
     from bzrlib.branch import gen_root_id
 
     branch.lock_read()
 
     try:
+        pb = ProgressBar(show_spinner=True)
         last_rev_id = None
 
         missing_inventory_sha_cnt = 0
         missing_revision_sha_cnt = 0
-        missing_revision_cnt = 0
 
         history = branch.revision_history()
         revno = 0
@@ -106,12 +104,10 @@
         # for all texts checked, text_id -> sha1
         checked_texts = {}
 
-        progress = bzrlib.ui.ui_factory.progress_bar()
-
         for rev_id in history:
             revno += 1
-            progress.update('checking revision', revno, revcount)
-            # mutter('    revision {%s}' % rev_id)
+            pb.update('checking revision', revno, revcount)
+            mutter('    revision {%s}' % rev_id)
             rev = branch.get_revision(rev_id)
             if rev.revision_id != rev_id:
                 raise BzrCheckError('wrong internal revision id in revision {%s}'
@@ -136,15 +132,7 @@
                         missing_revision_sha_cnt += 1
                         continue
                     prid = prr.revision_id
-                    
-                    try:
-                        actual_sha = branch.get_revision_sha1(prid)
-                    except NoSuchRevision:
-                        missing_revision_cnt += 1
-                        mutter("parent {%s} of {%s} not present in store",
-                               prid, rev_id)
-                        continue
-                        
+                    actual_sha = branch.get_revision_sha1(prid)
                     if prr.revision_sha1 != actual_sha:
                         raise BzrCheckError("mismatched revision sha1 for "
                                             "parent {%s} of {%s}: %s vs %s"
@@ -185,7 +173,7 @@
             for file_id in inv:
                 i += 1
                 if i & 31 == 0:
-                    progress.tick()
+                    pb.tick()
 
                 ie = inv[file_id]
 
@@ -214,7 +202,7 @@
                         raise BzrCheckError('directory {%s} has text in revision {%s}'
                                 % (file_id, rev_id))
 
-            progress.tick()
+            pb.tick()
             for path, ie in inv.iter_entries():
                 if path in seen_names:
                     raise BzrCheckError('duplicated path %s '
@@ -226,21 +214,15 @@
     finally:
         branch.unlock()
 
-    progress.clear()
+    pb.clear()
 
-    note('checked %d revisions, %d file texts' % (revcount, len(checked_texts)))
+    print 'checked %d revisions, %d file texts' % (revcount, len(checked_texts))
     
     if missing_inventory_sha_cnt:
-        note('%d revisions are missing inventory_sha1' % missing_inventory_sha_cnt)
+        print '%d revisions are missing inventory_sha1' % missing_inventory_sha_cnt
 
     if missing_revision_sha_cnt:
-        note('%d parent links are missing revision_sha1' % missing_revision_sha_cnt)
-
-    if missing_revision_cnt:
-        note('%d revisions are mentioned but not present' % missing_revision_cnt)
-
-    if missing_revision_cnt:
-        print '%d revisions are mentioned but not present' % missing_revision_cnt
+        print '%d parent links are missing revision_sha1' % missing_revision_sha_cnt
 
     # stub this out for now because the main bzr branch has references
     # to revisions that aren't present in the store -- mbp 20050804
@@ -249,6 +231,6 @@
 #        print '  (use "bzr upgrade" to fix them)'
 
     if mismatch_inv_id:
-        warning('%d revisions have mismatched inventory ids:' % len(mismatch_inv_id))
+        print '%d revisions have mismatched inventory ids:' % len(mismatch_inv_id)
         for rev_id in mismatch_inv_id:
-            warning('  %s', rev_id)
+            print '  ', rev_id

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-09-04 02:59:56 +0000
+++ bzrlib/commands.py	2005-08-22 16:31:16 +0000
@@ -15,29 +15,21 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+# TODO: Split the command framework away from the actual commands.
+
 # TODO: probably should say which arguments are candidates for glob
 # expansion on windows and do that at the command level.
 
-# TODO: Help messages for options.
-
-# TODO: Define arguments by objects, rather than just using names.
-# Those objects can specify the expected type of the argument, which
-# would help with validation and shell completion.
-
-
-
 import sys
 import os
-from warnings import warn
-from inspect import getdoc
 
 import bzrlib
-import bzrlib.trace
 from bzrlib.trace import mutter, note, log_error, warning
 from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError
 from bzrlib.branch import find_branch
 from bzrlib import BZRDIR
 
+
 plugin_cmds = {}
 
 
@@ -51,7 +43,6 @@
         k_unsquished = k
     if not plugin_cmds.has_key(k_unsquished):
         plugin_cmds[k_unsquished] = cmd
-        mutter('registered plugin command %s', k_unsquished)      
     else:
         log_error('Two plugins defined the same command: %r' % k)
         log_error('Not loading the one in %r' % sys.modules[cmd.__module__])
@@ -162,34 +153,21 @@
         msg = "No known merge type %s. Supported types are:\n%s" %\
             (typestring, type_list)
         raise BzrCommandError(msg)
-
-
-def _builtin_commands():
-    import bzrlib.builtins
-    r = {}
-    builtins = bzrlib.builtins.__dict__
-    for name in builtins:
-        if name.startswith("cmd_"):
-            real_name = _unsquish_command_name(name)        
-            r[real_name] = builtins[name]
-    return r
-
-            
-
-def builtin_command_names():
-    """Return list of builtin command names."""
-    return _builtin_commands().keys()
     
 
-def plugin_command_names():
-    return plugin_cmds.keys()
-
 
 def _get_cmd_dict(plugins_override=True):
-    """Return name->class mapping for all commands."""
-    d = _builtin_commands()
+    d = {}
+    for k, v in globals().iteritems():
+        if k.startswith("cmd_"):
+            d[_unsquish_command_name(k)] = v
+    # If we didn't load plugins, the plugin_cmds dict will be empty
     if plugins_override:
         d.update(plugin_cmds)
+    else:
+        d2 = plugin_cmds.copy()
+        d2.update(d)
+        d = d2
     return d
 
     
@@ -199,56 +177,37 @@
         yield k,v
 
 
-def get_cmd_object(cmd_name, plugins_override=True):
+def get_cmd_class(cmd, plugins_override=True):
     """Return the canonical name and command class for a command.
-
-    plugins_override
-        If true, plugin commands can override builtins.
     """
-    from bzrlib.externalcommand import ExternalCommand
-
-    cmd_name = str(cmd_name)            # not unicode
+    cmd = str(cmd)                      # not unicode
 
     # first look up this command under the specified name
     cmds = _get_cmd_dict(plugins_override=plugins_override)
     try:
-        return cmds[cmd_name]()
+        return cmd, cmds[cmd]
     except KeyError:
         pass
 
     # look for any command which claims this as an alias
-    for real_cmd_name, cmd_class in cmds.iteritems():
-        if cmd_name in cmd_class.aliases:
-            return cmd_class()
-
-    cmd_obj = ExternalCommand.find_command(cmd_name)
-    if cmd_obj:
-        return cmd_obj
-
-    raise BzrCommandError("unknown command %r" % cmd_name)
+    for cmdname, cmdclass in cmds.iteritems():
+        if cmd in cmdclass.aliases:
+            return cmdname, cmdclass
+
+    cmdclass = ExternalCommand.find_command(cmd)
+    if cmdclass:
+        return cmd, cmdclass
+
+    raise BzrCommandError("unknown command %r" % cmd)
 
 
 class Command(object):
     """Base class for commands.
 
-    Commands are the heart of the command-line bzr interface.
-
-    The command object mostly handles the mapping of command-line
-    parameters into one or more bzrlib operations, and of the results
-    into textual output.
-
-    Commands normally don't have any state.  All their arguments are
-    passed in to the run method.  (Subclasses may take a different
-    policy if the behaviour of the instance needs to depend on e.g. a
-    shell plugin and not just its Python class.)
-
     The docstring for an actual command should give a single-line
     summary, then a complete description of the command.  A grammar
     description will be inserted.
 
-    aliases
-        Other accepted names for this command.
-
     takes_args
         List of argument forms, marked with whether they are optional,
         repeated, etc.
@@ -257,8 +216,7 @@
         List of options that may be given for this command.
 
     hidden
-        If true, this command isn't advertised.  This is typically
-        for commands intended for expert users.
+        If true, this command isn't advertised.
     """
     aliases = []
     
@@ -267,62 +225,1206 @@
 
     hidden = False
     
-    def __init__(self):
-        """Construct an instance of this command."""
+    def __init__(self, options, arguments):
+        """Construct and run the command.
+
+        Sets self.status to the return value of run()."""
+        assert isinstance(options, dict)
+        assert isinstance(arguments, dict)
+        cmdargs = options.copy()
+        cmdargs.update(arguments)
         if self.__doc__ == Command.__doc__:
+            from warnings import warn
             warn("No help message set for %r" % self)
-
-
-    def run_argv(self, argv):
-        """Parse command line and run."""
-        args, opts = parse_args(argv)
-
-        if 'help' in opts:  # e.g. bzr add --help
-            from bzrlib.help import help_on_command
-            help_on_command(self.name())
-            return 0
-
-        # check options are reasonable
-        allowed = self.takes_options
-        for oname in opts:
-            if oname not in allowed:
-                raise BzrCommandError("option '--%s' is not allowed for command %r"
-                                      % (oname, self.name()))
-
-        # mix arguments and options into one dictionary
-        cmdargs = _match_argform(self.name(), self.takes_args, args)
-        cmdopts = {}
-        for k, v in opts.items():
-            cmdopts[k.replace('-', '_')] = v
-
-        all_cmd_args = cmdargs.copy()
-        all_cmd_args.update(cmdopts)
-
-        return self.run(**all_cmd_args)
+        self.status = self.run(**cmdargs)
+        if self.status is None:
+            self.status = 0
 
     
     def run(self):
-        """Actually run the command.
+        """Override this in sub-classes.
 
         This is invoked with the options and arguments bound to
         keyword parameters.
 
-        Return 0 or None if the command was successful, or a non-zero
-        shell error code if not.  It's OK for this method to allow
-        an exception to raise up.
+        Return 0 or None if the command was successful, or a shell
+        error code if not.
         """
-        raise NotImplementedError()
-
-
-    def help(self):
-        """Return help message for this class."""
-        if self.__doc__ is Command.__doc__:
-            return None
-        return getdoc(self)
-
-    def name(self):
-        return _unsquish_command_name(self.__class__.__name__)
-
+        return 0
+
+
+class ExternalCommand(Command):
+    """Class to wrap external commands.
+
+    We cheat a little here, when get_cmd_class() calls us we actually
+    give it back an object we construct that has the appropriate path,
+    help, options etc for the specified command.
+
+    When run_bzr() tries to instantiate that 'class' it gets caught by
+    the __call__ method, which we override to call the Command.__init__
+    method. That then calls our run method which is pretty straight
+    forward.
+
+    The only wrinkle is that we have to map bzr's dictionary of options
+    and arguments back into command line options and arguments for the
+    script.
+    """
+
+    def find_command(cls, cmd):
+        import os.path
+        bzrpath = os.environ.get('BZRPATH', '')
+
+        for dir in bzrpath.split(os.pathsep):
+            path = os.path.join(dir, cmd)
+            if os.path.isfile(path):
+                return ExternalCommand(path)
+
+        return None
+
+    find_command = classmethod(find_command)
+
+    def __init__(self, path):
+        self.path = path
+
+        pipe = os.popen('%s --bzr-usage' % path, 'r')
+        self.takes_options = pipe.readline().split()
+
+        for opt in self.takes_options:
+            if not opt in OPTIONS:
+                raise BzrError("Unknown option '%s' returned by external command %s"
+                               % (opt, path))
+
+        # TODO: Is there any way to check takes_args is valid here?
+        self.takes_args = pipe.readline().split()
+
+        if pipe.close() is not None:
+            raise BzrError("Failed funning '%s --bzr-usage'" % path)
+
+        pipe = os.popen('%s --bzr-help' % path, 'r')
+        self.__doc__ = pipe.read()
+        if pipe.close() is not None:
+            raise BzrError("Failed funning '%s --bzr-help'" % path)
+
+    def __call__(self, options, arguments):
+        Command.__init__(self, options, arguments)
+        return self
+
+    def run(self, **kargs):
+        opts = []
+        args = []
+
+        keys = kargs.keys()
+        keys.sort()
+        for name in keys:
+            optname = name.replace('_','-')
+            value = kargs[name]
+            if OPTIONS.has_key(optname):
+                # it's an option
+                opts.append('--%s' % optname)
+                if value is not None and value is not True:
+                    opts.append(str(value))
+            else:
+                # it's an arg, or arg list
+                if type(value) is not list:
+                    value = [value]
+                for v in value:
+                    if v is not None:
+                        args.append(str(v))
+
+        self.status = os.spawnv(os.P_WAIT, self.path, [self.path] + opts + args)
+        return self.status
+
+
+class cmd_status(Command):
+    """Display status summary.
+
+    This reports on versioned and unknown files, reporting them
+    grouped by state.  Possible states are:
+
+    added
+        Versioned in the working copy but not in the previous revision.
+
+    removed
+        Versioned in the previous revision but removed or deleted
+        in the working copy.
+
+    renamed
+        Path of this file changed from the previous revision;
+        the text may also have changed.  This includes files whose
+        parent directory was renamed.
+
+    modified
+        Text has changed since the previous revision.
+
+    unchanged
+        Nothing about this file has changed since the previous revision.
+        Only shown with --all.
+
+    unknown
+        Not versioned and not matching an ignore pattern.
+
+    To see ignored files use 'bzr ignored'.  For details in the
+    changes to file texts, use 'bzr diff'.
+
+    If no arguments are specified, the status of the entire working
+    directory is shown.  Otherwise, only the status of the specified
+    files or directories is reported.  If a directory is given, status
+    is reported for everything inside that directory.
+
+    If a revision is specified, the changes since that revision are shown.
+    """
+    takes_args = ['file*']
+    takes_options = ['all', 'show-ids', 'revision']
+    aliases = ['st', 'stat']
+    
+    def run(self, all=False, show_ids=False, file_list=None):
+        if file_list:
+            b = find_branch(file_list[0])
+            file_list = [b.relpath(x) for x in file_list]
+            # special case: only one path was given and it's the root
+            # of the branch
+            if file_list == ['']:
+                file_list = None
+        else:
+            b = find_branch('.')
+            
+        from bzrlib.status import show_status
+        show_status(b, show_unchanged=all, show_ids=show_ids,
+                    specific_files=file_list)
+
+
+class cmd_cat_revision(Command):
+    """Write out metadata for a revision."""
+
+    hidden = True
+    takes_args = ['revision_id']
+    
+    def run(self, revision_id):
+        from bzrlib.xml import pack_xml
+        pack_xml(find_branch('.').get_revision(revision_id), sys.stdout)
+
+
+class cmd_revno(Command):
+    """Show current revision number.
+
+    This is equal to the number of revisions on this branch."""
+    def run(self):
+        print find_branch('.').revno()
+
+class cmd_revision_info(Command):
+    """Show revision number and revision id for a given revision identifier.
+    """
+    hidden = True
+    takes_args = ['revision_info*']
+    takes_options = ['revision']
+    def run(self, revision=None, revision_info_list=None):
+        from bzrlib.branch import find_branch
+
+        revs = []
+        if revision is not None:
+            revs.extend(revision)
+        if revision_info_list is not None:
+            revs.extend(revision_info_list)
+        if len(revs) == 0:
+            raise BzrCommandError('You must supply a revision identifier')
+
+        b = find_branch('.')
+
+        for rev in revs:
+            print '%4d %s' % b.get_revision_info(rev)
+
+    
+class cmd_add(Command):
+    """Add specified files or directories.
+
+    In non-recursive mode, all the named items are added, regardless
+    of whether they were previously ignored.  A warning is given if
+    any of the named files are already versioned.
+
+    In recursive mode (the default), files are treated the same way
+    but the behaviour for directories is different.  Directories that
+    are already versioned do not give a warning.  All directories,
+    whether already versioned or not, are searched for files or
+    subdirectories that are neither versioned or ignored, and these
+    are added.  This search proceeds recursively into versioned
+    directories.  If no names are given '.' is assumed.
+
+    Therefore simply saying 'bzr add' will version all files that
+    are currently unknown.
+
+    TODO: Perhaps adding a file whose directly is not versioned should
+    recursively add that parent, rather than giving an error?
+    """
+    takes_args = ['file*']
+    takes_options = ['verbose', 'no-recurse']
+    
+    def run(self, file_list, verbose=False, no_recurse=False):
+        from bzrlib.add import smart_add
+        smart_add(file_list, verbose, not no_recurse)
+
+
+
+class cmd_mkdir(Command):
+    """Create a new versioned directory.
+
+    This is equivalent to creating the directory and then adding it.
+    """
+    takes_args = ['dir+']
+
+    def run(self, dir_list):
+        b = None
+        
+        for d in dir_list:
+            os.mkdir(d)
+            if not b:
+                b = find_branch(d)
+            b.add([d], verbose=True)
+
+
+class cmd_relpath(Command):
+    """Show path of a file relative to root"""
+    takes_args = ['filename']
+    hidden = True
+    
+    def run(self, filename):
+        print find_branch(filename).relpath(filename)
+
+
+
+class cmd_inventory(Command):
+    """Show inventory of the current working copy or a revision."""
+    takes_options = ['revision', 'show-ids']
+    
+    def run(self, revision=None, show_ids=False):
+        b = find_branch('.')
+        if revision == None:
+            inv = b.read_working_inventory()
+        else:
+            if len(revision) > 1:
+                raise BzrCommandError('bzr inventory --revision takes'
+                    ' exactly one revision identifier')
+            inv = b.get_revision_inventory(b.lookup_revision(revision[0]))
+
+        for path, entry in inv.entries():
+            if show_ids:
+                print '%-50s %s' % (path, entry.file_id)
+            else:
+                print path
+
+
+class cmd_move(Command):
+    """Move files to a different directory.
+
+    examples:
+        bzr move *.txt doc
+
+    The destination must be a versioned directory in the same branch.
+    """
+    takes_args = ['source$', 'dest']
+    def run(self, source_list, dest):
+        b = find_branch('.')
+
+        # TODO: glob expansion on windows?
+        b.move([b.relpath(s) for s in source_list], b.relpath(dest))
+
+
+class cmd_rename(Command):
+    """Change the name of an entry.
+
+    examples:
+      bzr rename frob.c frobber.c
+      bzr rename src/frob.c lib/frob.c
+
+    It is an error if the destination name exists.
+
+    See also the 'move' command, which moves files into a different
+    directory without changing their name.
+
+    TODO: Some way to rename multiple files without invoking bzr for each
+    one?"""
+    takes_args = ['from_name', 'to_name']
+    
+    def run(self, from_name, to_name):
+        b = find_branch('.')
+        b.rename_one(b.relpath(from_name), b.relpath(to_name))
+
+
+
+class cmd_mv(Command):
+    """Move or rename a file.
+
+    usage:
+        bzr mv OLDNAME NEWNAME
+        bzr mv SOURCE... DESTINATION
+
+    If the last argument is a versioned directory, all the other names
+    are moved into it.  Otherwise, there must be exactly two arguments
+    and the file is changed to a new name, which must not already exist.
+
+    Files cannot be moved between branches.
+    """
+    takes_args = ['names*']
+    def run(self, names_list):
+        if len(names_list) < 2:
+            raise BzrCommandError("missing file argument")
+        b = find_branch(names_list[0])
+
+        rel_names = [b.relpath(x) for x in names_list]
+        
+        if os.path.isdir(names_list[-1]):
+            # move into existing directory
+            b.move(rel_names[:-1], rel_names[-1])
+        else:
+            if len(names_list) != 2:
+                raise BzrCommandError('to mv multiple files the destination '
+                                      'must be a versioned directory')
+            b.move(rel_names[0], rel_names[1])
+            
+    
+
+
+class cmd_pull(Command):
+    """Pull any changes from another branch into the current one.
+
+    If the location is omitted, the last-used location will be used.
+    Both the revision history and the working directory will be
+    updated.
+
+    This command only works on branches that have not diverged.  Branches are
+    considered diverged if both branches have had commits without first
+    pulling from the other.
+
+    If branches have diverged, you can use 'bzr merge' to pull the text changes
+    from one into the other.
+    """
+    takes_args = ['location?']
+
+    def run(self, location=None):
+        from bzrlib.merge import merge
+        import tempfile
+        from shutil import rmtree
+        import errno
+        
+        br_to = find_branch('.')
+        stored_loc = None
+        try:
+            stored_loc = br_to.controlfile("x-pull", "rb").read().rstrip('\n')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+        if location is None:
+            if stored_loc is None:
+                raise BzrCommandError("No pull location known or specified.")
+            else:
+                print "Using last location: %s" % stored_loc
+                location = stored_loc
+        cache_root = tempfile.mkdtemp()
+        from bzrlib.branch import DivergedBranches
+        br_from = find_branch(location)
+        location = pull_loc(br_from)
+        old_revno = br_to.revno()
+        try:
+            from branch import find_cached_branch, DivergedBranches
+            br_from = find_cached_branch(location, cache_root)
+            location = pull_loc(br_from)
+            old_revno = br_to.revno()
+            try:
+                br_to.update_revisions(br_from)
+            except DivergedBranches:
+                raise BzrCommandError("These branches have diverged."
+                    "  Try merge.")
+                
+            merge(('.', -1), ('.', old_revno), check_clean=False)
+            if location != stored_loc:
+                br_to.controlfile("x-pull", "wb").write(location + "\n")
+        finally:
+            rmtree(cache_root)
+
+
+
+class cmd_branch(Command):
+    """Create a new copy of a branch.
+
+    If the TO_LOCATION is omitted, the last component of the FROM_LOCATION will
+    be used.  In other words, "branch ../foo/bar" will attempt to create ./bar.
+
+    To retrieve the branch as of a particular revision, supply the --revision
+    parameter, as in "branch foo/bar -r 5".
+    """
+    takes_args = ['from_location', 'to_location?']
+    takes_options = ['revision']
+    aliases = ['get', 'clone']
+
+    def run(self, from_location, to_location=None, revision=None):
+        import errno
+        from bzrlib.merge import merge
+        from bzrlib.branch import DivergedBranches, \
+             find_cached_branch, Branch
+        from shutil import rmtree
+        from meta_store import CachedStore
+        import tempfile
+        cache_root = tempfile.mkdtemp()
+
+        if revision is None:
+            revision = [None]
+        elif len(revision) > 1:
+            raise BzrCommandError('bzr branch --revision takes exactly 1 revision value')
+
+        try:
+            try:
+                br_from = find_cached_branch(from_location, cache_root)
+            except OSError, e:
+                if e.errno == errno.ENOENT:
+                    raise BzrCommandError('Source location "%s" does not'
+                                          ' exist.' % to_location)
+                else:
+                    raise
+
+            if to_location is None:
+                to_location = os.path.basename(from_location.rstrip("/\\"))
+
+            try:
+                os.mkdir(to_location)
+            except OSError, e:
+                if e.errno == errno.EEXIST:
+                    raise BzrCommandError('Target directory "%s" already'
+                                          ' exists.' % to_location)
+                if e.errno == errno.ENOENT:
+                    raise BzrCommandError('Parent of "%s" does not exist.' %
+                                          to_location)
+                else:
+                    raise
+            br_to = Branch(to_location, init=True)
+
+            br_to.set_root_id(br_from.get_root_id())
+
+            if revision:
+                if revision[0] is None:
+                    revno = br_from.revno()
+                else:
+                    revno, rev_id = br_from.get_revision_info(revision[0])
+                try:
+                    br_to.update_revisions(br_from, stop_revision=revno)
+                except bzrlib.errors.NoSuchRevision:
+                    rmtree(to_location)
+                    msg = "The branch %s has no revision %d." % (from_location,
+                                                                 revno)
+                    raise BzrCommandError(msg)
+            
+            merge((to_location, -1), (to_location, 0), this_dir=to_location,
+                  check_clean=False, ignore_zero=True)
+            from_location = pull_loc(br_from)
+            br_to.controlfile("x-pull", "wb").write(from_location + "\n")
+        finally:
+            rmtree(cache_root)
+
+
+def pull_loc(branch):
+    # TODO: Should perhaps just make attribute be 'base' in
+    # RemoteBranch and Branch?
+    if hasattr(branch, "baseurl"):
+        return branch.baseurl
+    else:
+        return branch.base
+
+
+
+class cmd_renames(Command):
+    """Show list of renamed files.
+
+    TODO: Option to show renames between two historical versions.
+
+    TODO: Only show renames under dir, rather than in the whole branch.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        b = find_branch(dir)
+        old_inv = b.basis_tree().inventory
+        new_inv = b.read_working_inventory()
+
+        renames = list(bzrlib.tree.find_renames(old_inv, new_inv))
+        renames.sort()
+        for old_name, new_name in renames:
+            print "%s => %s" % (old_name, new_name)        
+
+
+class cmd_info(Command):
+    """Show statistical information about a branch."""
+    takes_args = ['branch?']
+    
+    def run(self, branch=None):
+        import info
+
+        b = find_branch(branch)
+        info.show_info(b)
+
+
+class cmd_remove(Command):
+    """Make a file unversioned.
+
+    This makes bzr stop tracking changes to a versioned file.  It does
+    not delete the working copy.
+    """
+    takes_args = ['file+']
+    takes_options = ['verbose']
+    
+    def run(self, file_list, verbose=False):
+        b = find_branch(file_list[0])
+        b.remove([b.relpath(f) for f in file_list], verbose=verbose)
+
+
+class cmd_file_id(Command):
+    """Print file_id of a particular file or directory.
+
+    The file_id is assigned when the file is first added and remains the
+    same through all revisions where the file exists, even when it is
+    moved or renamed.
+    """
+    hidden = True
+    takes_args = ['filename']
+    def run(self, filename):
+        b = find_branch(filename)
+        i = b.inventory.path2id(b.relpath(filename))
+        if i == None:
+            raise BzrError("%r is not a versioned file" % filename)
+        else:
+            print i
+
+
+class cmd_file_path(Command):
+    """Print path of file_ids to a file or directory.
+
+    This prints one line for each directory down to the target,
+    starting at the branch root."""
+    hidden = True
+    takes_args = ['filename']
+    def run(self, filename):
+        b = find_branch(filename)
+        inv = b.inventory
+        fid = inv.path2id(b.relpath(filename))
+        if fid == None:
+            raise BzrError("%r is not a versioned file" % filename)
+        for fip in inv.get_idpath(fid):
+            print fip
+
+
+class cmd_revision_history(Command):
+    """Display list of revision ids on this branch."""
+    hidden = True
+    def run(self):
+        for patchid in find_branch('.').revision_history():
+            print patchid
+
+
+class cmd_directories(Command):
+    """Display list of versioned directories in this branch."""
+    def run(self):
+        for name, ie in find_branch('.').read_working_inventory().directories():
+            if name == '':
+                print '.'
+            else:
+                print name
+
+
+class cmd_init(Command):
+    """Make a directory into a versioned branch.
+
+    Use this to create an empty branch, or before importing an
+    existing project.
+
+    Recipe for importing a tree of files:
+        cd ~/project
+        bzr init
+        bzr add -v .
+        bzr status
+        bzr commit -m 'imported project'
+    """
+    def run(self):
+        from bzrlib.branch import Branch
+        Branch('.', init=True)
+
+
+class cmd_diff(Command):
+    """Show differences in working tree.
+    
+    If files are listed, only the changes in those files are listed.
+    Otherwise, all changes for the tree are listed.
+
+    TODO: Allow diff across branches.
+
+    TODO: Option to use external diff command; could be GNU diff, wdiff,
+          or a graphical diff.
+
+    TODO: Python difflib is not exactly the same as unidiff; should
+          either fix it up or prefer to use an external diff.
+
+    TODO: If a directory is given, diff everything under that.
+
+    TODO: Selected-file diff is inefficient and doesn't show you
+          deleted files.
+
+    TODO: This probably handles non-Unix newlines poorly.
+
+    examples:
+        bzr diff
+        bzr diff -r1
+        bzr diff -r1:2
+    """
+    
+    takes_args = ['file*']
+    takes_options = ['revision', 'diff-options']
+    aliases = ['di', 'dif']
+
+    def run(self, revision=None, file_list=None, diff_options=None):
+        from bzrlib.diff import show_diff
+
+        if file_list:
+            b = find_branch(file_list[0])
+            file_list = [b.relpath(f) for f in file_list]
+            if file_list == ['']:
+                # just pointing to top-of-tree
+                file_list = None
+        else:
+            b = find_branch('.')
+
+        if revision is not None:
+            if len(revision) == 1:
+                show_diff(b, revision[0], specific_files=file_list,
+                          external_diff_options=diff_options)
+            elif len(revision) == 2:
+                show_diff(b, revision[0], specific_files=file_list,
+                          external_diff_options=diff_options,
+                          revision2=revision[1])
+            else:
+                raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
+        else:
+            show_diff(b, None, specific_files=file_list,
+                      external_diff_options=diff_options)
+
+        
+
+
+class cmd_deleted(Command):
+    """List files deleted in the working tree.
+
+    TODO: Show files deleted since a previous revision, or between two revisions.
+    """
+    def run(self, show_ids=False):
+        b = find_branch('.')
+        old = b.basis_tree()
+        new = b.working_tree()
+
+        ## TODO: Much more efficient way to do this: read in new
+        ## directories with readdir, rather than stating each one.  Same
+        ## level of effort but possibly much less IO.  (Or possibly not,
+        ## if the directories are very large...)
+
+        for path, ie in old.inventory.iter_entries():
+            if not new.has_id(ie.file_id):
+                if show_ids:
+                    print '%-50s %s' % (path, ie.file_id)
+                else:
+                    print path
+
+
+class cmd_modified(Command):
+    """List files modified in working tree."""
+    hidden = True
+    def run(self):
+        from bzrlib.delta import compare_trees
+
+        b = find_branch('.')
+        td = compare_trees(b.basis_tree(), b.working_tree())
+
+        for path, id, kind in td.modified:
+            print path
+
+
+
+class cmd_added(Command):
+    """List files added in working tree."""
+    hidden = True
+    def run(self):
+        b = find_branch('.')
+        wt = b.working_tree()
+        basis_inv = b.basis_tree().inventory
+        inv = wt.inventory
+        for file_id in inv:
+            if file_id in basis_inv:
+                continue
+            path = inv.id2path(file_id)
+            if not os.access(b.abspath(path), os.F_OK):
+                continue
+            print path
+                
+        
+
+class cmd_root(Command):
+    """Show the tree root directory.
+
+    The root is the nearest enclosing directory with a .bzr control
+    directory."""
+    takes_args = ['filename?']
+    def run(self, filename=None):
+        """Print the branch root."""
+        b = find_branch(filename)
+        print getattr(b, 'base', None) or getattr(b, 'baseurl')
+
+
+class cmd_log(Command):
+    """Show log of this branch.
+
+    To request a range of logs, you can use the command -r begin:end
+    -r revision requests a specific revision, -r :end or -r begin: are
+    also valid.
+
+    --message allows you to give a regular expression, which will be evaluated
+    so that only matching entries will be displayed.
+
+    TODO: Make --revision support uuid: and hash: [future tag:] notation.
+  
+    """
+
+    takes_args = ['filename?']
+    takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
+                     'long', 'message', 'short',]
+    
+    def run(self, filename=None, timezone='original',
+            verbose=False,
+            show_ids=False,
+            forward=False,
+            revision=None,
+            message=None,
+            long=False,
+            short=False):
+        from bzrlib.branch import find_branch
+        from bzrlib.log import log_formatter, show_log
+        import codecs
+
+        direction = (forward and 'forward') or 'reverse'
+        
+        if filename:
+            b = find_branch(filename)
+            fp = b.relpath(filename)
+            if fp:
+                file_id = b.read_working_inventory().path2id(fp)
+            else:
+                file_id = None  # points to branch root
+        else:
+            b = find_branch('.')
+            file_id = None
+
+        if revision is None:
+            rev1 = None
+            rev2 = None
+        elif len(revision) == 1:
+            rev1 = rev2 = b.get_revision_info(revision[0])[0]
+        elif len(revision) == 2:
+            rev1 = b.get_revision_info(revision[0])[0]
+            rev2 = b.get_revision_info(revision[1])[0]
+        else:
+            raise BzrCommandError('bzr log --revision takes one or two values.')
+
+        if rev1 == 0:
+            rev1 = None
+        if rev2 == 0:
+            rev2 = None
+
+        mutter('encoding log as %r' % bzrlib.user_encoding)
+
+        # use 'replace' so that we don't abort if trying to write out
+        # in e.g. the default C locale.
+        outf = codecs.getwriter(bzrlib.user_encoding)(sys.stdout, errors='replace')
+
+        if not short:
+            log_format = 'long'
+        else:
+            log_format = 'short'
+        lf = log_formatter(log_format,
+                           show_ids=show_ids,
+                           to_file=outf,
+                           show_timezone=timezone)
+
+        show_log(b,
+                 lf,
+                 file_id,
+                 verbose=verbose,
+                 direction=direction,
+                 start_revision=rev1,
+                 end_revision=rev2,
+                 search=message)
+
+
+
+class cmd_touching_revisions(Command):
+    """Return revision-ids which affected a particular file.
+
+    A more user-friendly interface is "bzr log FILE"."""
+    hidden = True
+    takes_args = ["filename"]
+    def run(self, filename):
+        b = find_branch(filename)
+        inv = b.read_working_inventory()
+        file_id = inv.path2id(b.relpath(filename))
+        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
+            print "%6d %s" % (revno, what)
+
+
+class cmd_ls(Command):
+    """List files in a tree.
+
+    TODO: Take a revision or remote path and list that tree instead.
+    """
+    hidden = True
+    def run(self, revision=None, verbose=False):
+        b = find_branch('.')
+        if revision == None:
+            tree = b.working_tree()
+        else:
+            tree = b.revision_tree(b.lookup_revision(revision))
+
+        for fp, fc, kind, fid in tree.list_files():
+            if verbose:
+                if kind == 'directory':
+                    kindch = '/'
+                elif kind == 'file':
+                    kindch = ''
+                else:
+                    kindch = '???'
+
+                print '%-8s %s%s' % (fc, fp, kindch)
+            else:
+                print fp
+
+
+
+class cmd_unknowns(Command):
+    """List unknown files."""
+    def run(self):
+        from bzrlib.osutils import quotefn
+        for f in find_branch('.').unknowns():
+            print quotefn(f)
+
+
+
+class cmd_ignore(Command):
+    """Ignore a command or pattern.
+
+    To remove patterns from the ignore list, edit the .bzrignore file.
+
+    If the pattern contains a slash, it is compared to the whole path
+    from the branch root.  Otherwise, it is comapred to only the last
+    component of the path.
+
+    Ignore patterns are case-insensitive on case-insensitive systems.
+
+    Note: wildcards must be quoted from the shell on Unix.
+
+    examples:
+        bzr ignore ./Makefile
+        bzr ignore '*.class'
+    """
+    takes_args = ['name_pattern']
+    
+    def run(self, name_pattern):
+        from bzrlib.atomicfile import AtomicFile
+        import os.path
+
+        b = find_branch('.')
+        ifn = b.abspath('.bzrignore')
+
+        if os.path.exists(ifn):
+            f = open(ifn, 'rt')
+            try:
+                igns = f.read().decode('utf-8')
+            finally:
+                f.close()
+        else:
+            igns = ''
+
+        # TODO: If the file already uses crlf-style termination, maybe
+        # we should use that for the newly added lines?
+
+        if igns and igns[-1] != '\n':
+            igns += '\n'
+        igns += name_pattern + '\n'
+
+        try:
+            f = AtomicFile(ifn, 'wt')
+            f.write(igns.encode('utf-8'))
+            f.commit()
+        finally:
+            f.close()
+
+        inv = b.working_tree().inventory
+        if inv.path2id('.bzrignore'):
+            mutter('.bzrignore is already versioned')
+        else:
+            mutter('need to make new .bzrignore file versioned')
+            b.add(['.bzrignore'])
+
+
+
+class cmd_ignored(Command):
+    """List ignored files and the patterns that matched them.
+
+    See also: bzr ignore"""
+    def run(self):
+        tree = find_branch('.').working_tree()
+        for path, file_class, kind, file_id in tree.list_files():
+            if file_class != 'I':
+                continue
+            ## XXX: Slightly inefficient since this was already calculated
+            pat = tree.is_ignored(path)
+            print '%-50s %s' % (path, pat)
+
+
+class cmd_lookup_revision(Command):
+    """Lookup the revision-id from a revision-number
+
+    example:
+        bzr lookup-revision 33
+    """
+    hidden = True
+    takes_args = ['revno']
+    
+    def run(self, revno):
+        try:
+            revno = int(revno)
+        except ValueError:
+            raise BzrCommandError("not a valid revision-number: %r" % revno)
+
+        print find_branch('.').lookup_revision(revno)
+
+
+class cmd_export(Command):
+    """Export past revision to destination directory.
+
+    If no revision is specified this exports the last committed revision.
+
+    Format may be an "exporter" name, such as tar, tgz, tbz2.  If none is
+    given, try to find the format with the extension. If no extension
+    is found exports to a directory (equivalent to --format=dir).
+
+    Root may be the top directory for tar, tgz and tbz2 formats. If none
+    is given, the top directory will be the root name of the file."""
+    # TODO: list known exporters
+    takes_args = ['dest']
+    takes_options = ['revision', 'format', 'root']
+    def run(self, dest, revision=None, format=None, root=None):
+        import os.path
+        b = find_branch('.')
+        if revision is None:
+            rev_id = b.last_patch()
+        else:
+            if len(revision) != 1:
+                raise BzrError('bzr export --revision takes exactly 1 argument')
+            revno, rev_id = b.get_revision_info(revision[0])
+        t = b.revision_tree(rev_id)
+        root, ext = os.path.splitext(dest)
+        if not format:
+            if ext in (".tar",):
+                format = "tar"
+            elif ext in (".gz", ".tgz"):
+                format = "tgz"
+            elif ext in (".bz2", ".tbz2"):
+                format = "tbz2"
+            else:
+                format = "dir"
+        t.export(dest, format, root)
+
+
+class cmd_cat(Command):
+    """Write a file's text from a previous revision."""
+
+    takes_options = ['revision']
+    takes_args = ['filename']
+
+    def run(self, filename, revision=None):
+        if revision == None:
+            raise BzrCommandError("bzr cat requires a revision number")
+        elif len(revision) != 1:
+            raise BzrCommandError("bzr cat --revision takes exactly one number")
+        b = find_branch('.')
+        b.print_file(b.relpath(filename), revision[0])
+
+
+class cmd_local_time_offset(Command):
+    """Show the offset in seconds from GMT to local time."""
+    hidden = True    
+    def run(self):
+        print bzrlib.osutils.local_time_offset()
+
+
+
+class cmd_commit(Command):
+    """Commit changes into a new revision.
+    
+    If no arguments are given, the entire tree is committed.
+
+    If selected files are specified, only changes to those files are
+    committed.  If a directory is specified then the directory and everything 
+    within it is committed.
+
+    A selected-file commit may fail in some cases where the committed
+    tree would be invalid, such as trying to commit a file in a
+    newly-added directory that is not itself committed.
+
+    TODO: Run hooks on tree to-be-committed, and after commit.
+
+    TODO: Strict commit that fails if there are unknown or deleted files.
+    """
+    takes_args = ['selected*']
+    takes_options = ['message', 'file', 'verbose', 'unchanged']
+    aliases = ['ci', 'checkin']
+
+    # TODO: Give better message for -s, --summary, used by tla people
+    
+    def run(self, message=None, file=None, verbose=True, selected_list=None,
+            unchanged=False):
+        from bzrlib.errors import PointlessCommit
+        from bzrlib.osutils import get_text_message
+
+        ## Warning: shadows builtin file()
+        if not message and not file:
+            # FIXME: Ugly; change status code to send to a provided function?
+            
+            import cStringIO
+            stdout = sys.stdout
+            catcher = cStringIO.StringIO()
+            sys.stdout = catcher
+            cmd_status({"file_list":selected_list}, {})
+            info = catcher.getvalue()
+            sys.stdout = stdout
+            message = get_text_message(info)
+            
+            if message is None:
+                raise BzrCommandError("please specify a commit message",
+                                      ["use either --message or --file"])
+        elif message and file:
+            raise BzrCommandError("please specify either --message or --file")
+        
+        if file:
+            import codecs
+            message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
+
+        b = find_branch('.')
+        if selected_list:
+            selected_list = [b.relpath(s) for s in selected_list]
+            
+        try:
+            b.commit(message, verbose=verbose,
+                     specific_files=selected_list,
+                     allow_pointless=unchanged)
+        except PointlessCommit:
+            # FIXME: This should really happen before the file is read in;
+            # perhaps prepare the commit; get the message; then actually commit
+            raise BzrCommandError("no changes to commit",
+                                  ["use --unchanged to commit anyhow"])
+
+
+class cmd_check(Command):
+    """Validate consistency of branch history.
+
+    This command checks various invariants about the branch storage to
+    detect data corruption or bzr bugs.
+
+    If given the --update flag, it will update some optional fields
+    to help ensure data consistency.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        from bzrlib.check import check
+        check(find_branch(dir))
+
+
+
+class cmd_scan_cache(Command):
+    hidden = True
+    def run(self):
+        from bzrlib.hashcache import HashCache
+        import os
+
+        c = HashCache('.')
+        c.read()
+        c.scan()
+            
+        print '%6d stats' % c.stat_count
+        print '%6d in hashcache' % len(c._cache)
+        print '%6d files removed from cache' % c.removed_count
+        print '%6d hashes updated' % c.update_count
+        print '%6d files changed too recently to cache' % c.danger_count
+
+        if c.needs_write:
+            c.write()
+            
+
+
+class cmd_upgrade(Command):
+    """Upgrade branch storage to current format.
+
+    This should normally be used only after the check command tells
+    you to run it.
+    """
+    takes_args = ['dir?']
+
+    def run(self, dir='.'):
+        from bzrlib.upgrade import upgrade
+        upgrade(find_branch(dir))
+
+
+
+class cmd_whoami(Command):
+    """Show bzr user id."""
+    takes_options = ['email']
+    
+    def run(self, email=False):
+        try:
+            b = bzrlib.branch.find_branch('.')
+        except:
+            b = None
+        
+        if email:
+            print bzrlib.osutils.user_email(b)
+        else:
+            print bzrlib.osutils.username(b)
+
+
+class cmd_selftest(Command):
+    """Run internal test suite"""
+    hidden = True
+    takes_options = ['verbose']
+    def run(self, verbose=False):
+        from bzrlib.selftest import selftest
+        return int(not selftest(verbose=verbose))
+
+
+class cmd_version(Command):
+    """Show version of bzr."""
+    def run(self):
+        show_version()
+
+def show_version():
+    print "bzr (bazaar-ng) %s" % bzrlib.__version__
+    # is bzrlib itself in a branch?
+    bzrrev = bzrlib.get_bzr_revision()
+    if bzrrev:
+        print "  (bzr checkout, revision %d {%s})" % bzrrev
+    print bzrlib.__copyright__
+    print "http://bazaar-ng.org/"
+    print
+    print "bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and"
+    print "you may use, modify and redistribute it under the terms of the GNU"
+    print "General Public License version 2 or later."
+
+
+class cmd_rocks(Command):
+    """Statement of optimism."""
+    hidden = True
+    def run(self):
+        print "it sure does!"
 
 def parse_spec(spec):
     """
@@ -357,6 +1459,166 @@
 
 
 
+class cmd_merge(Command):
+    """Perform a three-way merge.
+    
+    The branch is the branch you will merge from.  By default, it will merge
+    the latest revision.  If you specify a revision, that revision will be
+    merged.  If you specify two revisions, the first will be used as a BASE, 
+    and the second one as OTHER.  Revision numbers are always relative to the
+    specified branch.
+    
+    Examples:
+
+    To merge the latest revision from bzr.dev
+    bzr merge ../bzr.dev
+
+    To merge changes up to and including revision 82 from bzr.dev
+    bzr merge -r 82 ../bzr.dev
+
+    To merge the changes introduced by 82, without previous changes:
+    bzr merge -r 81..82 ../bzr.dev
+    
+    merge refuses to run if there are any uncommitted changes, unless
+    --force is given.
+    """
+    takes_args = ['branch?']
+    takes_options = ['revision', 'force', 'merge-type']
+
+    def run(self, branch='.', revision=None, force=False, 
+            merge_type=None):
+        from bzrlib.merge import merge
+        from bzrlib.merge_core import ApplyMerge3
+        if merge_type is None:
+            merge_type = ApplyMerge3
+
+        if revision is None or len(revision) < 1:
+            base = (None, None)
+            other = (branch, -1)
+        else:
+            if len(revision) == 1:
+                other = (branch, revision[0])
+                base = (None, None)
+            else:
+                assert len(revision) == 2
+                if None in revision:
+                    raise BzrCommandError(
+                        "Merge doesn't permit that revision specifier.")
+                base = (branch, revision[0])
+                other = (branch, revision[1])
+            
+        merge(other, base, check_clean=(not force), merge_type=merge_type)
+
+
+class cmd_revert(Command):
+    """Reverse all changes since the last commit.
+
+    Only versioned files are affected.  Specify filenames to revert only 
+    those files.  By default, any files that are changed will be backed up
+    first.  Backup files have a '~' appended to their name.
+    """
+    takes_options = ['revision', 'no-backup']
+    takes_args = ['file*']
+    aliases = ['merge-revert']
+
+    def run(self, revision=None, no_backup=False, file_list=None):
+        from bzrlib.merge import merge
+        if file_list is not None:
+            if len(file_list) == 0:
+                raise BzrCommandError("No files specified")
+        if revision is None:
+            revision = [-1]
+        elif len(revision) != 1:
+            raise BzrCommandError('bzr revert --revision takes exactly 1 argument')
+        merge(('.', revision[0]), parse_spec('.'),
+              check_clean=False,
+              ignore_zero=True,
+              backup_files=not no_backup,
+              file_list=file_list)
+
+
+class cmd_assert_fail(Command):
+    """Test reporting of assertion failures"""
+    hidden = True
+    def run(self):
+        assert False, "always fails"
+
+
+class cmd_help(Command):
+    """Show help on a command or other topic.
+
+    For a list of all available commands, say 'bzr help commands'."""
+    takes_args = ['topic?']
+    aliases = ['?']
+    
+    def run(self, topic=None):
+        import help
+        help.help(topic)
+
+
+class cmd_shell_complete(Command):
+    """Show appropriate completions for context.
+
+    For a list of all available commands, say 'bzr shell-complete'."""
+    takes_args = ['context?']
+    aliases = ['s-c']
+    hidden = True
+    
+    def run(self, context=None):
+        import shellcomplete
+        shellcomplete.shellcomplete(context)
+
+
+class cmd_missing(Command):
+    """What is missing in this branch relative to other branch.
+    """
+    takes_args = ['remote?']
+    aliases = ['mis', 'miss']
+    # We don't have to add quiet to the list, because 
+    # unknown options are parsed as booleans
+    takes_options = ['verbose', 'quiet']
+
+    def run(self, remote=None, verbose=False, quiet=False):
+        from bzrlib.branch import find_branch, DivergedBranches
+        from bzrlib.errors import BzrCommandError
+        from bzrlib.missing import get_parent, show_missing
+
+        if verbose and quiet:
+            raise BzrCommandError('Cannot pass both quiet and verbose')
+
+        b = find_branch('.')
+        parent = get_parent(b)
+        if remote is None:
+            if parent is None:
+                raise BzrCommandError("No missing location known or specified.")
+            else:
+                if not quiet:
+                    print "Using last location: %s" % parent
+                remote = parent
+        elif parent is None:
+            # We only update x-pull if it did not exist, missing should not change the parent
+            b.controlfile('x-pull', 'wb').write(remote + '\n')
+        br_remote = find_branch(remote)
+
+        return show_missing(b, br_remote, verbose=verbose, quiet=quiet)
+
+
+class cmd_plugins(Command):
+    """List plugins"""
+    hidden = True
+    def run(self):
+        import bzrlib.plugin
+        from inspect import getdoc
+        from pprint import pprint
+        for plugin in bzrlib.plugin.all_plugins:
+            print plugin.__path__[0]
+            d = getdoc(plugin)
+            if d:
+                print '\t', d.split('\n')[0]
+
+        #pprint(bzrlib.plugin.all_plugins)
+
+
 
 # list of all available options; the rhs can be either None for an
 # option that takes no argument, or a constructor function that checks
@@ -385,7 +1647,6 @@
     'root':                   str,
     'no-backup':              None,
     'merge-type':             get_merge_type,
-    'pattern':                str,
     }
 
 SHORT_OPTIONS = {
@@ -408,8 +1669,6 @@
 
     >>> parse_args('--help'.split())
     ([], {'help': True})
-    >>> parse_args('help -- --invalidcmd'.split())
-    (['help', '--invalidcmd'], {})
     >>> parse_args('--version'.split())
     ([], {'version': True})
     >>> parse_args('status --all'.split())
@@ -428,18 +1687,15 @@
     args = []
     opts = {}
 
-    argsover = False
+    # TODO: Maybe handle '--' to end options?
+
     while argv:
         a = argv.pop(0)
-        if not argsover and a[0] == '-':
+        if a[0] == '-':
             # option names must not be unicode
             a = str(a)
             optarg = None
             if a[1] == '-':
-                if a == '--':
-                    # We've received a standalone -- No more flags
-                    argsover = True
-                    continue
                 mutter("  got option %r" % a)
                 if '=' in a:
                     optname, optarg = a[2:].split('=', 1)
@@ -547,31 +1803,6 @@
 
 
 
-def apply_profiled(the_callable, *args, **kwargs):
-    import hotshot
-    import tempfile
-    pffileno, pfname = tempfile.mkstemp()
-    try:
-        prof = hotshot.Profile(pfname)
-        try:
-            ret = prof.runcall(the_callable, *args, **kwargs) or 0
-        finally:
-            prof.close()
-
-        import hotshot.stats
-        stats = hotshot.stats.load(pfname)
-        #stats.strip_dirs()
-        stats.sort_stats('time')
-        ## XXX: Might like to write to stderr or the trace file instead but
-        ## print_stats seems hardcoded to stdout
-        stats.print_stats(20)
-
-        return ret
-    finally:
-        os.close(pffileno)
-        os.remove(pfname)
-
-
 def run_bzr(argv):
     """Execute a command.
 
@@ -605,7 +1836,7 @@
     # to load plugins before doing other command parsing so that they
     # can override commands, but this needs to happen first.
 
-    for a in argv:
+    for a in argv[:]:
         if a == '--profile':
             opt_profile = True
         elif a == '--no-plugins':
@@ -616,68 +1847,132 @@
             break
         argv.remove(a)
 
-    if (not argv) or (argv[0] == '--help'):
-        from bzrlib.help import help
-        if len(argv) > 1:
-            help(argv[1])
-        else:
-            help()
-        return 0
-
-    if argv[0] == '--version':
-        from bzrlib.builtins import show_version
-        show_version()
-        return 0
-        
     if not opt_no_plugins:
         from bzrlib.plugin import load_plugins
         load_plugins()
 
-    cmd = str(argv.pop(0))
-
-    cmd_obj = get_cmd_object(cmd, plugins_override=not opt_builtin)
+    args, opts = parse_args(argv)
+
+    if 'help' in opts:
+        from bzrlib.help import help
+        if args:
+            help(args[0])
+        else:
+            help()
+        return 0            
+        
+    if 'version' in opts:
+        show_version()
+        return 0
+    
+    if not args:
+        print >>sys.stderr, "please try 'bzr help' for help"
+        return 1
+    
+    cmd = str(args.pop(0))
+
+    canonical_cmd, cmd_class = \
+                   get_cmd_class(cmd, plugins_override=not opt_builtin)
+
+    # check options are reasonable
+    allowed = cmd_class.takes_options
+    for oname in opts:
+        if oname not in allowed:
+            raise BzrCommandError("option '--%s' is not allowed for command %r"
+                                  % (oname, cmd))
+
+    # mix arguments and options into one dictionary
+    cmdargs = _match_argform(cmd, cmd_class.takes_args, args)
+    cmdopts = {}
+    for k, v in opts.items():
+        cmdopts[k.replace('-', '_')] = v
 
     if opt_profile:
-        ret = apply_profiled(cmd_obj.run_argv, argv)
+        import hotshot, tempfile
+        pffileno, pfname = tempfile.mkstemp()
+        try:
+            prof = hotshot.Profile(pfname)
+            ret = prof.runcall(cmd_class, cmdopts, cmdargs) or 0
+            prof.close()
+
+            import hotshot.stats
+            stats = hotshot.stats.load(pfname)
+            #stats.strip_dirs()
+            stats.sort_stats('time')
+            ## XXX: Might like to write to stderr or the trace file instead but
+            ## print_stats seems hardcoded to stdout
+            stats.print_stats(20)
+            
+            return ret.status
+
+        finally:
+            os.close(pffileno)
+            os.remove(pfname)
     else:
-        ret = cmd_obj.run_argv(argv)
-    return ret or 0
+        return cmd_class(cmdopts, cmdargs).status 
+
+
+def _report_exception(summary, quiet=False):
+    import traceback
+    
+    log_error('bzr: ' + summary)
+    bzrlib.trace.log_exception()
+
+    if os.environ.get('BZR_DEBUG'):
+        traceback.print_exc()
+
+    if not quiet:
+        sys.stderr.write('\n')
+        tb = sys.exc_info()[2]
+        exinfo = traceback.extract_tb(tb)
+        if exinfo:
+            sys.stderr.write('  at %s:%d in %s()\n' % exinfo[-1][:3])
+        sys.stderr.write('  see ~/.bzr.log for debug information\n')
+
 
 
 def main(argv):
-    import bzrlib.ui
-    bzrlib.trace.log_startup(argv)
-    bzrlib.ui.ui_factory = bzrlib.ui.TextUIFactory()
+    
+    bzrlib.trace.open_tracefile(argv)
 
     try:
         try:
-            return run_bzr(argv[1:])
-        finally:
-            # do this here inside the exception wrappers to catch EPIPE
-            sys.stdout.flush()
-    except BzrCommandError, e:
-        # command line syntax error, etc
-        log_error(str(e))
-        return 1
-    except BzrError, e:
-        bzrlib.trace.log_exception()
-        return 1
-    except AssertionError, e:
-        bzrlib.trace.log_exception('assertion failed: ' + str(e))
-        return 3
-    except KeyboardInterrupt, e:
-        bzrlib.trace.note('interrupted')
-        return 2
-    except Exception, e:
-        import errno
-        if (isinstance(e, IOError) 
-            and hasattr(e, 'errno')
-            and e.errno == errno.EPIPE):
-            bzrlib.trace.note('broken pipe')
-            return 2
-        else:
-            bzrlib.trace.log_exception()
-            return 2
+            try:
+                return run_bzr(argv[1:])
+            finally:
+                # do this here inside the exception wrappers to catch EPIPE
+                sys.stdout.flush()
+        except BzrError, e:
+            quiet = isinstance(e, (BzrCommandError))
+            _report_exception('error: ' + str(e), quiet=quiet)
+            if len(e.args) > 1:
+                for h in e.args[1]:
+                    # some explanation or hints
+                    log_error('  ' + h)
+            return 1
+        except AssertionError, e:
+            msg = 'assertion failed'
+            if str(e):
+                msg += ': ' + str(e)
+            _report_exception(msg)
+            return 2
+        except KeyboardInterrupt, e:
+            _report_exception('interrupted', quiet=True)
+            return 2
+        except Exception, e:
+            import errno
+            quiet = False
+            if (isinstance(e, IOError) 
+                and hasattr(e, 'errno')
+                and e.errno == errno.EPIPE):
+                quiet = True
+                msg = 'broken pipe'
+            else:
+                msg = str(e).rstrip('\n')
+            _report_exception(msg, quiet)
+            return 2
+    finally:
+        bzrlib.trace.close_trace()
 
 
 if __name__ == '__main__':

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-09-05 09:27:11 +0000
+++ bzrlib/commit.py	2005-08-18 04:25:42 +0000
@@ -16,6 +16,8 @@
 
 
 
+# FIXME: "bzr commit doc/format" commits doc/format.txt!
+
 def commit(branch, message,
            timestamp=None,
            timezone=None,
@@ -64,7 +66,7 @@
     from bzrlib.errors import BzrError, PointlessCommit
     from bzrlib.revision import Revision, RevisionReference
     from bzrlib.trace import mutter, note
-    from bzrlib.xml import serializer_v4
+    from bzrlib.xml import pack_xml
 
     branch.lock_write()
 
@@ -83,10 +85,7 @@
         basis_inv = basis.inventory
 
         if verbose:
-            # note('looking for changes...')
-            # print 'looking for changes...'
-            # disabled; should be done at a higher level
-            pass
+            note('looking for changes...')
 
         pending_merges = branch.pending_merges()
 
@@ -121,8 +120,7 @@
         inv_id = rev_id
 
         inv_tmp = tempfile.TemporaryFile()
-        
-        serializer_v4.write_inventory(new_inv, inv_tmp)
+        pack_xml(new_inv, inv_tmp)
         inv_tmp.seek(0)
         branch.inventory_store.add(inv_tmp, inv_id)
         mutter('new inventory_id is {%s}' % inv_id)
@@ -161,7 +159,7 @@
             rev.parents.append(RevisionReference(merge_rev))            
 
         rev_tmp = tempfile.TemporaryFile()
-        serializer_v4.write_revision(rev, rev_tmp)
+        pack_xml(rev, rev_tmp)
         rev_tmp.seek(0)
         branch.revision_store.add(rev_tmp, rev_id)
         mutter("new revision_id is {%s}" % rev_id)
@@ -181,10 +179,7 @@
         branch.set_pending_merges([])
 
         if verbose:
-            # disabled; should go through logging
-            # note("commited r%d" % branch.revno())
-            # print ("commited r%d" % branch.revno())
-            pass
+            note("commited r%d" % branch.revno())
     finally:
         branch.unlock()
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-09-04 02:59:56 +0000
+++ bzrlib/errors.py	2005-08-04 21:39:23 +0000
@@ -92,33 +92,3 @@
         BzrError.__init__(self, msg)
 
 
-class UnrelatedBranches(BzrCommandError):
-    def __init__(self):
-        msg = "Branches have no common ancestor, and no base revision"\
-            " specified."
-        BzrCommandError.__init__(self, msg)
-
-
-class NotAncestor(BzrError):
-    def __init__(self, rev_id, not_ancestor_id):
-        self.rev_id = rev_id
-        self.not_ancestor_id = not_ancestor_id
-        msg = "Revision %s is not an ancestor of %s" % (not_ancestor_id, 
-                                                        rev_id)
-        BzrError.__init__(self, msg)
-
-
-class InstallFailed(BzrError):
-    def __init__(self, revisions):
-        self.revisions = revisions
-        msg = "Could not install revisions:\n%s" % " ,".join(revisions)
-        BzrError.__init__(self, msg)
-
-
-class AmbiguousBase(BzrError):
-    def __init__(self, bases):
-        msg = "The correct base is unclear, becase %s are all equally close" %\
-            ", ".join(bases)
-        BzrError.__init__(self, msg)
-        self.bases = bases
-

=== removed file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2005-09-01 11:53:02 +0000
+++ bzrlib/externalcommand.py	1970-01-01 00:00:00 +0000
@@ -1,62 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# TODO: Perhaps rather than mapping options and arguments back and
-# forth, we should just pass in the whole argv, and allow
-# ExternalCommands to handle it differently to internal commands?
-
-
-import os
-import sys
-from bzrlib.commands import Command
-
-
-class ExternalCommand(Command):
-    """Class to wrap external commands."""
-
-    @classmethod
-    def find_command(cls, cmd):
-        import os.path
-        bzrpath = os.environ.get('BZRPATH', '')
-
-        for dir in bzrpath.split(os.pathsep):
-            path = os.path.join(dir, cmd)
-            if os.path.isfile(path):
-                return ExternalCommand(path)
-
-        return None
-
-
-    def __init__(self, path):
-        self.path = path
-
- 
-    def name(self):
-        return self.path.split(os.sep)[-1]
-
-
-    def run(self, *args, **kwargs):
-        raise NotImplementedError('should not be called on %r' % self)
-
-
-    def run_argv(self, argv):
-        return os.spawnv(os.P_WAIT, self.path, [self.path] + argv)
-
-
-    def help(self):
-        m = 'external command from %s\n\n' % self.path
-        pipe = os.popen('%s --help' % self.path)
-        return m + pipe.read()

=== removed file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-09-04 02:59:56 +0000
+++ bzrlib/fetch.py	1970-01-01 00:00:00 +0000
@@ -1,82 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-import bzrlib.errors
-from bzrlib.trace import mutter, note
-from bzrlib.branch import Branch
-from bzrlib.progress import ProgressBar
-import sys
-import os
-
-def has_revision(branch, revision_id):
-    try:
-        branch.get_revision_xml(revision_id)
-        return True
-    except bzrlib.errors.NoSuchRevision:
-        return False
-
-
-def greedy_fetch(to_branch, from_branch, revision=None, pb=None):
-    """Copy a revision and all available ancestors from one branch to another
-    If no revision is specified, uses the last revision in the source branch's
-    revision history.
-    """
-    from_history = from_branch.revision_history()
-    required_revisions = set(from_history)
-    all_failed = set()
-    if revision is not None:
-        required_revisions.add(revision)
-        try:
-            rev_index = from_history.index(revision)
-        except ValueError:
-            rev_index = None
-        if rev_index is not None:
-            from_history = from_history[:rev_index + 1]
-        else:
-            from_history = [revision]
-    to_history = to_branch.revision_history()
-    missing = []
-    for rev_id in from_history:
-        if not has_revision(to_branch, rev_id):
-            missing.append(rev_id)
-    
-    count = 0
-    while len(missing) > 0:
-        installed, failed = to_branch.install_revisions(from_branch, 
-                                                        revision_ids=missing,
-                                                        pb=pb)
-        count += installed
-        required_failed = failed.intersection(required_revisions)
-        if len(required_failed) > 0:
-            raise bzrlib.errors.InstallFailed(required_failed)
-        for rev_id in failed:
-            note("Failed to install %s" % rev_id)
-        all_failed.update(failed)
-        new_missing = set() 
-        for rev_id in missing:
-            try:
-                revision = from_branch.get_revision(rev_id)
-            except bzrlib.errors.NoSuchRevision:
-                if revision in from_history:
-                    raise
-                else:
-                    continue
-            for parent in [p.revision_id for p in revision.parents]:
-                if not has_revision(to_branch, parent):
-                    new_missing.add(parent)
-        missing = new_missing
-    return count, all_failed
-
-

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2005-09-05 04:08:03 +0000
+++ bzrlib/help.py	2005-08-03 14:16:04 +0000
@@ -14,13 +14,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-# TODO: Some way to get a list of external commands (defined by shell
-# scripts) so that they can be included in the help listing as well.
-# It should be enough to just list the plugin directory and look for
-# executable files with reasonable names.
-
-# TODO: `help commands --all` should show hidden commands
-
 global_help = \
 """Bazaar-NG -- a free distributed version-control tool
 http://bazaar-ng.org/
@@ -46,8 +39,8 @@
   bzr log       show history of changes
   bzr check     validate storage
 
-Use e.g. 'bzr help init' for more details, or
-'bzr help commands' for all commands.
+Use e.g. 'bzr help init' for more details, or 'bzr help commands' for
+all commands.
 """
 
 
@@ -65,13 +58,13 @@
         help_on_command(topic, outfile = outfile)
 
 
-def command_usage(cmd_object):
+def command_usage(cmdname, cmdclass):
     """Return single-line grammar for command.
 
     Only describes arguments, not options.
     """
-    s = 'bzr ' + cmd_object.name() + ' '
-    for aname in cmd_object.takes_args:
+    s = cmdname + ' '
+    for aname in cmdclass.takes_args:
         aname = aname.upper()
         if aname[-1] in ['$', '+']:
             aname = aname[:-1] + '...'
@@ -87,37 +80,34 @@
     return s
 
 
-def help_on_command(cmdname, outfile=None):
-    from bzrlib.commands import get_cmd_object
-
+def help_on_command(cmdname, outfile = None):
     cmdname = str(cmdname)
 
     if outfile == None:
         outfile = sys.stdout
 
-    cmd_object = get_cmd_object(cmdname)
+    from inspect import getdoc
+    import commands
+    topic, cmdclass = commands.get_cmd_class(cmdname)
 
-    doc = cmd_object.help()
+    doc = getdoc(cmdclass)
     if doc == None:
         raise NotImplementedError("sorry, no detailed help yet for %r" % cmdname)
 
-    print >>outfile, 'usage:', command_usage(cmd_object) 
-
-    if cmd_object.aliases:
-        print >>outfile, 'aliases:',
-        print >>outfile, ', '.join(cmd_object.aliases)
-
-    print >>outfile
-
+    outfile.write('usage: ' + command_usage(topic, cmdclass) + '\n')
+
+    if cmdclass.aliases:
+        outfile.write('aliases: ' + ', '.join(cmdclass.aliases) + '\n')
+    
     outfile.write(doc)
     if doc[-1] != '\n':
         outfile.write('\n')
     
-    help_on_options(cmd_object.takes_options, outfile=None)
-
-
-def help_on_options(options, outfile=None):
-    from bzrlib.commands import SHORT_OPTIONS
+    help_on_option(cmdclass.takes_options, outfile = None)
+
+
+def help_on_option(options, outfile = None):
+    import commands
     
     if not options:
         return
@@ -128,35 +118,32 @@
     outfile.write('\noptions:\n')
     for on in options:
         l = '    --' + on
-        for shortname, longname in SHORT_OPTIONS.items():
+        for shortname, longname in commands.SHORT_OPTIONS.items():
             if longname == on:
                 l += ', -' + shortname
                 break
         outfile.write(l + '\n')
 
 
-def help_commands(outfile=None):
+def help_commands(outfile = None):
     """List all commands"""
-    from bzrlib.commands import (builtin_command_names,
-                                 plugin_command_names,
-                                 get_cmd_object)
+    import inspect
+    import commands
 
     if outfile == None:
         outfile = sys.stdout
-
-    names = set()                       # to eliminate duplicates
-    names.update(builtin_command_names())
-    names.update(plugin_command_names())
-    names = list(names)
-    names.sort()
-
-    for cmd_name in names:
-        cmd_object = get_cmd_object(cmd_name)
-        if cmd_object.hidden:
+    
+    accu = []
+    for cmdname, cmdclass in commands.get_all_cmds():
+        accu.append((cmdname, cmdclass))
+    accu.sort()
+    for cmdname, cmdclass in accu:
+        if cmdclass.hidden:
             continue
-        print >>outfile, command_usage(cmd_object)
-        cmd_help = cmd_object.help()
-        if cmd_help:
-            firstline = cmd_help.split('\n', 1)[0]
-            print >>outfile, '    ' + firstline
-        
+        outfile.write(command_usage(cmdname, cmdclass) + '\n')
+        help = inspect.getdoc(cmdclass)
+        if help:
+            outfile.write("    " + help.split('\n', 1)[0] + '\n')
+
+            
+

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-09-06 07:26:13 +0000
+++ bzrlib/inventory.py	2005-08-18 05:52:29 +0000
@@ -55,9 +55,7 @@
     >>> i.path2id('')
     'TREE_ROOT'
     >>> i.add(InventoryEntry('123', 'src', 'directory', ROOT_ID))
-    InventoryEntry('123', 'src', kind='directory', parent_id='TREE_ROOT')
     >>> i.add(InventoryEntry('2323', 'hello.c', 'file', parent_id='123'))
-    InventoryEntry('2323', 'hello.c', kind='file', parent_id='123')
     >>> for j in i.iter_entries():
     ...   print j
     ... 
@@ -68,15 +66,12 @@
     ...
     BzrError: inventory already contains entry with id {2323}
     >>> i.add(InventoryEntry('2324', 'bye.c', 'file', '123'))
-    InventoryEntry('2324', 'bye.c', kind='file', parent_id='123')
     >>> i.add(InventoryEntry('2325', 'wibble', 'directory', '123'))
-    InventoryEntry('2325', 'wibble', kind='directory', parent_id='123')
     >>> i.path2id('src/wibble')
     '2325'
     >>> '2325' in i
     True
     >>> i.add(InventoryEntry('2326', 'wibble.c', 'file', '2325'))
-    InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> i['2326']
     InventoryEntry('2326', 'wibble.c', kind='file', parent_id='2325')
     >>> for j in i.iter_entries():
@@ -100,9 +95,7 @@
     # directories, etc etc.
 
     __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children',
-                 'text_version', 'entry_version', ]
-
+                 'text_id', 'parent_id', 'children', ]
 
     def __init__(self, file_id, name, kind, parent_id, text_id=None):
         """Create an InventoryEntry
@@ -119,14 +112,12 @@
         Traceback (most recent call last):
         BzrCheckError: InventoryEntry name 'src/hello.c' is invalid
         """
-        assert isinstance(name, basestring), name
         if '/' in name or '\\' in name:
             raise BzrCheckError('InventoryEntry name %r is invalid' % name)
         
-        self.text_version = None
-        self.entry_version = None
         self.text_sha1 = None
         self.text_size = None
+    
         self.file_id = file_id
         self.name = name
         self.kind = kind
@@ -166,6 +157,60 @@
                    self.parent_id))
 
     
+    def to_element(self):
+        """Convert to XML element"""
+        from bzrlib.xml import Element
+        
+        e = Element('entry')
+
+        e.set('name', self.name)
+        e.set('file_id', self.file_id)
+        e.set('kind', self.kind)
+
+        if self.text_size != None:
+            e.set('text_size', '%d' % self.text_size)
+            
+        for f in ['text_id', 'text_sha1']:
+            v = getattr(self, f)
+            if v != None:
+                e.set(f, v)
+
+        # to be conservative, we don't externalize the root pointers
+        # for now, leaving them as null in the xml form.  in a future
+        # version it will be implied by nested elements.
+        if self.parent_id != ROOT_ID:
+            assert isinstance(self.parent_id, basestring)
+            e.set('parent_id', self.parent_id)
+
+        e.tail = '\n'
+            
+        return e
+
+
+    def from_element(cls, elt):
+        assert elt.tag == 'entry'
+
+        ## original format inventories don't have a parent_id for
+        ## nodes in the root directory, but it's cleaner to use one
+        ## internally.
+        parent_id = elt.get('parent_id')
+        if parent_id == None:
+            parent_id = ROOT_ID
+
+        self = cls(elt.get('file_id'), elt.get('name'), elt.get('kind'), parent_id)
+        self.text_id = elt.get('text_id')
+        self.text_sha1 = elt.get('text_sha1')
+        
+        ## mutter("read inventoryentry: %r" % (elt.attrib))
+
+        v = elt.get('text_size')
+        self.text_size = v and int(v)
+
+        return self
+            
+
+    from_element = classmethod(from_element)
+
     def __eq__(self, other):
         if not isinstance(other, InventoryEntry):
             return NotImplemented
@@ -176,9 +221,7 @@
                and (self.text_size == other.text_size) \
                and (self.text_id == other.text_id) \
                and (self.parent_id == other.parent_id) \
-               and (self.kind == other.kind) \
-               and (self.text_version == other.text_version) \
-               and (self.entry_version == other.entry_version)
+               and (self.kind == other.kind)
 
 
     def __ne__(self, other):
@@ -225,7 +268,6 @@
 
     >>> inv = Inventory()
     >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
-    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT')
     >>> inv['123-123'].name
     'hello.c'
 
@@ -242,7 +284,6 @@
     ['hello.c']
     >>> inv = Inventory('TREE_ROOT-12345678-12345678')
     >>> inv.add(InventoryEntry('123-123', 'hello.c', 'file', ROOT_ID))
-    InventoryEntry('123-123', 'hello.c', kind='file', parent_id='TREE_ROOT-12345678-12345678')
     """
     def __init__(self, root_id=ROOT_ID):
         """Create or read an inventory.
@@ -330,7 +371,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> '456' in inv
@@ -344,7 +384,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123123', 'hello.c', 'file', ROOT_ID))
-        InventoryEntry('123123', 'hello.c', kind='file', parent_id='TREE_ROOT')
         >>> inv['123123'].name
         'hello.c'
         """
@@ -368,10 +407,7 @@
         """Add entry to inventory.
 
         To add  a file to a branch ready to be committed, use Branch.add,
-        which calls this.
-
-        Returns the new entry object.
-        """
+        which calls this."""
         if entry.file_id in self._byid:
             raise BzrError("inventory already contains entry with id {%s}" % entry.file_id)
 
@@ -389,15 +425,12 @@
 
         self._byid[entry.file_id] = entry
         parent.children[entry.name] = entry
-        return entry
 
 
     def add_path(self, relpath, kind, file_id=None):
         """Add entry from a path.
 
-        The immediate parent must already be versioned.
-
-        Returns the new entry object."""
+        The immediate parent must already be versioned"""
         from bzrlib.branch import gen_file_id
         
         parts = bzrlib.osutils.splitpath(relpath)
@@ -422,7 +455,6 @@
 
         >>> inv = Inventory()
         >>> inv.add(InventoryEntry('123', 'foo.c', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo.c', kind='file', parent_id='TREE_ROOT')
         >>> '123' in inv
         True
         >>> del inv['123']
@@ -444,6 +476,43 @@
         del self[ie.parent_id].children[ie.name]
 
 
+    def to_element(self):
+        """Convert to XML Element"""
+        from bzrlib.xml import Element
+        
+        e = Element('inventory')
+        e.text = '\n'
+        if self.root.file_id not in (None, ROOT_ID):
+            e.set('file_id', self.root.file_id)
+        for path, ie in self.iter_entries():
+            e.append(ie.to_element())
+        return e
+    
+
+    def from_element(cls, elt):
+        """Construct from XML Element
+        
+        >>> inv = Inventory()
+        >>> inv.add(InventoryEntry('foo.c-123981239', 'foo.c', 'file', ROOT_ID))
+        >>> elt = inv.to_element()
+        >>> inv2 = Inventory.from_element(elt)
+        >>> inv2 == inv
+        True
+        """
+        # XXXX: doctest doesn't run this properly under python2.3
+        assert elt.tag == 'inventory'
+        root_id = elt.get('file_id') or ROOT_ID
+        o = cls(root_id)
+        for e in elt:
+            ie = InventoryEntry.from_element(e)
+            if ie.parent_id == ROOT_ID:
+                ie.parent_id = root_id
+            o.add(ie)
+        return o
+        
+    from_element = classmethod(from_element)
+
+
     def __eq__(self, other):
         """Compare two sets by comparing their contents.
 
@@ -452,11 +521,9 @@
         >>> i1 == i2
         True
         >>> i1.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         False
         >>> i2.add(InventoryEntry('123', 'foo', 'file', ROOT_ID))
-        InventoryEntry('123', 'foo', kind='file', parent_id='TREE_ROOT')
         >>> i1 == i2
         True
         """
@@ -478,6 +545,7 @@
         raise ValueError('not hashable')
 
 
+
     def get_idpath(self, file_id):
         """Return a list of file_ids for the path to an entry.
 

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-09-05 05:35:25 +0000
+++ bzrlib/log.py	2005-08-01 20:10:24 +0000
@@ -53,6 +53,7 @@
 from bzrlib.tree import EmptyTree
 from bzrlib.delta import compare_trees
 from bzrlib.trace import mutter
+from bzrlib.errors import InvalidRevisionNumber
 
 
 def find_touching_revisions(branch, file_id):
@@ -161,13 +162,13 @@
     
     if start_revision is None:
         start_revision = 1
-    else:
-        branch.check_real_revno(start_revision)
+    elif start_revision < 1 or start_revision >= len(which_revs):
+        raise InvalidRevisionNumber(start_revision)
     
     if end_revision is None:
         end_revision = len(which_revs)
-    else:
-        branch.check_real_revno(end_revision)
+    elif end_revision < 1 or end_revision >= len(which_revs):
+        raise InvalidRevisionNumber(end_revision)
 
     # list indexes are 0-based; revisions are 1-based
     cut_revs = which_revs[(start_revision-1):(end_revision)]
@@ -309,10 +310,6 @@
         print >>to_file,  'revno:', revno
         if self.show_ids:
             print >>to_file,  'revision-id:', rev.revision_id
-
-            for parent in rev.parents:
-                print >>to_file, 'parent:', parent.revision_id
-            
         print >>to_file,  'committer:', rev.committer
 
         date_str = format_date(rev.timestamp,

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-09-05 02:01:31 +0000
+++ bzrlib/merge.py	2005-08-17 08:32:56 +0000
@@ -1,37 +1,16 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
+from bzrlib.merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
+from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
+from bzrlib.changeset import Inventory, Diff3Merge
+from bzrlib import find_branch
+import bzrlib.osutils
+from bzrlib.errors import BzrCommandError
+from bzrlib.delta import compare_trees
+from trace import mutter, warning
 import os.path
 import tempfile
 import shutil
 import errno
-from fetch import greedy_fetch
 
-import bzrlib.osutils
-import bzrlib.revision
-from bzrlib.merge_core import merge_flex, ApplyMerge3, BackupBeforeChange
-from bzrlib.changeset import generate_changeset, ExceptionConflictHandler
-from bzrlib.changeset import Inventory, Diff3Merge
-from bzrlib.branch import find_branch
-from bzrlib.errors import BzrCommandError, UnrelatedBranches
-from bzrlib.delta import compare_trees
-from bzrlib.trace import mutter, warning
-from bzrlib.fetch import greedy_fetch
-from bzrlib.revision import is_ancestor
 
 # comments from abentley on irc: merge happens in two stages, each
 # of which generates a changeset object
@@ -39,6 +18,13 @@
 # stage 1: generate OLD->OTHER,
 # stage 2: use MINE and OLD->OTHER to generate MINE -> RESULT
 
+class UnrelatedBranches(BzrCommandError):
+    def __init__(self):
+        msg = "Branches have no common ancestor, and no base revision"\
+            " specified."
+        BzrCommandError.__init__(self, msg)
+
+
 class MergeConflictHandler(ExceptionConflictHandler):
     """Handle conflicts encountered while merging.
 
@@ -131,30 +117,18 @@
         if not self.ignore_zero:
             print "%d conflicts encountered.\n" % self.conflicts
             
-def get_tree(treespec, temp_root, label, local_branch=None):
+def get_tree(treespec, temp_root, label):
     location, revno = treespec
     branch = find_branch(location)
     if revno is None:
-        revision = None
+        base_tree = branch.working_tree()
     elif revno == -1:
-        revision = branch.last_patch()
-    else:
-        revision = branch.lookup_revision(revno)
-    return branch, get_revid_tree(branch, revision, temp_root, label,
-                                  local_branch)
-
-def get_revid_tree(branch, revision, temp_root, label, local_branch):
-    if revision is None:
-        base_tree = branch.working_tree()
-    else:
-        if local_branch is not None:
-            greedy_fetch(local_branch, branch, revision)
-            base_tree = local_branch.revision_tree(revision)
-        else:
-            base_tree = branch.revision_tree(revision)
+        base_tree = branch.basis_tree()
+    else:
+        base_tree = branch.revision_tree(branch.lookup_revision(revno))
     temp_path = os.path.join(temp_root, label)
     os.mkdir(temp_path)
-    return MergeTree(base_tree, temp_path)
+    return branch, MergeTree(base_tree, temp_path)
 
 
 def file_exists(tree, file_id):
@@ -191,16 +165,6 @@
     def has_id(self, file_id):
         return self.tree.has_id(file_id)
 
-    def has_or_had_id(self, file_id):
-        if file_id == self.tree.inventory.root.file_id:
-            return True
-        return self.tree.inventory.has_id(file_id)
-
-    def has_or_had_id(self, file_id):
-        if file_id == self.tree.inventory.root.file_id:
-            return True
-        return self.tree.inventory.has_id(file_id)
-
     def readonly_path(self, id):
         if id not in self.tree:
             return None
@@ -226,65 +190,37 @@
     """Merge changes into a tree.
 
     base_revision
-        tuple(path, revision) Base for three-way merge.
+        Base for three-way merge.
     other_revision
-        tuple(path, revision) Other revision for three-way merge.
+        Other revision for three-way merge.
     this_dir
         Directory to merge changes into; '.' by default.
     check_clean
         If true, this_dir must have no uncommitted changes before the
         merge begins.
-    all available ancestors of other_revision and base_revision are
-    automatically pulled into the branch.
     """
-    from bzrlib.revision import common_ancestor, MultipleRevisionSources
-    from bzrlib.errors import NoSuchRevision
     tempdir = tempfile.mkdtemp(prefix="bzr-")
     try:
         if this_dir is None:
             this_dir = '.'
         this_branch = find_branch(this_dir)
-        this_rev_id = this_branch.last_patch()
-        if this_rev_id is None:
-            raise BzrCommandError("This branch has no commits")
         if check_clean:
             changes = compare_trees(this_branch.working_tree(), 
                                     this_branch.basis_tree(), False)
             if changes.has_changed():
                 raise BzrCommandError("Working tree has uncommitted changes.")
-        other_branch, other_tree = get_tree(other_revision, tempdir, "other",
-                                            this_branch)
-        if other_revision[1] == -1:
-            other_rev_id = other_branch.last_patch()
-            other_basis = other_rev_id
-        elif other_revision[1] is not None:
-            other_rev_id = other_branch.lookup_revision(other_revision[1])
-            other_basis = other_rev_id
-        else:
-            other_rev_id = None
-            other_basis = other_branch.last_patch()
+        other_branch, other_tree = get_tree(other_revision, tempdir, "other")
         if base_revision == [None, None]:
-            base_rev_id = common_ancestor(this_rev_id, other_basis, 
-                                          this_branch)
-            if base_rev_id is None:
+            if other_revision[1] == -1:
+                o_revno = None
+            else:
+                o_revno = other_revision[1]
+            base_revno = this_branch.common_ancestor(other_branch, 
+                                                     other_revno=o_revno)[0]
+            if base_revno is None:
                 raise UnrelatedBranches()
-            base_tree = get_revid_tree(this_branch, base_rev_id, tempdir, 
-                                       "base", None)
-            base_is_ancestor = True
-        else:
-            base_branch, base_tree = get_tree(base_revision, tempdir, "base")
-            if base_revision[1] == -1:
-                base_rev_id = base_branch.last_patch()
-            elif base_revision[1] is None:
-                base_rev_id = None
-            else:
-                base_rev_id = base_branch.lookup_revision(base_revision[1])
-            if base_rev_id is not None:
-                base_is_ancestor = is_ancestor(this_rev_id, base_rev_id, 
-                                               MultipleRevisionSources(this_branch, 
-                                                                       base_branch))
-            else:
-                base_is_ancestor = False
+            base_revision = ['.', base_revno]
+        base_branch, base_tree = get_tree(base_revision, tempdir, "base")
         if file_list is None:
             interesting_ids = None
         else:
@@ -304,9 +240,6 @@
         merge_inner(this_branch, other_tree, base_tree, tempdir, 
                     ignore_zero=ignore_zero, backup_files=backup_files, 
                     merge_type=merge_type, interesting_ids=interesting_ids)
-        if base_is_ancestor and other_rev_id is not None\
-            and other_rev_id not in this_branch.revision_history():
-            this_branch.add_pending_merge(other_rev_id)
     finally:
         shutil.rmtree(tempdir)
 

=== modified file 'bzrlib/merge3.py'
--- bzrlib/merge3.py	2005-09-04 02:59:56 +0000
+++ bzrlib/merge3.py	2005-07-06 04:09:02 +0000
@@ -76,9 +76,9 @@
     def merge_lines(self,
                     name_a=None,
                     name_b=None,
-                    start_marker='<<<<<<<',
-                    mid_marker='=======',
-                    end_marker='>>>>>>>',
+                    start_marker='<<<<<<<<',
+                    mid_marker='========',
+                    end_marker='>>>>>>>>',
                     show_base=False):
         """Return merge in cvs-like form.
         """

=== modified file 'bzrlib/merge_core.py'
--- bzrlib/merge_core.py	2005-08-27 04:42:41 +0000
+++ bzrlib/merge_core.py	2005-08-17 08:32:56 +0000
@@ -45,7 +45,7 @@
                        start_marker=start_marker):
             if line.startswith(start_marker):
                 new_conflicts = True
-                output_file.write(line.replace(start_marker, '<' * 7))
+                output_file.write(line.replace(start_marker, '<<<<<<<<'))
             else:
                 output_file.write(line)
         output_file.close()
@@ -150,7 +150,7 @@
     from bzrlib.trace import mutter
     def entry_data(file_id, tree):
         assert hasattr(tree, "__contains__"), "%s" % tree
-        if not tree.has_or_had_id(file_id):
+        if file_id not in tree:
             return (None, None, "")
         entry = tree.tree.inventory[file_id]
         my_dir = tree.id2path(entry.parent_id)
@@ -176,16 +176,13 @@
         new_parent = conflict_handler.move_conflict(entry.id, this_dir,
                                                     base_dir, other_dir)
     def get_path(name, parent):
-        if name is not None:
-            if name == "":
-                assert parent is None
-                return './.'
+        if name is not None and parent is not None:
             parent_dir = {this_parent: this_dir, other_parent: other_dir, 
                           base_parent: base_dir}
             directory = parent_dir[parent]
             return os.path.join(directory, name)
         else:
-            assert parent is None
+            assert name is None and parent is None
             return None
 
     old_path = get_path(old_name, old_parent)
@@ -197,17 +194,6 @@
     return new_entry
 
 
-def get_contents(entry, tree):
-    """Get a contents change element suitable for use with ReplaceContents
-    """
-    tree_entry = tree.tree.inventory[entry.id]
-    if tree_entry.kind == "file":
-        return changeset.FileCreate(tree.get_file(entry.id).read())
-    else:
-        assert tree_entry.kind in ("root_directory", "directory")
-        return changeset.dir_create
-
-
 def make_merged_contents(entry, this, base, other, conflict_handler,
                          merge_factory):
     contents = entry.contents_change
@@ -232,7 +218,8 @@
             if this_path is None or not os.path.exists(this_path):
                 return contents
             else:
-                this_contents = get_contents(entry, this)
+                this_contents = changeset.FileCreate(file(this_path, 
+                                                     "rb").read())
                 if this_contents == contents.new_contents:
                     return None
                 else:
@@ -275,3 +262,471 @@
             os.chmod(filename, other_stat)
         else:
             conflict_handler.permission_conflict(filename, base, other)
+
+
+import unittest
+import tempfile
+import shutil
+from bzrlib.inventory import InventoryEntry, RootEntry
+from osutils import file_kind
+class FalseTree(object):
+    def __init__(self, realtree):
+        self._realtree = realtree
+        self.inventory = self
+
+    def __getitem__(self, file_id):
+        entry = self.make_inventory_entry(file_id)
+        if entry is None:
+            raise KeyError(file_id)
+        return entry
+        
+    def make_inventory_entry(self, file_id):
+        path = self._realtree.inventory.get(file_id)
+        if path is None:
+            return None
+        if path == "":
+            return RootEntry(file_id)
+        dir, name = os.path.split(path)
+        kind = file_kind(self._realtree.abs_path(path))
+        for parent_id, path in self._realtree.inventory.iteritems():
+            if path == dir:
+                break
+        if path != dir:
+            raise Exception("Can't find parent for %s" % name)
+        return InventoryEntry(file_id, name, kind, parent_id)
+
+
+class MergeTree(object):
+    def __init__(self, dir):
+        self.dir = dir;
+        os.mkdir(dir)
+        self.inventory = {'0': ""}
+        self.tree = FalseTree(self)
+    
+    def child_path(self, parent, name):
+        return os.path.join(self.inventory[parent], name)
+
+    def add_file(self, id, parent, name, contents, mode):
+        path = self.child_path(parent, name)
+        full_path = self.abs_path(path)
+        assert not os.path.exists(full_path)
+        file(full_path, "wb").write(contents)
+        os.chmod(self.abs_path(path), mode)
+        self.inventory[id] = path
+
+    def remove_file(self, id):
+        os.unlink(self.full_path(id))
+        del self.inventory[id]
+
+    def add_dir(self, id, parent, name, mode):
+        path = self.child_path(parent, name)
+        full_path = self.abs_path(path)
+        assert not os.path.exists(full_path)
+        os.mkdir(self.abs_path(path))
+        os.chmod(self.abs_path(path), mode)
+        self.inventory[id] = path
+
+    def abs_path(self, path):
+        return os.path.join(self.dir, path)
+
+    def full_path(self, id):
+        try:
+            tree_path = self.inventory[id]
+        except KeyError:
+            return None
+        return self.abs_path(tree_path)
+
+    def readonly_path(self, id):
+        return self.full_path(id)
+
+    def __contains__(self, file_id):
+        return file_id in self.inventory
+
+    def get_file(self, file_id):
+        path = self.readonly_path(file_id)
+        return file(path, "rb")
+
+    def id2path(self, file_id):
+        return self.inventory[file_id]
+
+    def change_path(self, id, path):
+        new = os.path.join(self.dir, self.inventory[id])
+        os.rename(self.abs_path(self.inventory[id]), self.abs_path(path))
+        self.inventory[id] = path
+
+class MergeBuilder(object):
+    def __init__(self):
+        self.dir = tempfile.mkdtemp(prefix="BaZing")
+        self.base = MergeTree(os.path.join(self.dir, "base"))
+        self.this = MergeTree(os.path.join(self.dir, "this"))
+        self.other = MergeTree(os.path.join(self.dir, "other"))
+        
+        self.cset = changeset.Changeset()
+        self.cset.add_entry(changeset.ChangesetEntry("0", 
+                                                     changeset.NULL_ID, "./."))
+    def get_cset_path(self, parent, name):
+        if name is None:
+            assert (parent is None)
+            return None
+        return os.path.join(self.cset.entries[parent].path, name)
+
+    def add_file(self, id, parent, name, contents, mode):
+        self.base.add_file(id, parent, name, contents, mode)
+        self.this.add_file(id, parent, name, contents, mode)
+        self.other.add_file(id, parent, name, contents, mode)
+        path = self.get_cset_path(parent, name)
+        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
+
+    def remove_file(self, id, base=False, this=False, other=False):
+        for option, tree in ((base, self.base), (this, self.this), 
+                             (other, self.other)):
+            if option:
+                tree.remove_file(id)
+            if other or base:
+                change = self.cset.entries[id].contents_change
+                if change is None:
+                    change = changeset.ReplaceContents(None, None)
+                    self.cset.entries[id].contents_change = change
+                    def create_file(tree):
+                        return changeset.FileCreate(tree.get_file(id).read())
+                    if not other:
+                        change.new_contents = create_file(self.other)
+                    if not base:
+                        change.old_contents = create_file(self.base)
+                else:
+                    assert isinstance(change, changeset.ReplaceContents)
+                if other:
+                    change.new_contents=None
+                if base:
+                    change.old_contents=None
+                if change.old_contents is None and change.new_contents is None:
+                    change = None
+
+
+    def add_dir(self, id, parent, name, mode):
+        path = self.get_cset_path(parent, name)
+        self.base.add_dir(id, parent, name, mode)
+        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
+        self.this.add_dir(id, parent, name, mode)
+        self.other.add_dir(id, parent, name, mode)
+
+
+    def change_name(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_name_tree(id, self.base, base)
+            self.cset.entries[id].name = base
+
+        if this is not None:
+            self.change_name_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_name_tree(id, self.other, other)
+            self.cset.entries[id].new_name = other
+
+    def change_parent(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_parent_tree(id, self.base, base)
+            self.cset.entries[id].parent = base
+            self.cset.entries[id].dir = self.cset.entries[base].path
+
+        if this is not None:
+            self.change_parent_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_parent_tree(id, self.other, other)
+            self.cset.entries[id].new_parent = other
+            self.cset.entries[id].new_dir = \
+                self.cset.entries[other].new_path
+
+    def change_contents(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_contents_tree(id, self.base, base)
+
+        if this is not None:
+            self.change_contents_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_contents_tree(id, self.other, other)
+
+        if base is not None or other is not None:
+            old_contents = file(self.base.full_path(id)).read()
+            new_contents = file(self.other.full_path(id)).read()
+            contents = changeset.ReplaceFileContents(old_contents, 
+                                                     new_contents)
+            self.cset.entries[id].contents_change = contents
+
+    def change_perms(self, id, base=None, this=None, other=None):
+        if base is not None:
+            self.change_perms_tree(id, self.base, base)
+
+        if this is not None:
+            self.change_perms_tree(id, self.this, this)
+
+        if other is not None:
+            self.change_perms_tree(id, self.other, other)
+
+        if base is not None or other is not None:
+            old_perms = os.stat(self.base.full_path(id)).st_mode &077
+            new_perms = os.stat(self.other.full_path(id)).st_mode &077
+            contents = changeset.ChangeUnixPermissions(old_perms, 
+                                                       new_perms)
+            self.cset.entries[id].metadata_change = contents
+
+    def change_name_tree(self, id, tree, name):
+        new_path = tree.child_path(self.cset.entries[id].parent, name)
+        tree.change_path(id, new_path)
+
+    def change_parent_tree(self, id, tree, parent):
+        new_path = tree.child_path(parent, self.cset.entries[id].name)
+        tree.change_path(id, new_path)
+
+    def change_contents_tree(self, id, tree, contents):
+        path = tree.full_path(id)
+        mode = os.stat(path).st_mode
+        file(path, "w").write(contents)
+        os.chmod(path, mode)
+
+    def change_perms_tree(self, id, tree, mode):
+        os.chmod(tree.full_path(id), mode)
+
+    def merge_changeset(self, merge_factory):
+        conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
+        return make_merge_changeset(self.cset, self.this, self.base,
+                                    self.other, conflict_handler,
+                                    merge_factory)
+
+    def apply_inv_change(self, inventory_change, orig_inventory):
+        orig_inventory_by_path = {}
+        for file_id, path in orig_inventory.iteritems():
+            orig_inventory_by_path[path] = file_id
+
+        def parent_id(file_id):
+            try:
+                parent_dir = os.path.dirname(orig_inventory[file_id])
+            except:
+                print file_id
+                raise
+            if parent_dir == "":
+                return None
+            return orig_inventory_by_path[parent_dir]
+        
+        def new_path(file_id):
+            if inventory_change.has_key(file_id):
+                return inventory_change[file_id]
+            else:
+                parent = parent_id(file_id)
+                if parent is None:
+                    return orig_inventory[file_id]
+                dirname = new_path(parent)
+                return os.path.join(dirname, orig_inventory[file_id])
+
+        new_inventory = {}
+        for file_id in orig_inventory.iterkeys():
+            path = new_path(file_id)
+            if path is None:
+                continue
+            new_inventory[file_id] = path
+
+        for file_id, path in inventory_change.iteritems():
+            if orig_inventory.has_key(file_id):
+                continue
+            new_inventory[file_id] = path
+        return new_inventory
+
+        
+
+    def apply_changeset(self, cset, conflict_handler=None, reverse=False):
+        inventory_change = changeset.apply_changeset(cset,
+                                                     self.this.inventory,
+                                                     self.this.dir,
+                                                     conflict_handler, reverse)
+        self.this.inventory =  self.apply_inv_change(inventory_change, 
+                                                     self.this.inventory)
+
+                    
+        
+
+        
+    def cleanup(self):
+        shutil.rmtree(self.dir)
+
+
+class MergeTest(unittest.TestCase):
+    def test_change_name(self):
+        """Test renames"""
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "hello1", 0755)
+        builder.change_name("1", other="name2")
+        builder.add_file("2", "0", "name3", "hello2", 0755)
+        builder.change_name("2", base="name4")
+        builder.add_file("3", "0", "name5", "hello3", 0755)
+        builder.change_name("3", this="name6")
+        cset = builder.merge_changeset(ApplyMerge3)
+        assert(cset.entries["2"].is_boring())
+        assert(cset.entries["1"].name == "name1")
+        assert(cset.entries["1"].new_name == "name2")
+        assert(cset.entries["3"].is_boring())
+        for tree in (builder.this, builder.other, builder.base):
+            assert(tree.dir != builder.dir and 
+                   tree.dir.startswith(builder.dir))
+            for path in tree.inventory.itervalues():
+                fullpath = tree.abs_path(path)
+                assert(fullpath.startswith(tree.dir))
+                assert(not path.startswith(tree.dir))
+                assert os.path.exists(fullpath)
+        builder.apply_changeset(cset)
+        builder.cleanup()
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "hello1", 0644)
+        builder.change_name("1", other="name2", this="name3")
+        self.assertRaises(changeset.RenameConflict, 
+                          builder.merge_changeset, ApplyMerge3)
+        builder.cleanup()
+        
+    def test_file_moves(self):
+        """Test moves"""
+        builder = MergeBuilder()
+        builder.add_dir("1", "0", "dir1", 0755)
+        builder.add_dir("2", "0", "dir2", 0755)
+        builder.add_file("3", "1", "file1", "hello1", 0644)
+        builder.add_file("4", "1", "file2", "hello2", 0644)
+        builder.add_file("5", "1", "file3", "hello3", 0644)
+        builder.change_parent("3", other="2")
+        assert(Inventory(builder.other.inventory).get_parent("3") == "2")
+        builder.change_parent("4", this="2")
+        assert(Inventory(builder.this.inventory).get_parent("4") == "2")
+        builder.change_parent("5", base="2")
+        assert(Inventory(builder.base.inventory).get_parent("5") == "2")
+        cset = builder.merge_changeset(ApplyMerge3)
+        for id in ("1", "2", "4", "5"):
+            assert(cset.entries[id].is_boring())
+        assert(cset.entries["3"].parent == "1")
+        assert(cset.entries["3"].new_parent == "2")
+        builder.apply_changeset(cset)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_dir("1", "0", "dir1", 0755)
+        builder.add_dir("2", "0", "dir2", 0755)
+        builder.add_dir("3", "0", "dir3", 0755)
+        builder.add_file("4", "1", "file1", "hello1", 0644)
+        builder.change_parent("4", other="2", this="3")
+        self.assertRaises(changeset.MoveConflict, 
+                          builder.merge_changeset, ApplyMerge3)
+        builder.cleanup()
+
+    def test_contents_merge(self):
+        """Test merge3 merging"""
+        self.do_contents_test(ApplyMerge3)
+
+    def test_contents_merge2(self):
+        """Test diff3 merging"""
+        self.do_contents_test(changeset.Diff3Merge)
+
+    def test_contents_merge3(self):
+        """Test diff3 merging"""
+        def backup_merge(file_id, base, other):
+            return BackupBeforeChange(ApplyMerge3(file_id, base, other))
+        builder = self.contents_test_success(backup_merge)
+        def backup_exists(file_id):
+            return os.path.exists(builder.this.full_path(file_id)+"~")
+        assert backup_exists("1")
+        assert backup_exists("2")
+        assert not backup_exists("3")
+        builder.cleanup()
+
+    def do_contents_test(self, merge_factory):
+        """Test merging with specified ContentsChange factory"""
+        builder = self.contents_test_success(merge_factory)
+        builder.cleanup()
+        self.contents_test_conflicts(merge_factory)
+
+    def contents_test_success(self, merge_factory):
+        from inspect import isclass
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4")
+        builder.add_file("2", "0", "name3", "text2", 0655)
+        builder.change_contents("2", base="text5")
+        builder.add_file("3", "0", "name5", "text3", 0744)
+        builder.add_file("4", "0", "name6", "text4", 0744)
+        builder.remove_file("4", base=True)
+        assert not builder.cset.entries["4"].is_boring()
+        builder.change_contents("3", this="text6")
+        cset = builder.merge_changeset(merge_factory)
+        assert(cset.entries["1"].contents_change is not None)
+        if isclass(merge_factory):
+            assert(isinstance(cset.entries["1"].contents_change,
+                          merge_factory))
+            assert(isinstance(cset.entries["2"].contents_change,
+                          merge_factory))
+        assert(cset.entries["3"].is_boring())
+        assert(cset.entries["4"].is_boring())
+        builder.apply_changeset(cset)
+        assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
+        assert(file(builder.this.full_path("2"), "rb").read() == "text2" )
+        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
+        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
+        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
+        return builder
+
+    def contents_test_conflicts(self, merge_factory):
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", this="text3")
+        cset = builder.merge_changeset(merge_factory)
+        self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
+                          cset)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", base="text3")
+        builder.remove_file("1", base=True)
+        self.assertRaises(changeset.NewContentsConflict,
+                          builder.merge_changeset, merge_factory)
+        builder.cleanup()
+
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_contents("1", other="text4", base="text3")
+        builder.remove_file("1", this=True)
+        self.assertRaises(changeset.MissingForMerge, builder.merge_changeset, 
+                          merge_factory)
+        builder.cleanup()
+
+    def test_perms_merge(self):
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_perms("1", other=0655)
+        builder.add_file("2", "0", "name2", "text2", 0755)
+        builder.change_perms("2", base=0655)
+        builder.add_file("3", "0", "name3", "text3", 0755)
+        builder.change_perms("3", this=0655)
+        cset = builder.merge_changeset(ApplyMerge3)
+        assert(cset.entries["1"].metadata_change is not None)
+        assert(isinstance(cset.entries["1"].metadata_change,
+                          PermissionsMerge))
+        assert(isinstance(cset.entries["2"].metadata_change,
+                          PermissionsMerge))
+        assert(cset.entries["3"].is_boring())
+        builder.apply_changeset(cset)
+        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0655)
+        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0755)
+        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0655)
+        builder.cleanup();
+        builder = MergeBuilder()
+        builder.add_file("1", "0", "name1", "text1", 0755)
+        builder.change_perms("1", other=0655, base=0555)
+        cset = builder.merge_changeset(ApplyMerge3)
+        self.assertRaises(changeset.MergePermissionConflict, 
+                     builder.apply_changeset, cset)
+        builder.cleanup()
+
+def test():        
+    changeset_suite = unittest.makeSuite(MergeTest, 'test_')
+    runner = unittest.TextTestRunner()
+    runner.run(changeset_suite)
+        
+if __name__ == "__main__":
+    test()

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-08-30 05:30:43 +0000
+++ bzrlib/missing.py	2005-08-12 15:37:01 +0000
@@ -11,6 +11,24 @@
     from sets import Set as set
 
 
+def get_parent(branch):
+    """Get the last pull/push location.
+
+    TODO: This should probably be part of a Branch object.
+    """
+    import errno
+    _locs = ['parent', 'pull', 'x-pull']
+    loc = None
+    for l in _locs:
+        try:
+            stored_loc = branch.controlfile(l, 'rb').read().strip('\n')
+        except IOError, e:
+            if e.errno != errno.ENOENT:
+                raise
+        else:
+            return stored_loc
+
+
 def show_missing(br_local, br_remote, verbose=False, quiet=False):
     """Show the revisions which exist in br_remote, that 
     do not exist in br_local.

=== removed file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2005-09-01 11:27:20 +0000
+++ bzrlib/msgeditor.py	1970-01-01 00:00:00 +0000
@@ -1,122 +0,0 @@
-# Bazaar-NG -- distributed version control
-
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Commit message editor support."""
-
-import os
-from bzrlib.errors import BzrError
-
-def _get_editor():
-    """Return a sequence of possible editor binaries for the current platform"""
-    from bzrlib.osutils import _read_config_value
-    
-    e = _read_config_value("editor")
-    if e is not None:
-        yield e
-        
-    if os.name == "windows":
-        yield "notepad.exe"
-    elif os.name == "posix":
-        try:
-            yield os.environ["EDITOR"]
-        except KeyError:
-            yield "/usr/bin/vi"
-
-
-def _run_editor(filename):
-    """Try to execute an editor to edit the commit message."""
-    for e in _get_editor():
-        edargs = e.split(' ')
-        x = os.spawnvp(os.P_WAIT, edargs[0],
-                       edargs + [filename])
-        if x == 0:
-            return True
-        elif x == 127:
-            continue
-        else:
-            break
-    raise BzrError("Could not start any editor. "
-                   "Please specify $EDITOR or use ~/.bzr.conf/editor")
-                          
-
-def edit_commit_message(infotext, ignoreline=None):
-    """Let the user edit a commit message in a temp file.
-
-    This is run if they don't give a message or
-    message-containing file on the command line.
-
-    infotext:
-        Text to be displayed at bottom of message for
-        the user's reference; currently similar to
-        'bzr status'.
-    """
-    import tempfile
-    
-    if ignoreline is None:
-        ignoreline = "-- This line and the following will be ignored --"
-        
-    try:
-        tmp_fileno, msgfilename = tempfile.mkstemp()
-        msgfile = os.close(tmp_fileno)
-        if infotext is not None and infotext != "":
-            hasinfo = True
-            msgfile = file(msgfilename, "w")
-            msgfile.write("\n\n%s\n\n%s" % (ignoreline, infotext))
-            msgfile.close()
-        else:
-            hasinfo = False
-
-        if not _run_editor(msgfilename):
-            return None
-        
-        started = False
-        msg = []
-        lastline, nlines = 0, 0
-        for line in file(msgfilename, "r"):
-            stripped_line = line.strip()
-            # strip empty line before the log message starts
-            if not started:
-                if stripped_line != "":
-                    started = True
-                else:
-                    continue
-            # check for the ignore line only if there
-            # is additional information at the end
-            if hasinfo and stripped_line == ignoreline:
-                break
-            nlines += 1
-            # keep track of the last line that had some content
-            if stripped_line != "":
-                lastline = nlines
-            msg.append(line)
-            
-        if len(msg) == 0:
-            return None
-        # delete empty lines at the end
-        del msg[lastline:]
-        # add a newline at the end, if needed
-        if not msg[-1].endswith("\n"):
-            return "%s%s" % ("".join(msg), "\n")
-        else:
-            return "".join(msg)
-    finally:
-        # delete the msg file in any case
-        try: os.unlink(msgfilename)
-        except IOError: pass
-

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2005-09-01 11:19:08 +0000
+++ bzrlib/osutils.py	2005-08-18 05:52:29 +0000
@@ -492,3 +492,87 @@
         raise
 
 
+def _get_editor():
+    """Return a sequence of possible editor binaries for the current platform"""
+    e = _read_config_value("editor")
+    if e is not None:
+        yield e
+        
+    if os.name == "windows":
+        yield "notepad.exe"
+    elif os.name == "posix":
+        try:
+            yield os.environ["EDITOR"]
+        except KeyError:
+            yield "/usr/bin/vi"
+
+
+def _run_editor(filename):
+    """Try to execute an editor to edit the commit message. Returns True on success,
+    False on failure"""
+    for e in _get_editor():
+        x = os.spawnvp(os.P_WAIT, e, (e, filename))
+        if x == 0:
+            return True
+        elif x == 127:
+            continue
+        else:
+            break
+    raise BzrError("Could not start any editor. Please specify $EDITOR or use ~/.bzr.conf/editor")
+    return False
+                          
+
+def get_text_message(infotext, ignoreline = "default"):
+    import tempfile
+    
+    if ignoreline == "default":
+        ignoreline = "-- This line and the following will be ignored --"
+        
+    try:
+        tmp_fileno, msgfilename = tempfile.mkstemp()
+        msgfile = os.close(tmp_fileno)
+        if infotext is not None and infotext != "":
+            hasinfo = True
+            msgfile = file(msgfilename, "w")
+            msgfile.write("\n\n%s\n\n%s" % (ignoreline, infotext))
+            msgfile.close()
+        else:
+            hasinfo = False
+
+        if not _run_editor(msgfilename):
+            return None
+        
+        started = False
+        msg = []
+        lastline, nlines = 0, 0
+        for line in file(msgfilename, "r"):
+            stripped_line = line.strip()
+            # strip empty line before the log message starts
+            if not started:
+                if stripped_line != "":
+                    started = True
+                else:
+                    continue
+            # check for the ignore line only if there
+            # is additional information at the end
+            if hasinfo and stripped_line == ignoreline:
+                break
+            nlines += 1
+            # keep track of the last line that had some content
+            if stripped_line != "":
+                lastline = nlines
+            msg.append(line)
+            
+        if len(msg) == 0:
+            return None
+        # delete empty lines at the end
+        del msg[lastline:]
+        # add a newline at the end, if needed
+        if not msg[-1].endswith("\n"):
+            return "%s%s" % ("".join(msg), "\n")
+        else:
+            return "".join(msg)
+    finally:
+        # delete the msg file in any case
+        try: os.unlink(msgfilename)
+        except IOError: pass

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2005-08-29 05:13:54 +0000
+++ bzrlib/plugin.py	2005-08-17 02:06:19 +0000
@@ -116,9 +116,8 @@
                 finally:
                     if plugin_info[0] is not None:
                         plugin_info[0].close()
-
-                mutter('loaded succesfully')
-            except:
+            except Exception, e:
                 log_error('Unable to load plugin %r from %r' % (name, d))
+                log_error(str(e))
                 log_exception()
 

=== modified file 'bzrlib/plugins/__init__.py'
--- bzrlib/plugins/__init__.py	2005-08-30 03:29:32 +0000
+++ bzrlib/plugins/__init__.py	2005-08-17 02:06:19 +0000
@@ -1,1 +0,0 @@
-"""Null placeholder plugin"""

=== added file 'bzrlib/plugins/checkperms'
--- bzrlib/plugins/checkperms	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/checkperms	2005-06-27 05:14:15 +0000
@@ -0,0 +1,5 @@
+#! /bin/sh -ex
+
+root=`bzr root`
+
+find $root \! -perm -0444 
\ No newline at end of file

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2005-08-25 12:46:42 +0000
+++ bzrlib/progress.py	2005-07-22 23:06:25 +0000
@@ -94,22 +94,7 @@
         self.show_eta = show_eta
         self.show_bar = show_bar
         self.show_count = show_count
-
-
-
-class DummyProgress(_BaseProgressBar):
-    """Progress-bar standin that does nothing.
-
-    This can be used as the default argument for methods that
-    take an optional progress indicator."""
-    def tick(self):
-        pass
-
-    def update(self, msg=None, current=None, total=None):
-        pass
-
-    def clear(self):
-        pass
+        
         
     
 class DotsProgressBar(_BaseProgressBar):

=== modified file 'bzrlib/remotebranch.py'
--- bzrlib/remotebranch.py	2005-09-05 09:27:11 +0000
+++ bzrlib/remotebranch.py	2005-08-17 02:06:19 +0000
@@ -36,9 +36,9 @@
 # breaks keep-alive -- sucks!
 
 
-ENABLE_URLGRABBER = False
+ENABLE_URLGRABBER = True
 
-from bzrlib.errors import BzrError, NoSuchRevision
+from bzrlib.errors import BzrError
 
 class GetFailed(BzrError):
     def __init__(self, url, status):
@@ -155,11 +155,9 @@
 
     def get_revision(self, revision_id):
         from bzrlib.revision import Revision
-        try:
-            revf = self.revision_store[revision_id]
-        except KeyError:
-            raise NoSuchRevision(self, revision_id)
-        r = serializer_v4.read_revision(revf)
+        from bzrlib.xml import unpack_xml
+        revf = self.revision_store[revision_id]
+        r = unpack_xml(Revision, revf)
         if r.revision_id != revision_id:
             raise BzrCheckError('revision stored as {%s} actually contains {%s}'
                                 % (revision_id, r.revision_id))

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2005-09-06 07:26:13 +0000
+++ bzrlib/revision.py	2005-08-05 19:23:12 +0000
@@ -70,21 +70,90 @@
     def __repr__(self):
         return "<Revision id %s>" % self.revision_id
 
-    def __eq__(self, other):
-        if not isinstance(other, Revision):
-            return False
-        return (self.inventory_id == other.inventory_id
-                and self.inventory_sha1 == other.inventory_sha1
-                and self.revision_id == other.revision_id
-                and self.timestamp == other.timestamp
-                and self.message == other.message
-                and self.timezone == other.timezone
-                and self.committer == other.committer)
-
-    def __ne__(self, other):
-        return not self.__eq__(other)
-
-        
+        
+    def to_element(self):
+        from bzrlib.xml import Element, SubElement
+        
+        root = Element('revision',
+                       committer = self.committer,
+                       timestamp = '%.9f' % self.timestamp,
+                       revision_id = self.revision_id,
+                       inventory_id = self.inventory_id,
+                       inventory_sha1 = self.inventory_sha1,
+                       )
+        if self.timezone:
+            root.set('timezone', str(self.timezone))
+        root.text = '\n'
+        
+        msg = SubElement(root, 'message')
+        msg.text = self.message
+        msg.tail = '\n'
+
+        if self.parents:
+            pelts = SubElement(root, 'parents')
+            pelts.tail = pelts.text = '\n'
+            for rr in self.parents:
+                assert isinstance(rr, RevisionReference)
+                p = SubElement(pelts, 'revision_ref')
+                p.tail = '\n'
+                assert rr.revision_id
+                p.set('revision_id', rr.revision_id)
+                if rr.revision_sha1:
+                    p.set('revision_sha1', rr.revision_sha1)
+
+        return root
+
+
+    def from_element(cls, elt):
+        return unpack_revision(elt)
+
+    from_element = classmethod(from_element)
+
+
+
+def unpack_revision(elt):
+    """Convert XML element into Revision object."""
+    # <changeset> is deprecated...
+    if elt.tag not in ('revision', 'changeset'):
+        raise bzrlib.errors.BzrError("unexpected tag in revision file: %r" % elt)
+
+    rev = Revision(committer = elt.get('committer'),
+                   timestamp = float(elt.get('timestamp')),
+                   revision_id = elt.get('revision_id'),
+                   inventory_id = elt.get('inventory_id'),
+                   inventory_sha1 = elt.get('inventory_sha1')
+                   )
+
+    precursor = elt.get('precursor')
+    precursor_sha1 = elt.get('precursor_sha1')
+
+    pelts = elt.find('parents')
+
+    if pelts:
+        for p in pelts:
+            assert p.tag == 'revision_ref', \
+                   "bad parent node tag %r" % p.tag
+            rev_ref = RevisionReference(p.get('revision_id'),
+                                        p.get('revision_sha1'))
+            rev.parents.append(rev_ref)
+
+        if precursor:
+            # must be consistent
+            prec_parent = rev.parents[0].revision_id
+            assert prec_parent == precursor
+    elif precursor:
+        # revisions written prior to 0.0.5 have a single precursor
+        # give as an attribute
+        rev_ref = RevisionReference(precursor, precursor_sha1)
+        rev.parents.append(rev_ref)
+
+    v = elt.get('timezone')
+    rev.timezone = v and int(v)
+
+    rev.message = elt.findtext('message') # text of <message>
+    return rev
+
+
 
 REVISION_ID_RE = None
 
@@ -107,19 +176,12 @@
     behaves like Branch's.
     """
 
-    for ancestor_id, distance in iter_ancestors(revision_id, revision_source):
-        if ancestor_id == candidate_id:
-            return True
-    return False
-
-def iter_ancestors(revision_id, revision_source, only_present=False):
     ancestors = (revision_id,)
-    distance = 0
     while len(ancestors) > 0:
         new_ancestors = []
         for ancestor in ancestors:
-            if not only_present:
-                yield ancestor, distance
+            if ancestor == candidate_id:
+                return True
             try:
                 revision = revision_source.get_revision(ancestor)
             except bzrlib.errors.NoSuchRevision, e:
@@ -127,71 +189,11 @@
                     raise 
                 else:
                     continue
-            if only_present:
-                yield ancestor, distance
             new_ancestors.extend([p.revision_id for p in revision.parents])
         ancestors = new_ancestors
-        distance += 1
-
-
-def find_present_ancestors(revision_id, revision_source):
-    """Return the ancestors of a revision present in a branch.
-
-    It's possible that a branch won't have the complete ancestry of
-    one of its revisions.  
-
-    """
-    found_ancestors = {}
-    anc_iter = enumerate(iter_ancestors(revision_id, revision_source,
-                         only_present=True))
-    for anc_order, (anc_id, anc_distance) in anc_iter:
-        if not found_ancestors.has_key(anc_id):
-            found_ancestors[anc_id] = (anc_order, anc_distance)
-    return found_ancestors
-    
-
-def __get_closest(intersection):
-    intersection.sort()
-    matches = [] 
-    for entry in intersection:
-        if entry[0] == intersection[0][0]:
-            matches.append(entry[2])
-    return matches
-
-
-def common_ancestor(revision_a, revision_b, revision_source):
-    """Find the ancestor common to both revisions that is closest to both.
-    """
-    from bzrlib.trace import mutter
-    a_ancestors = find_present_ancestors(revision_a, revision_source)
-    b_ancestors = find_present_ancestors(revision_b, revision_source)
-    a_intersection = []
-    b_intersection = []
-    # a_order is used as a tie-breaker when two equally-good bases are found
-    for revision, (a_order, a_distance) in a_ancestors.iteritems():
-        if b_ancestors.has_key(revision):
-            a_intersection.append((a_distance, a_order, revision))
-            b_intersection.append((b_ancestors[revision][1], a_order, revision))
-    mutter("a intersection: %r" % a_intersection)
-    mutter("b intersection: %r" % b_intersection)
-
-    a_closest = __get_closest(a_intersection)
-    if len(a_closest) == 0:
-        return None
-    b_closest = __get_closest(b_intersection)
-    assert len(b_closest) != 0
-    mutter ("a_closest %r" % a_closest)
-    mutter ("b_closest %r" % b_closest)
-    if a_closest[0] in b_closest:
-        return a_closest[0]
-    elif b_closest[0] in a_closest:
-        return b_closest[0]
-    else:
-        raise bzrlib.errors.AmbiguousBase((a_closest[0], b_closest[0]))
-    return a_closest[0]
+
 
 class MultipleRevisionSources(object):
-    """Proxy that looks in multiple branches for revisions."""
     def __init__(self, *args):
         object.__init__(self)
         assert len(args) != 0
@@ -204,59 +206,3 @@
             except bzrlib.errors.NoSuchRevision, e:
                 pass
         raise e
-
-def get_intervening_revisions(ancestor_id, rev_id, rev_source, 
-                              revision_history=None):
-    """Find the longest line of descent from maybe_ancestor to revision.
-    Revision history is followed where possible.
-
-    If ancestor_id == rev_id, list will be empty.
-    Otherwise, rev_id will be the last entry.  ancestor_id will never appear.
-    If ancestor_id is not an ancestor, NotAncestor will be thrown
-    """
-    [rev_source.get_revision(r) for r in (ancestor_id, rev_id)]
-    if ancestor_id == rev_id:
-        return []
-    def historical_lines(line):
-        """Return a tuple of historical/non_historical lines, for sorting.
-        The non_historical count is negative, since non_historical lines are
-        a bad thing.
-        """
-        good_count = 0
-        bad_count = 0
-        for revision in line:
-            if revision in revision_history:
-                good_count += 1
-            else:
-                bad_count -= 1
-        return good_count, bad_count
-    active = [[rev_id]]
-    successful_lines = []
-    while len(active) > 0:
-        new_active = []
-        for line in active:
-            parent_ids = [p.revision_id for p in 
-                          rev_source.get_revision(line[-1]).parents]
-            for parent in parent_ids:
-                line_copy = line[:]
-                if parent == ancestor_id:
-                    successful_lines.append(line_copy)
-                else:
-                    line_copy.append(parent)
-                    new_active.append(line_copy)
-        active = new_active
-    if len(successful_lines) == 0:
-        raise bzrlib.errors.NotAncestor(rev_id, ancestor_id)
-    for line in successful_lines:
-        line.reverse()
-    if revision_history is not None:
-        by_historical_lines = []
-        for line in successful_lines:
-            count = historical_lines(line)
-            by_historical_lines.append((count, line))
-        by_historical_lines.sort()
-        if by_historical_lines[-1][0][0] > 0:
-            return by_historical_lines[-1][1]
-    assert len(successful_lines)
-    successful_lines.sort(cmp, len)
-    return successful_lines[-1]

=== removed file 'bzrlib/selftest/TestUtil.py'
--- bzrlib/selftest/TestUtil.py	2005-08-24 08:34:10 +0000
+++ bzrlib/selftest/TestUtil.py	1970-01-01 00:00:00 +0000
@@ -1,80 +0,0 @@
-# Copyright (c) 2004 Canonical Limited
-#       Author: Robert Collins <robert.collins@canonical.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-import sys
-import logging
-import unittest
-
-
-class LogCollector(logging.Handler):
-    def __init__(self):
-        logging.Handler.__init__(self)
-        self.records=[]
-    def emit(self, record):
-        self.records.append(record.getMessage())
-
-
-def makeCollectingLogger():
-    """I make a logger instance that collects its logs for programmatic analysis
-    -> (logger, collector)"""
-    logger=logging.Logger("collector")
-    handler=LogCollector()
-    handler.setFormatter(logging.Formatter("%(levelname)s: %(message)s"))
-    logger.addHandler(handler)
-    return logger, handler
-
-
-def visitTests(suite, visitor):
-    """A foreign method for visiting the tests in a test suite."""
-    for test in suite._tests:
-        #Abusing types to avoid monkey patching unittest.TestCase. 
-        # Maybe that would be better?
-        try:
-            test.visit(visitor)
-        except AttributeError:
-            if isinstance(test, unittest.TestCase):
-                visitor.visitCase(test)
-            elif isinstance(test, unittest.TestSuite):
-                visitor.visitSuite(test)
-                visitTests(test, visitor)
-            else:
-                print "unvisitable non-unittest.TestCase element %r (%r)" % (test, test.__class__)
-    
-
-class TestSuite(unittest.TestSuite):
-    """I am an extended TestSuite with a visitor interface.
-    This is primarily to allow filtering of tests - and suites or
-    more in the future. An iterator of just tests wouldn't scale..."""
-
-    def visit(self, visitor):
-        """visit the composite. Visiting is depth-first.
-        current callbacks are visitSuite and visitCase."""
-        visitor.visitSuite(self)
-        visitTests(self, visitor)
-
-
-class TestLoader(unittest.TestLoader):
-    """Custome TestLoader to set the right TestSuite class."""
-    suiteClass = TestSuite
-
-class TestVisitor(object):
-    """A visitor for Tests"""
-    def visitSuite(self, aTestSuite):
-        pass
-    def visitCase(self, aTestCase):
-        pass

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-09-05 09:11:03 +0000
+++ bzrlib/selftest/__init__.py	2005-08-04 21:39:23 +0000
@@ -15,284 +15,22 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-import logging
-import unittest
-import tempfile
-import os
-import sys
-import subprocess
-
-from testsweet import run_suite
+from testsweet import TestBase, run_suite, InTempDir
 import bzrlib.commands
 
-import bzrlib.trace
-import bzrlib.fetch
-
-
 MODULES_TO_TEST = []
 MODULES_TO_DOCTEST = []
 
-from logging import debug, warning, error
-
-class CommandFailed(Exception):
-    pass
-
-class TestCase(unittest.TestCase):
-    """Base class for bzr unit tests.
-    
-    Tests that need access to disk resources should subclass 
-    TestCaseInTempDir not TestCase.
-
-    Error and debug log messages are redirected from their usual
-    location into a temporary file, the contents of which can be
-    retrieved by _get_log().
-       
-    There are also convenience functions to invoke bzr's command-line
-    routine, and to build and check bzr trees."""
-
-    BZRPATH = 'bzr'
-
-    def setUp(self):
-        # this replaces the default testsweet.TestCase; we don't want logging changed
-        unittest.TestCase.setUp(self)
-        bzrlib.trace.disable_default_logging()
-        self._enable_file_logging()
-
-
-    def _enable_file_logging(self):
-        fileno, name = tempfile.mkstemp(suffix='.log', prefix='testbzr')
-
-        self._log_file = os.fdopen(fileno, 'w+')
-
-        hdlr = logging.StreamHandler(self._log_file)
-        hdlr.setLevel(logging.DEBUG)
-        hdlr.setFormatter(logging.Formatter('%(levelname)4.4s  %(message)s'))
-        logging.getLogger('').addHandler(hdlr)
-        logging.getLogger('').setLevel(logging.DEBUG)
-        self._log_hdlr = hdlr
-        debug('opened log file %s', name)
-        
-        self._log_file_name = name
-
-        
-    def tearDown(self):
-        logging.getLogger('').removeHandler(self._log_hdlr)
-        bzrlib.trace.enable_default_logging()
-        logging.debug('%s teardown', self.id())
-        self._log_file.close()
-        unittest.TestCase.tearDown(self)
-
-
-    def log(self, *args):
-        logging.debug(*args)
-
-    def _get_log(self):
-        """Return as a string the log for this test"""
-        return open(self._log_file_name).read()
-
+
+class BzrTestBase(InTempDir):
+    """bzr-specific test base class"""
     def run_bzr(self, *args, **kwargs):
-        """Invoke bzr, as if it were run from the command line.
-
-        This should be the main method for tests that want to exercise the
-        overall behavior of the bzr application (rather than a unit test
-        or a functional test of the library.)
-
-        Much of the old code runs bzr by forking a new copy of Python, but
-        that is slower, harder to debug, and generally not necessary.
-        """
         retcode = kwargs.get('retcode', 0)
-        result = self.apply_redirected(None, None, None,
-                                       bzrlib.commands.run_bzr, args)
-        self.assertEquals(result, retcode)
-        
-        
-    def check_inventory_shape(self, inv, shape):
-        """
-        Compare an inventory to a list of expected names.
-
-        Fail if they are not precisely equal.
-        """
-        extras = []
-        shape = list(shape)             # copy
-        for path, ie in inv.entries():
-            name = path.replace('\\', '/')
-            if ie.kind == 'dir':
-                name = name + '/'
-            if name in shape:
-                shape.remove(name)
-            else:
-                extras.append(name)
-        if shape:
-            self.fail("expected paths not found in inventory: %r" % shape)
-        if extras:
-            self.fail("unexpected paths found in inventory: %r" % extras)
-
-    def apply_redirected(self, stdin=None, stdout=None, stderr=None,
-                         a_callable=None, *args, **kwargs):
-        """Call callable with redirected std io pipes.
-
-        Returns the return code."""
-        from StringIO import StringIO
-        if not callable(a_callable):
-            raise ValueError("a_callable must be callable.")
-        if stdin is None:
-            stdin = StringIO("")
-        if stdout is None:
-            stdout = self._log_file
-        if stderr is None:
-            stderr = self._log_file
-        real_stdin = sys.stdin
-        real_stdout = sys.stdout
-        real_stderr = sys.stderr
-        try:
-            sys.stdout = stdout
-            sys.stderr = stderr
-            sys.stdin = stdin
-            return a_callable(*args, **kwargs)
-        finally:
-            sys.stdout = real_stdout
-            sys.stderr = real_stderr
-            sys.stdin = real_stdin
-
-
-BzrTestBase = TestCase
-
-     
-class TestCaseInTempDir(TestCase):
-    """Derived class that runs a test within a temporary directory.
-
-    This is useful for tests that need to create a branch, etc.
-
-    The directory is created in a slightly complex way: for each
-    Python invocation, a new temporary top-level directory is created.
-    All test cases create their own directory within that.  If the
-    tests complete successfully, the directory is removed.
-
-    InTempDir is an old alias for FunctionalTestCase.
-    """
-
-    TEST_ROOT = None
-    _TEST_NAME = 'test'
-    OVERRIDE_PYTHON = 'python'
-
-    def check_file_contents(self, filename, expect):
-        self.log("check contents of file %s" % filename)
-        contents = file(filename, 'r').read()
-        if contents != expect:
-            self.log("expected: %r" % expect)
-            self.log("actually: %r" % contents)
-            self.fail("contents of %s not as expected")
-
-    def _make_test_root(self):
-        import os
-        import shutil
-        import tempfile
-        
-        if TestCaseInTempDir.TEST_ROOT is not None:
-            return
-        TestCaseInTempDir.TEST_ROOT = os.path.abspath(
-                                 tempfile.mkdtemp(suffix='.tmp',
-                                                  prefix=self._TEST_NAME + '-',
-                                                  dir=os.curdir))
-    
-        # make a fake bzr directory there to prevent any tests propagating
-        # up onto the source directory's real branch
-        os.mkdir(os.path.join(TestCaseInTempDir.TEST_ROOT, '.bzr'))
-
-    def setUp(self):
-        super(TestCaseInTempDir, self).setUp()
-        import os
-        self._make_test_root()
-        self._currentdir = os.getcwdu()
-        self.test_dir = os.path.join(self.TEST_ROOT, self.id())
-        os.mkdir(self.test_dir)
-        os.chdir(self.test_dir)
-        
-    def tearDown(self):
-        import os
-        os.chdir(self._currentdir)
-        super(TestCaseInTempDir, self).tearDown()
-
-    def _formcmd(self, cmd):
-        if isinstance(cmd, basestring):
-            cmd = cmd.split()
-        if cmd[0] == 'bzr':
-            cmd[0] = self.BZRPATH
-            if self.OVERRIDE_PYTHON:
-                cmd.insert(0, self.OVERRIDE_PYTHON)
-        self.log('$ %r' % cmd)
-        return cmd
-
-    def runcmd(self, cmd, retcode=0):
-        """Run one command and check the return code.
-
-        Returns a tuple of (stdout,stderr) strings.
-
-        If a single string is based, it is split into words.
-        For commands that are not simple space-separated words, please
-        pass a list instead."""
-        cmd = self._formcmd(cmd)
-        self.log('$ ' + ' '.join(cmd))
-        actual_retcode = subprocess.call(cmd, stdout=self._log_file,
-                                         stderr=self._log_file)
-        if retcode != actual_retcode:
-            raise CommandFailed("test failed: %r returned %d, expected %d"
-                                % (cmd, actual_retcode, retcode))
-
-    def backtick(self, cmd, retcode=0):
-        """Run a command and return its output"""
-        cmd = self._formcmd(cmd)
-        child = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=self._log_file)
-        outd, errd = child.communicate()
-        self.log(outd)
-        actual_retcode = child.wait()
-
-        outd = outd.replace('\r', '')
-
-        if retcode != actual_retcode:
-            raise CommandFailed("test failed: %r returned %d, expected %d"
-                                % (cmd, actual_retcode, retcode))
-
-        return outd
-
-
-
-    def build_tree(self, shape):
-        """Build a test tree according to a pattern.
-
-        shape is a sequence of file specifications.  If the final
-        character is '/', a directory is created.
-
-        This doesn't add anything to a branch.
-        """
-        # XXX: It's OK to just create them using forward slashes on windows?
-        import os
-        for name in shape:
-            assert isinstance(name, basestring)
-            if name[-1] == '/':
-                os.mkdir(name[:-1])
-            else:
-                f = file(name, 'wt')
-                print >>f, "contents of", name
-                f.close()
-                
-
-
-class MetaTestLog(TestCase):
-    def test_logging(self):
-        """Test logs are captured when a test fails."""
-        logging.info('an info message')
-        warning('something looks dodgy...')
-        logging.debug('hello, test is running')
-        ##assert 0
-
-
-def selftest(verbose=False, pattern=".*"):
-    return run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern)
-
-
-def test_suite():
-    from bzrlib.selftest.TestUtil import TestLoader, TestSuite
+        self.assertEquals(bzrlib.commands.run_bzr(args), retcode)
+        
+
+def selftest(verbose=False):
+    from unittest import TestLoader, TestSuite
     import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
     import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
     from doctest import DocTestSuite
@@ -300,16 +38,14 @@
     import shutil
     import time
     import sys
+    import unittest
 
     global MODULES_TO_TEST, MODULES_TO_DOCTEST
 
     testmod_names = \
-                  ['bzrlib.selftest.MetaTestLog',
-                   'bzrlib.selftest.test_parent',
+                  ['bzrlib.selftest.whitebox',
+                   'bzrlib.selftest.versioning',
                    'bzrlib.selftest.testinv',
-                   'bzrlib.selftest.testfetch',
-                   'bzrlib.selftest.versioning',
-                   'bzrlib.selftest.whitebox',
                    'bzrlib.selftest.testmerge3',
                    'bzrlib.selftest.testhashcache',
                    'bzrlib.selftest.teststatus',
@@ -318,30 +54,42 @@
                    'bzrlib.selftest.testrevisionnamespaces',
                    'bzrlib.selftest.testbranch',
                    'bzrlib.selftest.testrevision',
-                   'bzrlib.selftest.test_merge_core',
-                   'bzrlib.selftest.test_smart_add',
+                   'bzrlib.merge_core',
                    'bzrlib.selftest.testdiff',
-                   'bzrlib.selftest.test_xml',
-                   'bzrlib.fetch',
-                   'bzrlib.selftest.teststore',
                    ]
 
+    # XXX: should also test bzrlib.merge_core, but they seem to be out
+    # of date with the code.
+
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,
               bzrlib.osutils, bzrlib.commands, bzrlib.merge3):
         if m not in MODULES_TO_DOCTEST:
             MODULES_TO_DOCTEST.append(m)
 
-    TestCase.BZRPATH = os.path.join(os.path.realpath(os.path.dirname(bzrlib.__path__[0])), 'bzr')
-    print '%-30s %s' % ('bzr binary', TestCase.BZRPATH)
+    
+    TestBase.BZRPATH = os.path.join(os.path.realpath(os.path.dirname(bzrlib.__path__[0])), 'bzr')
+    print '%-30s %s' % ('bzr binary', TestBase.BZRPATH)
+
     print
+
     suite = TestSuite()
+
     suite.addTest(TestLoader().loadTestsFromNames(testmod_names))
+
     for m in MODULES_TO_TEST:
          suite.addTest(TestLoader().loadTestsFromModule(m))
+
     for m in (MODULES_TO_DOCTEST):
         suite.addTest(DocTestSuite(m))
+
     for p in bzrlib.plugin.all_plugins:
         if hasattr(p, 'test_suite'):
             suite.addTest(p.test_suite())
-    return suite
+
+    import bzrlib.merge_core
+    suite.addTest(unittest.makeSuite(bzrlib.merge_core.MergeTest, 'test_'))
+
+    return run_suite(suite, 'testbzr', verbose=verbose)
+
+
 

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/blackbox.py	2005-08-18 04:25:42 +0000
@@ -28,13 +28,19 @@
 
 import sys
 
-from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
-from bzrlib.branch import Branch
-from bzrlib.commands import run_bzr
-
-
-class ExternalBase(TestCaseInTempDir):
+from bzrlib.selftest import TestBase, InTempDir, BzrTestBase
+
+
+
+class ExternalBase(InTempDir):
     def runbzr(self, args, retcode=0,backtick=False):
+        try:
+            import shutil
+            from subprocess import call
+        except ImportError, e:
+            _need_subprocess()
+            raise
+
         if isinstance(args, basestring):
             args = args.split()
 
@@ -46,19 +52,76 @@
                            retcode=retcode)
 
 
-class TestCommands(ExternalBase):
-
-    def test_help_commands(self):
+
+class MvCommand(BzrTestBase):
+    def runbzr(self):
+        """Test two modes of operation for mv"""
+        b = Branch('.', init=True)
+        self.build_tree(['a', 'c', 'subdir/'])
+        self.run_bzr('mv', 'a', 'b')
+        self.run_bzr('mv', 'b', 'subdir')
+        self.run_bzr('mv', 'subdir/b', 'a')
+        self.run_bzr('mv', 'a', 'b', 'subdir')
+        self.run_bzr('mv', 'subdir/a', 'subdir/newa')
+
+
+
+class TestVersion(BzrTestBase):
+    """Check output from version command and master option is reasonable"""
+    def runTest(self):
+        # output is intentionally passed through to stdout so that we
+        # can see the version being tested
+        from cStringIO import StringIO
+        save_out = sys.stdout
+        try:
+            sys.stdout = tmp_out = StringIO()
+            
+            self.run_bzr('version')
+        finally:
+            sys.stdout = save_out
+
+        output = tmp_out.getvalue()
+        self.log('bzr version output:')
+        self.log(output)
+        
+        self.assert_(output.startswith('bzr (bazaar-ng) '))
+        self.assertNotEqual(output.index('Canonical'), -1)
+
+        # make sure --version is consistent
+        try:
+            sys.stdout = tmp_out = StringIO()
+            
+            self.run_bzr('--version')
+        finally:
+            sys.stdout = save_out
+
+        self.log('bzr --version output:')
+        self.log(tmp_out.getvalue())
+
+        self.assertEquals(output, tmp_out.getvalue())
+
+
+        
+
+
+class HelpCommands(ExternalBase):
+    def runTest(self):
         self.runbzr('--help')
         self.runbzr('help')
         self.runbzr('help commands')
         self.runbzr('help help')
         self.runbzr('commit -h')
 
-    def test_init_branch(self):
+
+class InitBranch(ExternalBase):
+    def runTest(self):
+        import os
         self.runbzr(['init'])
 
-    def test_whoami(self):
+
+
+class UserIdentity(ExternalBase):
+    def runTest(self):
         # this should always identify something, if only "john@localhost"
         self.runbzr("whoami")
         self.runbzr("whoami --email")
@@ -66,8 +129,9 @@
         self.assertEquals(self.runbzr("whoami --email",
                                       backtick=True).count('@'), 1)
         
-    def test_whoami_branch(self):
-        """branch specific user identity works."""
+class UserIdentityBranch(ExternalBase):
+    def runTest(self):
+        # tests branch specific user identity
         self.runbzr('init')
         f = file('.bzr/email', 'wt')
         f.write('Branch Identity <branch@identi.ty>')
@@ -77,19 +141,27 @@
         self.assertTrue(whoami.startswith('Branch Identity <branch@identi.ty>'))
         self.assertTrue(whoami_email.startswith('branch@identi.ty'))
 
-    def test_invalid_commands(self):
+
+class InvalidCommands(ExternalBase):
+    def runTest(self):
         self.runbzr("pants", retcode=1)
         self.runbzr("--pants off", retcode=1)
         self.runbzr("diff --message foo", retcode=1)
 
-    def test_empty_commit(self):
+
+
+class EmptyCommit(ExternalBase):
+    def runTest(self):
         self.runbzr("init")
         self.build_tree(['hello.txt'])
         self.runbzr("commit -m empty", retcode=1)
         self.runbzr("add hello.txt")
         self.runbzr("commit -m added")
 
-    def test_ignore_patterns(self):
+
+
+class IgnorePatterns(ExternalBase):
+    def runTest(self):
         from bzrlib.branch import Branch
         
         b = Branch('.', init=True)
@@ -120,134 +192,13 @@
         self.runbzr('ignore garh')
         self.assertEquals(list(b.unknowns()), [])
         assert file('.bzrignore', 'rb').read() == '*.blah\ngarh\n'
-
-    def test_revert(self):
-        import os
-        self.runbzr('init')
-
-        file('hello', 'wt').write('foo')
-        self.runbzr('add hello')
-        self.runbzr('commit -m setup hello')
-
-        file('goodbye', 'wt').write('baz')
-        self.runbzr('add goodbye')
-        self.runbzr('commit -m setup goodbye')
-        
-        file('hello', 'wt').write('bar')
-        file('goodbye', 'wt').write('qux')
-        self.runbzr('revert hello')
-        self.check_file_contents('hello', 'foo')
-        self.check_file_contents('goodbye', 'qux')
-        self.runbzr('revert')
-        self.check_file_contents('goodbye', 'baz')
-
-        os.mkdir('revertdir')
-        self.runbzr('add revertdir')
-        self.runbzr('commit -m f')
-        os.rmdir('revertdir')
-        self.runbzr('revert')
-
-    def skipped_test_mv_modes(self):
-        """Test two modes of operation for mv"""
-        from bzrlib.branch import Branch
-        b = Branch('.', init=True)
-        self.build_tree(['a', 'c', 'subdir/'])
-        self.run_bzr('mv', 'a', 'b')
-        self.run_bzr('mv', 'b', 'subdir')
-        self.run_bzr('mv', 'subdir/b', 'a')
-        self.run_bzr('mv', 'a', 'b', 'subdir')
-        self.run_bzr('mv', 'subdir/a', 'subdir/newa')
-
-    def test_main_version(self):
-        """Check output from version command and master option is reasonable"""
-        # output is intentionally passed through to stdout so that we
-        # can see the version being tested
-        output = self.runbzr('version', backtick=1)
-        self.log('bzr version output:')
-        self.log(output)
-        self.assert_(output.startswith('bzr (bazaar-ng) '))
-        self.assertNotEqual(output.index('Canonical'), -1)
-        # make sure --version is consistent
-        tmp_output = self.runbzr('--version', backtick=1)
-        self.log('bzr --version output:')
-        self.log(tmp_output)
-        self.assertEquals(output, tmp_output)
-
-    def example_branch(test):
-        test.runbzr('init')
-        file('hello', 'wt').write('foo')
-        test.runbzr('add hello')
-        test.runbzr('commit -m setup hello')
-        file('goodbye', 'wt').write('baz')
-        test.runbzr('add goodbye')
-        test.runbzr('commit -m setup goodbye')
-
-    def test_revert(self):
-        self.example_branch()
-        file('hello', 'wt').write('bar')
-        file('goodbye', 'wt').write('qux')
-        self.runbzr('revert hello')
-        self.check_file_contents('hello', 'foo')
-        self.check_file_contents('goodbye', 'qux')
-        self.runbzr('revert')
-        self.check_file_contents('goodbye', 'baz')
-
-    def test_merge(self):
-        from bzrlib.branch import Branch
-        import os
-        
-        os.mkdir('a')
-        os.chdir('a')
-
-        self.example_branch()
-        os.chdir('..')
-        self.runbzr('branch a b')
-        os.chdir('b')
-        file('goodbye', 'wt').write('quux')
-        self.runbzr(['commit',  '-m',  "more u's are always good"])
-
-        os.chdir('../a')
-        file('hello', 'wt').write('quuux')
-        # We can't merge when there are in-tree changes
-        self.runbzr('merge ../b', retcode=1)
-        self.runbzr(['commit', '-m', "Like an epidemic of u's"])
-        self.runbzr('merge ../b')
-        self.check_file_contents('goodbye', 'quux')
-        # Merging a branch pulls its revision into the tree
-        a = Branch('.')
-        b = Branch('../b')
-        a.get_revision_xml(b.last_patch())
-
-        self.log('pending merges: %s', a.pending_merges())
-        #        assert a.pending_merges() == [b.last_patch()], "Assertion %s %s" \
-        #        % (a.pending_merges(), b.last_patch())
-
-
-    def test_add_reports(self):
-        """add command prints the names of added files."""
-        b = Branch('.', init=True)
-        self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-
-        from cStringIO import StringIO
-        out = StringIO()
-
-        ret = self.apply_redirected(None, out, None,
-                                    run_bzr,
-                                    ['add'])
-        self.assertEquals(ret, 0)
-
-        # the ordering is not defined at the moment
-        results = sorted(out.getvalue().rstrip('\n').split('\n'))
-        self.assertEquals(['added dir',
-                           'added dir/sub.txt',
-                           'added top.txt',],
-                          results)
+        
+
 
 
 class OldTests(ExternalBase):
-    """old tests moved from ./testbzr."""
-
-    def test_bzr(self):
+    # old tests moved from ./testbzr
+    def runTest(self):
         from os import chdir, mkdir
         from os.path import exists
         import os
@@ -415,3 +366,28 @@
 
         runbzr('info')
 
+
+
+
+
+
+class RevertCommand(ExternalBase):
+    def runTest(self):
+        self.runbzr('init')
+
+        file('hello', 'wt').write('foo')
+        self.runbzr('add hello')
+        self.runbzr('commit -m setup hello')
+
+        file('goodbye', 'wt').write('baz')
+        self.runbzr('add goodbye')
+        self.runbzr('commit -m setup goodbye')
+        
+        file('hello', 'wt').write('bar')
+        file('goodbye', 'wt').write('qux')
+        self.runbzr('revert hello')
+        self.check_file_contents('hello', 'foo')
+        self.check_file_contents('goodbye', 'qux')
+        self.runbzr('revert')
+        self.check_file_contents('goodbye', 'baz')
+

=== modified file 'bzrlib/selftest/plugins.py'
--- bzrlib/selftest/plugins.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/plugins.py	2005-08-17 23:31:01 +0000
@@ -17,25 +17,20 @@
 
 """Tests for plugins"""
 
-
-
-# **************************************************
 # NOT RUN YET
-# **************************************************
-
-
-
-
-
-
-
-
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class PluginTest(TestCaseInTempDir):
+
+
+
+
+
+
+
+from bzrlib.selftest import InTempDir
+
+
+def PluginTest(InTempDir):
     """Create an external plugin and test loading."""
-    def test_plugin_loading(self):
+    def runTest(self):
         import os
         
         orig_help = self.backtick('bzr help commands') # No plugins yet

=== removed file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-09-01 06:33:48 +0000
+++ bzrlib/selftest/test_merge_core.py	1970-01-01 00:00:00 +0000
@@ -1,501 +0,0 @@
-import os
-import unittest
-
-from bzrlib.selftest import TestCaseInTempDir, TestCase
-from bzrlib.branch import ScratchBranch, Branch
-from bzrlib.errors import NotBranchError, NotVersionedError
-
-
-import tempfile
-import shutil
-from bzrlib.inventory import InventoryEntry, RootEntry
-from bzrlib.osutils import file_kind
-from bzrlib import changeset
-from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
-                                BackupBeforeChange, PermissionsMerge)
-from bzrlib.changeset import Inventory, apply_changeset, invert_dict
-
-class FalseTree(object):
-    def __init__(self, realtree):
-        self._realtree = realtree
-        self.inventory = self
-
-    def __getitem__(self, file_id):
-        entry = self.make_inventory_entry(file_id)
-        if entry is None:
-            raise KeyError(file_id)
-        return entry
-        
-    def make_inventory_entry(self, file_id):
-        path = self._realtree.inventory.get(file_id)
-        if path is None:
-            return None
-        if path == "":
-            return RootEntry(file_id)
-        dir, name = os.path.split(path)
-        kind = file_kind(self._realtree.abs_path(path))
-        for parent_id, path in self._realtree.inventory.iteritems():
-            if path == dir:
-                break
-        if path != dir:
-            raise Exception("Can't find parent for %s" % name)
-        return InventoryEntry(file_id, name, kind, parent_id)
-
-
-class MergeTree(object):
-    def __init__(self, dir):
-        self.dir = dir;
-        os.mkdir(dir)
-        self.inventory = {'0': ""}
-        self.tree = FalseTree(self)
-    
-    def child_path(self, parent, name):
-        return os.path.join(self.inventory[parent], name)
-
-    def add_file(self, id, parent, name, contents, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        file(full_path, "wb").write(contents)
-        os.chmod(self.abs_path(path), mode)
-        self.inventory[id] = path
-
-    def remove_file(self, id):
-        os.unlink(self.full_path(id))
-        del self.inventory[id]
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.child_path(parent, name)
-        full_path = self.abs_path(path)
-        assert not os.path.exists(full_path)
-        os.mkdir(self.abs_path(path))
-        os.chmod(self.abs_path(path), mode)
-        self.inventory[id] = path
-
-    def abs_path(self, path):
-        return os.path.join(self.dir, path)
-
-    def full_path(self, id):
-        try:
-            tree_path = self.inventory[id]
-        except KeyError:
-            return None
-        return self.abs_path(tree_path)
-
-    def readonly_path(self, id):
-        return self.full_path(id)
-
-    def __contains__(self, file_id):
-        return file_id in self.inventory
-
-    def has_or_had_id(self, file_id):
-        return file_id in self
-
-    def get_file(self, file_id):
-        path = self.readonly_path(file_id)
-        return file(path, "rb")
-
-    def id2path(self, file_id):
-        return self.inventory[file_id]
-
-    def change_path(self, id, path):
-        old_path = os.path.join(self.dir, self.inventory[id])
-        os.rename(old_path, self.abs_path(path))
-        self.inventory[id] = path
-
-
-class MergeBuilder(object):
-    def __init__(self):
-        self.dir = tempfile.mkdtemp(prefix="BaZing")
-        self.base = MergeTree(os.path.join(self.dir, "base"))
-        self.this = MergeTree(os.path.join(self.dir, "this"))
-        self.other = MergeTree(os.path.join(self.dir, "other"))
-        
-        self.cset = changeset.Changeset()
-        self.cset.add_entry(changeset.ChangesetEntry("0", 
-                                                     changeset.NULL_ID, "./."))
-    def get_cset_path(self, parent, name):
-        if name is None:
-            assert (parent is None)
-            return None
-        return os.path.join(self.cset.entries[parent].path, name)
-
-    def add_file(self, id, parent, name, contents, mode):
-        self.base.add_file(id, parent, name, contents, mode)
-        self.this.add_file(id, parent, name, contents, mode)
-        self.other.add_file(id, parent, name, contents, mode)
-        path = self.get_cset_path(parent, name)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-
-    def remove_file(self, id, base=False, this=False, other=False):
-        for option, tree in ((base, self.base), (this, self.this), 
-                             (other, self.other)):
-            if option:
-                tree.remove_file(id)
-            if other or base:
-                change = self.cset.entries[id].contents_change
-                if change is None:
-                    change = changeset.ReplaceContents(None, None)
-                    self.cset.entries[id].contents_change = change
-                    def create_file(tree):
-                        return changeset.FileCreate(tree.get_file(id).read())
-                    if not other:
-                        change.new_contents = create_file(self.other)
-                    if not base:
-                        change.old_contents = create_file(self.base)
-                else:
-                    assert isinstance(change, changeset.ReplaceContents)
-                if other:
-                    change.new_contents=None
-                if base:
-                    change.old_contents=None
-                if change.old_contents is None and change.new_contents is None:
-                    change = None
-
-
-    def add_dir(self, id, parent, name, mode):
-        path = self.get_cset_path(parent, name)
-        self.base.add_dir(id, parent, name, mode)
-        self.cset.add_entry(changeset.ChangesetEntry(id, parent, path))
-        self.this.add_dir(id, parent, name, mode)
-        self.other.add_dir(id, parent, name, mode)
-
-
-    def change_name(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_name_tree(id, self.base, base)
-            self.cset.entries[id].name = base
-
-        if this is not None:
-            self.change_name_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_name_tree(id, self.other, other)
-            self.cset.entries[id].new_name = other
-
-    def change_parent(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_parent_tree(id, self.base, base)
-            self.cset.entries[id].parent = base
-            self.cset.entries[id].dir = self.cset.entries[base].path
-
-        if this is not None:
-            self.change_parent_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_parent_tree(id, self.other, other)
-            self.cset.entries[id].new_parent = other
-            self.cset.entries[id].new_dir = \
-                self.cset.entries[other].new_path
-
-    def change_contents(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_contents_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_contents_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_contents_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_contents = file(self.base.full_path(id)).read()
-            new_contents = file(self.other.full_path(id)).read()
-            contents = changeset.ReplaceFileContents(old_contents, 
-                                                     new_contents)
-            self.cset.entries[id].contents_change = contents
-
-    def change_perms(self, id, base=None, this=None, other=None):
-        if base is not None:
-            self.change_perms_tree(id, self.base, base)
-
-        if this is not None:
-            self.change_perms_tree(id, self.this, this)
-
-        if other is not None:
-            self.change_perms_tree(id, self.other, other)
-
-        if base is not None or other is not None:
-            old_perms = os.stat(self.base.full_path(id)).st_mode &077
-            new_perms = os.stat(self.other.full_path(id)).st_mode &077
-            contents = changeset.ChangeUnixPermissions(old_perms, 
-                                                       new_perms)
-            self.cset.entries[id].metadata_change = contents
-
-    def change_name_tree(self, id, tree, name):
-        new_path = tree.child_path(self.cset.entries[id].parent, name)
-        tree.change_path(id, new_path)
-
-    def change_parent_tree(self, id, tree, parent):
-        new_path = tree.child_path(parent, self.cset.entries[id].name)
-        tree.change_path(id, new_path)
-
-    def change_contents_tree(self, id, tree, contents):
-        path = tree.full_path(id)
-        mode = os.stat(path).st_mode
-        file(path, "w").write(contents)
-        os.chmod(path, mode)
-
-    def change_perms_tree(self, id, tree, mode):
-        os.chmod(tree.full_path(id), mode)
-
-    def merge_changeset(self, merge_factory):
-        conflict_handler = changeset.ExceptionConflictHandler(self.this.dir)
-        return make_merge_changeset(self.cset, self.this, self.base,
-                                    self.other, conflict_handler,
-                                    merge_factory)
-
-    def apply_inv_change(self, inventory_change, orig_inventory):
-        orig_inventory_by_path = {}
-        for file_id, path in orig_inventory.iteritems():
-            orig_inventory_by_path[path] = file_id
-
-        def parent_id(file_id):
-            try:
-                parent_dir = os.path.dirname(orig_inventory[file_id])
-            except:
-                print file_id
-                raise
-            if parent_dir == "":
-                return None
-            return orig_inventory_by_path[parent_dir]
-        
-        def new_path(file_id):
-            if inventory_change.has_key(file_id):
-                return inventory_change[file_id]
-            else:
-                parent = parent_id(file_id)
-                if parent is None:
-                    return orig_inventory[file_id]
-                dirname = new_path(parent)
-                return os.path.join(dirname, orig_inventory[file_id])
-
-        new_inventory = {}
-        for file_id in orig_inventory.iterkeys():
-            path = new_path(file_id)
-            if path is None:
-                continue
-            new_inventory[file_id] = path
-
-        for file_id, path in inventory_change.iteritems():
-            if orig_inventory.has_key(file_id):
-                continue
-            new_inventory[file_id] = path
-        return new_inventory
-
-    def apply_changeset(self, cset, conflict_handler=None, reverse=False):
-        inventory_change = changeset.apply_changeset(cset,
-                                                     self.this.inventory,
-                                                     self.this.dir,
-                                                     conflict_handler, reverse)
-        self.this.inventory =  self.apply_inv_change(inventory_change, 
-                                                     self.this.inventory)
-
-    def cleanup(self):
-        shutil.rmtree(self.dir)
-
-class MergeTest(unittest.TestCase):
-    def test_change_name(self):
-        """Test renames"""
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0755)
-        builder.change_name("1", other="name2")
-        builder.add_file("2", "0", "name3", "hello2", 0755)
-        builder.change_name("2", base="name4")
-        builder.add_file("3", "0", "name5", "hello3", 0755)
-        builder.change_name("3", this="name6")
-        cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["2"].is_boring())
-        assert(cset.entries["1"].name == "name1")
-        assert(cset.entries["1"].new_name == "name2")
-        assert(cset.entries["3"].is_boring())
-        for tree in (builder.this, builder.other, builder.base):
-            assert(tree.dir != builder.dir and 
-                   tree.dir.startswith(builder.dir))
-            for path in tree.inventory.itervalues():
-                fullpath = tree.abs_path(path)
-                assert(fullpath.startswith(tree.dir))
-                assert(not path.startswith(tree.dir))
-                assert os.path.exists(fullpath)
-        builder.apply_changeset(cset)
-        builder.cleanup()
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "hello1", 0644)
-        builder.change_name("1", other="name2", this="name3")
-        self.assertRaises(changeset.RenameConflict, 
-                          builder.merge_changeset, ApplyMerge3)
-        builder.cleanup()
-        
-    def test_file_moves(self):
-        """Test moves"""
-        builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_file("3", "1", "file1", "hello1", 0644)
-        builder.add_file("4", "1", "file2", "hello2", 0644)
-        builder.add_file("5", "1", "file3", "hello3", 0644)
-        builder.change_parent("3", other="2")
-        assert(Inventory(builder.other.inventory).get_parent("3") == "2")
-        builder.change_parent("4", this="2")
-        assert(Inventory(builder.this.inventory).get_parent("4") == "2")
-        builder.change_parent("5", base="2")
-        assert(Inventory(builder.base.inventory).get_parent("5") == "2")
-        cset = builder.merge_changeset(ApplyMerge3)
-        for id in ("1", "2", "4", "5"):
-            assert(cset.entries[id].is_boring())
-        assert(cset.entries["3"].parent == "1")
-        assert(cset.entries["3"].new_parent == "2")
-        builder.apply_changeset(cset)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_dir("1", "0", "dir1", 0755)
-        builder.add_dir("2", "0", "dir2", 0755)
-        builder.add_dir("3", "0", "dir3", 0755)
-        builder.add_file("4", "1", "file1", "hello1", 0644)
-        builder.change_parent("4", other="2", this="3")
-        self.assertRaises(changeset.MoveConflict, 
-                          builder.merge_changeset, ApplyMerge3)
-        builder.cleanup()
-
-    def test_contents_merge(self):
-        """Test merge3 merging"""
-        self.do_contents_test(ApplyMerge3)
-
-    def test_contents_merge2(self):
-        """Test diff3 merging"""
-        self.do_contents_test(changeset.Diff3Merge)
-
-    def test_contents_merge3(self):
-        """Test diff3 merging"""
-        def backup_merge(file_id, base, other):
-            return BackupBeforeChange(ApplyMerge3(file_id, base, other))
-        builder = self.contents_test_success(backup_merge)
-        def backup_exists(file_id):
-            return os.path.exists(builder.this.full_path(file_id)+"~")
-        assert backup_exists("1")
-        assert backup_exists("2")
-        assert not backup_exists("3")
-        builder.cleanup()
-
-    def do_contents_test(self, merge_factory):
-        """Test merging with specified ContentsChange factory"""
-        builder = self.contents_test_success(merge_factory)
-        builder.cleanup()
-        self.contents_test_conflicts(merge_factory)
-
-    def contents_test_success(self, merge_factory):
-        from inspect import isclass
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4")
-        builder.add_file("2", "0", "name3", "text2", 0655)
-        builder.change_contents("2", base="text5")
-        builder.add_file("3", "0", "name5", "text3", 0744)
-        builder.add_file("4", "0", "name6", "text4", 0744)
-        builder.remove_file("4", base=True)
-        assert not builder.cset.entries["4"].is_boring()
-        builder.change_contents("3", this="text6")
-        cset = builder.merge_changeset(merge_factory)
-        assert(cset.entries["1"].contents_change is not None)
-        if isclass(merge_factory):
-            assert(isinstance(cset.entries["1"].contents_change,
-                          merge_factory))
-            assert(isinstance(cset.entries["2"].contents_change,
-                          merge_factory))
-        assert(cset.entries["3"].is_boring())
-        assert(cset.entries["4"].is_boring())
-        builder.apply_changeset(cset)
-        assert(file(builder.this.full_path("1"), "rb").read() == "text4" )
-        assert(file(builder.this.full_path("2"), "rb").read() == "text2" )
-        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
-        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
-        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
-        return builder
-
-    def contents_test_conflicts(self, merge_factory):
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", this="text3")
-        cset = builder.merge_changeset(merge_factory)
-        self.assertRaises(changeset.MergeConflict, builder.apply_changeset,
-                          cset)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", base=True)
-        self.assertRaises(changeset.NewContentsConflict,
-                          builder.merge_changeset, merge_factory)
-        builder.cleanup()
-
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_contents("1", other="text4", base="text3")
-        builder.remove_file("1", this=True)
-        self.assertRaises(changeset.MissingForMerge, builder.merge_changeset, 
-                          merge_factory)
-        builder.cleanup()
-
-    def test_perms_merge(self):
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_perms("1", other=0655)
-        builder.add_file("2", "0", "name2", "text2", 0755)
-        builder.change_perms("2", base=0655)
-        builder.add_file("3", "0", "name3", "text3", 0755)
-        builder.change_perms("3", this=0655)
-        cset = builder.merge_changeset(ApplyMerge3)
-        assert(cset.entries["1"].metadata_change is not None)
-        assert(isinstance(cset.entries["1"].metadata_change,
-                          PermissionsMerge))
-        assert(isinstance(cset.entries["2"].metadata_change,
-                          PermissionsMerge))
-        assert(cset.entries["3"].is_boring())
-        builder.apply_changeset(cset)
-        assert(os.stat(builder.this.full_path("1")).st_mode &0777 == 0655)
-        assert(os.stat(builder.this.full_path("2")).st_mode &0777 == 0755)
-        assert(os.stat(builder.this.full_path("3")).st_mode &0777 == 0655)
-        builder.cleanup();
-        builder = MergeBuilder()
-        builder.add_file("1", "0", "name1", "text1", 0755)
-        builder.change_perms("1", other=0655, base=0555)
-        cset = builder.merge_changeset(ApplyMerge3)
-        self.assertRaises(changeset.MergePermissionConflict, 
-                     builder.apply_changeset, cset)
-        builder.cleanup()
-
-class FunctionalMergeTest(TestCaseInTempDir):
-
-    def test_trivial_star_merge(self):
-        """Test that merges in a star shape Just Work.""" 
-        from bzrlib.add import smart_add_branch, add_reporter_null
-        from bzrlib.branch import copy_branch
-        from bzrlib.merge import merge
-        # John starts a branch
-        self.build_tree(("original/", "original/file1", "original/file2"))
-        branch = Branch("original", init=True)
-        smart_add_branch(branch, ["original"], True, add_reporter_null)
-        branch.commit("start branch.", verbose=False)
-        # Mary branches it.
-        self.build_tree(("mary/",))
-        copy_branch(branch, "mary")
-        # Now John commits a change
-        file = open("original/file1", "wt")
-        file.write("John\n")
-        file.close()
-        branch.commit("change file1")
-        # Mary does too
-        mary_branch = Branch("mary")
-        file = open("mary/file2", "wt")
-        file.write("Mary\n")
-        file.close()
-        mary_branch.commit("change file2")
-        # john should be able to merge with no conflicts.
-        merge_type = ApplyMerge3
-        base = [None, None]
-        other = ("mary", -1)
-        merge(other, base, check_clean=True, merge_type=merge_type, this_dir="original")
-        self.assertEqual("John\n", open("original/file1", "rt").read())
-        self.assertEqual("Mary\n", open("original/file2", "rt").read())

=== removed file 'bzrlib/selftest/test_parent.py'
--- bzrlib/selftest/test_parent.py	2005-08-30 05:55:13 +0000
+++ bzrlib/selftest/test_parent.py	1970-01-01 00:00:00 +0000
@@ -1,55 +0,0 @@
-# Copyright (C) 2004, 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.branch import Branch, copy_branch
-
-
-
-class TestParent(TestCaseInTempDir):
-    def test_no_default_parent(self):
-        """Branches should have no parent by default"""
-        b = Branch('.', init=True)
-        self.assertEquals(b.get_parent(), None)
-        
-    
-    def test_set_get_parent(self):
-        """Set and then re-get the parent"""
-        b = Branch('.', init=True)
-        url = 'http://bazaar-ng.org/bzr/bzr.dev'
-        b.set_parent(url)
-        self.assertEquals(b.get_parent(), url)
-
-    def test_branch_sets_parent(self):
-        """The branch command should set the new branch's parent"""
-        from bzrlib.commands import run_bzr
-
-        os.mkdir('from')
-        branch_from = Branch('from', init=True)
-        file('from/foo', 'wt').write('contents of foo')
-        branch_from.add('foo')
-        branch_from.commit('initial commit')
-        
-        os.mkdir('to')
-        copy_branch(branch_from, 'to', None)
-
-        branch_to = Branch('to')
-        abspath = os.path.abspath('from')
-        self.assertEquals(branch_to.get_parent(), abspath)
-        
-

=== removed file 'bzrlib/selftest/test_smart_add.py'
--- bzrlib/selftest/test_smart_add.py	2005-09-01 06:33:48 +0000
+++ bzrlib/selftest/test_smart_add.py	1970-01-01 00:00:00 +0000
@@ -1,160 +0,0 @@
-import os
-import unittest
-
-from bzrlib.selftest import TestCaseInTempDir, TestCase
-from bzrlib.branch import Branch
-from bzrlib.errors import NotBranchError, NotVersionedError
-
-class TestSmartAdd(TestCaseInTempDir):
-
-    def test_add_dot_from_root(self):
-        """Test adding . from the root of the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add((".",), recurse=True)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_dot_from_subdir(self):
-        """Test adding . from a subdir of the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        os.chdir("original")
-        smart_add((".",), recurse=True)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_tree_from_above_tree(self):
-        """Test adding a tree from above the tree.""" 
-        from bzrlib.add import smart_add
-        paths = ("original/", "original/file1", "original/file2")
-        branch_paths = ("branch/", "branch/original/", "branch/original/file1",
-                        "branch/original/file2")
-        self.build_tree(branch_paths)
-        branch = Branch("branch", init=True)
-        smart_add(("branch",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_above_tree_preserves_tree(self):
-        """Test nested trees are not affect by an add above them."""
-        from bzrlib.add import smart_add, add_reporter_null
-        
-        paths = ("original/", "original/file1", "original/file2")
-        child_paths = ("path",)
-        full_child_paths = ("original/child", "original/child/path")
-        build_paths = ("original/", "original/file1", "original/file2", 
-                       "original/child/", "original/child/path")
-        
-        self.build_tree(build_paths)
-        branch = Branch(".", init=True)
-        child_branch = Branch("original/child", init=True)
-        smart_add((".",), True, add_reporter_null)
-        for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
-                                (path, None))
-        for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
-                             (path, None))
-        for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
-
-    def test_add_paths(self):
-        """Test smart-adding a list of paths."""
-        from bzrlib.add import smart_add
-        paths = ("file1", "file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add(paths)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-            
-class TestSmartAddBranch(TestCaseInTempDir):
-    """Test smart adds with a specified branch."""
-
-    def test_add_dot_from_root(self):
-        """Test adding . from the root of the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_dot_from_subdir(self):
-        """Test adding . from a subdir of the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        os.chdir("original")
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_tree_from_above_tree(self):
-        """Test adding a tree from above the tree.""" 
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        branch_paths = ("branch/", "branch/original/", "branch/original/file1",
-                        "branch/original/file2")
-        self.build_tree(branch_paths)
-        branch = Branch("branch", init=True)
-        smart_add_branch(branch, ("branch",))
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-    def test_add_above_tree_preserves_tree(self):
-        """Test nested trees are not affect by an add above them."""
-        from bzrlib.add import smart_add_branch
-        paths = ("original/", "original/file1", "original/file2")
-        child_paths = ("path")
-        full_child_paths = ("original/child", "original/child/path")
-        build_paths = ("original/", "original/file1", "original/file2", 
-                       "original/child/", "original/child/path")
-        self.build_tree(build_paths)
-        branch = Branch(".", init=True)
-        child_branch = Branch("original/child", init=True)
-        smart_add_branch(branch, (".",))
-        for path in paths:
-            self.assertNotEqual((path, branch.inventory.path2id(path)),
-                                (path, None))
-        for path in full_child_paths:
-            self.assertEqual((path, branch.inventory.path2id(path)),
-                             (path, None))
-        for path in child_paths:
-            self.assertEqual(child_branch.inventory.path2id(path), None)
-
-    def test_add_paths(self):
-        """Test smart-adding a list of paths."""
-        from bzrlib.add import smart_add_branch
-        paths = ("file1", "file2")
-        self.build_tree(paths)
-        branch = Branch(".", init=True)
-        smart_add_branch(branch, paths)
-        for path in paths:
-            self.assertNotEqual(branch.inventory.path2id(path), None)
-
-class TestAddCallbacks(TestCaseInTempDir):
-
-    def setUp(self):
-        from bzrlib.inventory import InventoryEntry
-        super(TestAddCallbacks, self).setUp()
-        self.entry = InventoryEntry("id", "name", "file", None)
-
-    def test_null_callback(self):
-        from bzrlib.add import add_reporter_null
-        add_reporter_null('path', 'file', self.entry)
-
-    def test_print_callback(self):
-        from bzrlib.add import add_reporter_print
-        from StringIO import StringIO
-        stdout = StringIO()
-        self.apply_redirected(None, stdout, None, add_reporter_print,
-                              'path', 'file', self.entry)
-        self.assertEqual(stdout.getvalue(), "added path\n")

=== removed file 'bzrlib/selftest/test_xml.py'
--- bzrlib/selftest/test_xml.py	2005-09-06 07:26:13 +0000
+++ bzrlib/selftest/test_xml.py	1970-01-01 00:00:00 +0000
@@ -1,140 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from cStringIO import StringIO
-
-from bzrlib.selftest import TestCase
-from bzrlib.inventory import Inventory, InventoryEntry
-from bzrlib.xml import serializer_v4, serializer_v5
-
-_working_inventory_v4 = """<inventory file_id="TREE_ROOT">
-<entry file_id="bar-20050901064931-73b4b1138abc9cd2" kind="file" name="bar" parent_id="TREE_ROOT" />
-<entry file_id="foo-20050801201819-4139aa4a272f4250" kind="directory" name="foo" parent_id="TREE_ROOT" />
-<entry file_id="bar-20050824000535-6bc48cfad47ed134" kind="file" name="bar" parent_id="foo-20050801201819-4139aa4a272f4250" />
-</inventory>"""
-
-
-_revision_v4 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;"
-    inventory_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
-    revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    timestamp="1125907235.211783886"
-    timezone="36000">
-<message>- start splitting code for xml (de)serialization away from objects
-  preparatory to supporting multiple formats by a single library
-</message>
-<parents>
-<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92" revision_sha1="7bdf4cc8c5bdac739f8cf9b10b78cf4b68f915ff" />
-</parents>
-</revision>
-"""
-
-_revision_v5 = """<revision committer="Martin Pool &lt;mbp@sourcefrog.net&gt;"
-    inventory_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    inventory_sha1="e79c31c1deb64c163cf660fdedd476dd579ffd41"
-    revision_id="mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9"
-    timestamp="1125907235.211783886"
-    timezone="36000">
-<message>- start splitting code for xml (de)serialization away from objects
-  preparatory to supporting multiple formats by a single library
-</message>
-<parents>
-<revision_ref revision_id="mbp@sourcefrog.net-20050905063503-43948f59fa127d92"/>
-</parents>
-</revision>
-"""
-
-_committed_inv_v5 = """<inventory>
-<file file_id="bar-20050901064931-73b4b1138abc9cd2" 
-      name="bar" parent_id="TREE_ROOT" 
-      text_version="mbp@foo-123123" entry_version="mbp@foo-123123"
-      />
-<directory name="subdir"
-           file_id="foo-20050801201819-4139aa4a272f4250"
-           parent_id="TREE_ROOT" 
-           entry_version="mbp@foo-00"/>
-<file file_id="bar-20050824000535-6bc48cfad47ed134" 
-      name="bar" parent_id="foo-20050801201819-4139aa4a272f4250" 
-      entry_version="mbp@foo-00"
-      text_version="mbp@foo-123123"/>
-</inventory>
-"""
-
-class TestSerializer(TestCase):
-    """Test XML serialization"""
-    def test_canned_inventory(self):
-        """Test unpacked a canned inventory v4 file."""
-        inp = StringIO(_working_inventory_v4)
-        inv = serializer_v4.read_inventory(inp)
-        self.assertEqual(len(inv), 4)
-        self.assert_('bar-20050901064931-73b4b1138abc9cd2' in inv)
-
-    def test_unpack_revision(self):
-        """Test unpacking a canned revision v4"""
-        inp = StringIO(_revision_v4)
-        rev = serializer_v4.read_revision(inp)
-        eq = self.assertEqual
-        eq(rev.committer,
-           "Martin Pool <mbp@sourcefrog.net>")
-        eq(rev.inventory_id,
-           "mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9")
-        eq(len(rev.parents), 1)
-        eq(rev.parents[0].revision_id,
-           "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
-
-    def test_unpack_revision_5(self):
-        """Test unpacking a canned revision v5"""
-        inp = StringIO(_revision_v5)
-        rev = serializer_v5.read_revision(inp)
-        eq = self.assertEqual
-        eq(rev.committer,
-           "Martin Pool <mbp@sourcefrog.net>")
-        eq(rev.inventory_id,
-           "mbp@sourcefrog.net-20050905080035-e0439293f8b6b9f9")
-        eq(len(rev.parents), 1)
-        eq(rev.timezone, 36000)
-        eq(rev.parents[0].revision_id,
-           "mbp@sourcefrog.net-20050905063503-43948f59fa127d92")
-
-    def test_unpack_inventory_5(self):
-        """Unpack canned new-style inventory"""
-        inp = StringIO(_committed_inv_v5)
-        inv = serializer_v5.read_inventory(inp)
-        eq = self.assertEqual
-        eq(len(inv), 4)
-        ie = inv['bar-20050824000535-6bc48cfad47ed134']
-        eq(ie.kind, 'file')
-        eq(ie.text_version, 'mbp@foo-123123')
-        eq(ie.entry_version, 'mbp@foo-00')
-        eq(ie.name, 'bar')
-        eq(inv[ie.parent_id].kind, 'directory')
-
-    def test_repack_inventory_5(self):
-        inp = StringIO(_committed_inv_v5)
-        inv = serializer_v5.read_inventory(inp)
-        outp = StringIO()
-        serializer_v5.write_inventory(inv, outp)
-        inv2 = serializer_v5.read_inventory(StringIO(outp.getvalue()))
-        self.assertEqual(inv, inv2)
-
-    def test_repack_revision_5(self):
-        inp = StringIO(_revision_v5)
-        rev = serializer_v5.read_revision(inp)
-        outp = StringIO()
-        serializer_v5.write_revision(rev, outp)
-        rev2 = serializer_v5.read_revision(StringIO(outp.getvalue()))
-        self.assertEqual(rev, rev2)
-

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-08-30 01:35:40 +0000
+++ bzrlib/selftest/testbranch.py	2005-07-11 07:05:34 +0000
@@ -14,35 +14,22 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
-
-
-class TestAppendRevisions(TestCaseInTempDir):
+from bzrlib.selftest import InTempDir
+
+
+
+class TestAppendRevisions(InTempDir):
     """Test appending more than one revision"""
-    def test_append_revisions(self):
+    def runTest(self):
         from bzrlib.branch import Branch
         br = Branch(".", init=True)
         br.append_revision("rev1")
         self.assertEquals(br.revision_history(), ["rev1",])
         br.append_revision("rev2", "rev3")
         self.assertEquals(br.revision_history(), ["rev1", "rev2", "rev3"])
-
-
-# TODO: rewrite this as a regular unittest, without relying on the displayed output        
-#         >>> from bzrlib.commit import commit
-#         >>> bzrlib.trace.silent = True
-#         >>> br1 = ScratchBranch(files=['foo', 'bar'])
-#         >>> br1.add('foo')
-#         >>> br1.add('bar')
-#         >>> commit(br1, "lala!", rev_id="REVISION-ID-1", verbose=False)
-#         >>> br2 = ScratchBranch()
-#         >>> br2.update_revisions(br1)
-#         Added 2 texts.
-#         Added 1 inventories.
-#         Added 1 revisions.
-#         >>> br2.revision_history()
-#         [u'REVISION-ID-1']
-#         >>> br2.update_revisions(br1)
-#         Added 0 revisions.
-#         >>> br1.text_store.total_size() == br2.text_store.total_size()
-#         True
+        
+
+
+TEST_CLASSES = [
+    TestAppendRevisions,
+    ]

=== modified file 'bzrlib/selftest/testdiff.py'
--- bzrlib/selftest/testdiff.py	2005-08-25 12:46:42 +0000
+++ bzrlib/selftest/testdiff.py	2005-07-27 16:44:44 +0000
@@ -1,4 +1,4 @@
-from bzrlib.selftest import TestCase
+from bzrlib.selftest import TestBase
 from bzrlib.diff import internal_diff
 from cStringIO import StringIO
 def udiff_lines(old, new):
@@ -21,28 +21,41 @@
     assert '@@' in lines[2][2:], \
         "Unterminated hunk header for patch:\n%s" % "".join(lines)
 
-class TestDiff(TestCase):
-    def test_add_nl(self):
-        """diff generates a valid diff for patches that add a newline"""
+class AddNL(TestBase):
+    """
+    diff generates a valid diff for patches that add a newline
+    """
+    def runTest(self):
         lines = udiff_lines(['boo'], ['boo\n'])
         check_patch(lines)
         assert lines[4] == '\\ No newline at end of file\n', \
             "expected no-nl, got %r" % lines[4]
 
-    def test_add_nl_2(self):
-        """diff generates a valid diff for patches that change last line and
-        add a newline.
-        """
+
+class AddNL2(TestBase):
+    """
+    diff generates a valid diff for patches that change last line and add a
+    newline
+    """
+    def runTest(self):
         lines = udiff_lines(['boo'], ['goo\n'])
         check_patch(lines)
         assert lines[4] == '\\ No newline at end of file\n', \
             "expected no-nl, got %r" % lines[4]
 
-    def test_remove_nl(self):
-        """diff generates a valid diff for patches that change last line and
-        add a newline.
-        """
+class RemoveNL(TestBase):
+    """
+    diff generates a valid diff for patches that change last line and add a
+    newline
+    """
+    def runTest(self):
         lines = udiff_lines(['boo\n'], ['boo'])
         check_patch(lines)
         assert lines[5] == '\\ No newline at end of file\n', \
             "expected no-nl, got %r" % lines[5]
+
+TEST_CLASSES = [
+    AddNL, 
+    AddNL2, 
+    RemoveNL,
+]

=== removed file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/testfetch.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-import bzrlib.errors
-from bzrlib.selftest.testrevision import make_branches
-from bzrlib.trace import mutter
-from bzrlib.branch import Branch
-import sys
-import os
-
-from bzrlib.selftest import TestCaseInTempDir
-        
-
-class TestFetch(TestCaseInTempDir):
-    def runTest(self):
-        from bzrlib.fetch import greedy_fetch, has_revision
-
-        def new_branch(name):
-            os.mkdir(name)
-            return Branch(name, init=True)
-            
-        #highest indices a: 5, b: 7
-        br_a, br_b = make_branches()
-        assert not has_revision(br_b, br_a.revision_history()[3])
-        assert has_revision(br_b, br_a.revision_history()[2])
-        assert len(br_b.revision_history()) == 7
-        assert greedy_fetch(br_b, br_a, br_a.revision_history()[2])[0] == 0
-
-        # greedy_fetch is not supposed to alter the revision history
-        assert len(br_b.revision_history()) == 7
-        assert not has_revision(br_b, br_a.revision_history()[3])
-
-        assert len(br_b.revision_history()) == 7
-        assert greedy_fetch(br_b, br_a, br_a.revision_history()[3])[0] == 1
-        assert has_revision(br_b, br_a.revision_history()[3])
-        assert not has_revision(br_a, br_b.revision_history()[3])
-        assert not has_revision(br_a, br_b.revision_history()[4])
-
-        # When a non-branch ancestor is missing, it should be a failure, not
-        # exception
-        br_a4 = new_branch('br_a4')
-        count, failures = greedy_fetch(br_a4, br_a)
-        assert count == 6
-        assert failures == set((br_b.revision_history()[4],
-                                br_b.revision_history()[5])) 
-
-        assert greedy_fetch(br_a, br_b)[0] == 4
-        assert has_revision(br_a, br_b.revision_history()[3])
-        assert has_revision(br_a, br_b.revision_history()[4])
-
-        br_b2 = new_branch('br_b2')
-        assert greedy_fetch(br_b2, br_b)[0] == 7
-        assert has_revision(br_b2, br_b.revision_history()[4])
-        assert has_revision(br_b2, br_a.revision_history()[2])
-        assert not has_revision(br_b2, br_a.revision_history()[3])
-
-        br_a2 = new_branch('br_a2')
-        assert greedy_fetch(br_a2, br_a)[0] == 9
-        assert has_revision(br_a2, br_b.revision_history()[4])
-        assert has_revision(br_a2, br_a.revision_history()[3])
-
-        br_a3 = new_branch('br_a3')
-        assert greedy_fetch(br_a3, br_a2)[0] == 0
-        for revno in range(4):
-            assert not has_revision(br_a3, br_a.revision_history()[revno])
-        assert greedy_fetch(br_a3, br_a2, br_a.revision_history()[2])[0] == 3
-        fetched = greedy_fetch(br_a3, br_a2, br_a.revision_history()[3])[0]
-        assert fetched == 3, "fetched %d instead of 3" % fetched
-        # InstallFailed should be raised if the branch is missing the revision
-        # that was requested.
-        self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                          br_a2, 'pizza')
-        # InstallFailed should be raised if the branch is missing a revision
-        # from its own revision history
-        br_a2.append_revision('a-b-c')
-        self.assertRaises(bzrlib.errors.InstallFailed, greedy_fetch, br_a3,
-                          br_a2)
-
-
-
-if __name__ == '__main__':
-    import unittest
-    sys.exit(unittest.run_suite(unittest.makeSuite()))

=== modified file 'bzrlib/selftest/testhashcache.py'
--- bzrlib/selftest/testhashcache.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/testhashcache.py	2005-07-08 06:54:58 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
 
 
@@ -31,12 +31,13 @@
         time.sleep(0.2)
     
 
-class TestHashCache(TestCaseInTempDir):
 
-    def test_hashcache(self):
-        """Functional tests for hashcache"""
+class TestHashCache(InTempDir):
+    """Functional tests for hashcache"""
+    def runTest(self):
         from bzrlib.hashcache import HashCache
         import os
+        import time
 
         # make a dummy bzr directory just to hold the cache
         os.mkdir('.bzr')
@@ -111,3 +112,8 @@
         self.assertEquals(hc.hit_count, 1)
         self.assertEquals(hc.miss_count, 0)
         self.assertEquals(hc.get_sha1('foo2'), sha1('new content'))
+
+        
+
+        
+

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-09-05 08:00:35 +0000
+++ bzrlib/selftest/testinv.py	2005-07-23 00:18:14 +0000
@@ -14,14 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCase
+from bzrlib.selftest import TestBase
 
 from bzrlib.inventory import Inventory, InventoryEntry
 
 
-class TestInventory(TestCase):
-
-    def test_is_within(self):
+class TestIsWithin(TestBase):
+    def runTest(self):
         from bzrlib.osutils import is_inside_any
         
         for dirs, fn in [(['src', 'doc'], 'src/foo.c'),
@@ -34,7 +33,10 @@
                          (['src'], 'srccontrol/foo')]:
             self.assertFalse(is_inside_any(dirs, fn))
             
-    def test_ids(self):
+            
+            
+class TestInventoryIds(TestBase):
+    def runTest(self):
         """Test detection of files within selected directories."""
         inv = Inventory()
         
@@ -49,11 +51,3 @@
         self.assertEqual(inv.path2id('src/bye.c'), 'bye-id')
         
         self.assert_('src-id' in inv)
-
-
-    def test_version(self):
-        """Inventory remembers the text's version."""
-        inv = Inventory()
-        ie = inv.add_path('foo.txt', 'file')
-        ## XXX
-

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-09-05 01:31:37 +0000
+++ bzrlib/selftest/testlog.py	2005-07-29 13:18:36 +0000
@@ -15,12 +15,10 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
-from cStringIO import StringIO
 
-from bzrlib.selftest import BzrTestBase, TestCaseInTempDir
+from bzrlib.selftest import BzrTestBase
 from bzrlib.log import LogFormatter, show_log, LongLogFormatter
 from bzrlib.branch import Branch
-from bzrlib.errors import InvalidRevisionNumber
 
 class _LogEntry(object):
     # should probably move into bzrlib.log?
@@ -49,8 +47,7 @@
         self.logs.append(le)
 
 
-class SimpleLogTest(TestCaseInTempDir):
-
+class SimpleLogTest(BzrTestBase):
     def checkDelta(self, delta, **kw):
         """Check the filenames touched by a delta are as expected."""
         for n in 'added', 'removed', 'renamed', 'modified', 'unchanged':
@@ -64,27 +61,10 @@
             got = [x[0] for x in getattr(delta, n)]
             self.assertEquals(expected, got)
 
-    def test_cur_revno(self):
-        b = Branch('.', init=True)
-
-        lf = LogCatcher()
-        b.commit('empty commit')
-        show_log(b, lf, verbose=True, start_revision=1, end_revision=1)
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=2, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=0, end_revision=2) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=0) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=-1, end_revision=1) 
-        self.assertRaises(InvalidRevisionNumber, show_log, b, lf,
-                          start_revision=1, end_revision=-1) 
-
-    def test_simple_log(self):
+    
+    def runTest(self):
         eq = self.assertEquals
+        ass = self.assert_
         
         b = Branch('.', init=True)
 
@@ -108,13 +88,8 @@
         self.build_tree(['hello'])
         b.add('hello')
         b.commit('add one file')
-
-        lf = StringIO()
         # log using regular thing
-        show_log(b, LongLogFormatter(lf))
-        lf.seek(0)
-        for l in lf.readlines():
-            self.log(l)
+        show_log(b, LongLogFormatter(self.TEST_LOG))
 
         # get log as data structure
         lf = LogCatcher()

=== modified file 'bzrlib/selftest/testmerge3.py'
--- bzrlib/selftest/testmerge3.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/testmerge3.py	2005-07-06 05:24:29 +0000
@@ -15,85 +15,16 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-from bzrlib.selftest import TestCaseInTempDir, TestCase
+from bzrlib.selftest import InTempDir, TestBase
 from bzrlib.merge3 import Merge3
 
-def split_lines(t):
-    from cStringIO import StringIO
-    return StringIO(t).readlines()
-
-############################################################
-# test case data from the gnu diffutils manual
-# common base
-TZU = split_lines("""     The Nameless is the origin of Heaven and Earth;
-     The named is the mother of all things.
-     
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their outcome.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-     They both may be called deep and profound.
-     Deeper and more profound,
-     The door of all subtleties!
-""")
-
-LAO = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The Named is the mother of all things.
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their outcome.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-""")
-
-
-TAO = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The named is the mother of all things.
-     
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their result.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-     
-       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
-
-""")
-
-MERGED_RESULT = split_lines("""     The Way that can be told of is not the eternal Way;
-     The name that can be named is not the eternal name.
-     The Nameless is the origin of Heaven and Earth;
-     The Named is the mother of all things.
-     Therefore let there always be non-being,
-       so we may see their subtlety,
-     And let there always be being,
-       so we may see their result.
-     The two are the same,
-     But after they are produced,
-       they have different names.
-<<<<<<< LAO
-=======
-     
-       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
-
->>>>>>> TAO
-""")
-
-class TestMerge3(TestCase):
-
-    def test_no_changes(self):
-        """No conflicts because nothing changed"""
+
+
+
+
+class NoChanges(TestBase):
+    """No conflicts because nothing changed"""
+    def runTest(self):
         m3 = Merge3(['aaa', 'bbb'],
                     ['aaa', 'bbb'],
                     ['aaa', 'bbb'])
@@ -113,7 +44,9 @@
         self.assertEquals(list(m3.merge_groups()),
                           [('unchanged', ['aaa', 'bbb'])])
 
-    def test_front_insert(self):
+
+class FrontInsert(TestBase):
+    def runTest(self):
         m3 = Merge3(['zz'],
                     ['aaa', 'bbb', 'zz'],
                     ['zz'])
@@ -132,10 +65,14 @@
                           [('a', ['aaa', 'bbb']),
                            ('unchanged', ['zz'])])
         
-    def test_null_insert(self):
+    
+
+class NullInsert(TestBase):
+    def runTest(self):
         m3 = Merge3([],
                     ['aaa', 'bbb'],
                     [])
+
         # todo: should use a sentinal at end as from get_matching_blocks
         # to match without zz
         self.assertEquals(list(m3.find_sync_regions()),
@@ -146,9 +83,12 @@
 
         self.assertEquals(list(m3.merge_lines()),
                           ['aaa', 'bbb'])
+        
+    
 
-    def test_no_conflicts(self):
-        """No conflicts because only one side changed"""
+class NoConflicts(TestBase):
+    """No conflicts because only one side changed"""
+    def runTest(self):
         m3 = Merge3(['aaa', 'bbb'],
                     ['aaa', '111', 'bbb'],
                     ['aaa', 'bbb'])
@@ -166,7 +106,10 @@
                            ('a', 1, 2),
                            ('unchanged', 1, 2),])
 
-    def test_append_a(self):
+
+
+class AppendA(TestBase):
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', 'bbb\n', '222\n'],
                     ['aaa\n', 'bbb\n'])
@@ -174,7 +117,8 @@
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
-    def test_append_b(self):
+class AppendB(TestBase):
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', 'bbb\n'],
                     ['aaa\n', 'bbb\n', '222\n'])
@@ -182,7 +126,8 @@
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
-    def test_append_agreement(self):
+class AppendAgreement(TestBase):
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', 'bbb\n', '222\n'],
                     ['aaa\n', 'bbb\n', '222\n'])
@@ -190,7 +135,8 @@
         self.assertEquals(''.join(m3.merge_lines()),
                           'aaa\nbbb\n222\n')
 
-    def test_append_clash(self):
+class AppendClash(TestBase):
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', 'bbb\n', '222\n'],
                     ['aaa\n', 'bbb\n', '333\n'])
@@ -211,7 +157,9 @@
 >> b
 ''')
 
-    def test_insert_agreement(self):
+
+class InsertAgreement(TestBase):
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', '222\n', 'bbb\n'],
                     ['aaa\n', '222\n', 'bbb\n'])
@@ -221,11 +169,15 @@
                             start_marker='<<',
                             mid_marker='--',
                             end_marker='>>')
-        self.assertEquals(''.join(ml), 'aaa\n222\nbbb\n')
-        
-
-    def test_insert_clash(self):
-        """Both try to insert lines in the same place."""
+        self.assertEquals(''.join(m3.merge_lines()),
+                          'aaa\n222\nbbb\n')
+
+
+
+
+class InsertClash(TestBase):
+    """Both try to insert lines in the same place."""
+    def runTest(self):
         m3 = Merge3(['aaa\n', 'bbb\n'],
                     ['aaa\n', '111\n', 'bbb\n'],
                     ['aaa\n', '222\n', 'bbb\n'])
@@ -264,8 +216,11 @@
 bbb
 ''')
 
-    def test_replace_clash(self):
-        """Both try to insert lines in the same place."""
+
+
+class ReplaceClash(TestBase):
+    """Both try to insert lines in the same place."""
+    def runTest(self):
         m3 = Merge3(['aaa', '000', 'bbb'],
                     ['aaa', '111', 'bbb'],
                     ['aaa', '222', 'bbb'])
@@ -278,8 +233,11 @@
                            (2,3, 2,3, 2,3),
                            (3,3, 3,3, 3,3),])
 
-    def test_replace_multi(self):
-        """Replacement with regions of different size."""
+
+
+class ReplaceMulti(TestBase):
+    """Replacement with regions of different size."""
+    def runTest(self):
         m3 = Merge3(['aaa', '000', '000', 'bbb'],
                     ['aaa', '111', '111', '111', 'bbb'],
                     ['aaa', '222', '222', '222', '222', 'bbb'])
@@ -293,10 +251,112 @@
                            (3,4, 4,5, 5,6),
                            (4,4, 5,5, 6,6),])
 
-    def test_merge_poem(self):
-        """Test case from diff3 manual"""
+        
+        
+
+
+
+
+def split_lines(t):
+    from cStringIO import StringIO
+    return StringIO(t).readlines()
+
+
+
+############################################################
+# test case from the gnu diffutils manual
+
+# common base
+TZU = split_lines("""     The Nameless is the origin of Heaven and Earth;
+     The named is the mother of all things.
+     
+     Therefore let there always be non-being,
+       so we may see their subtlety,
+     And let there always be being,
+       so we may see their outcome.
+     The two are the same,
+     But after they are produced,
+       they have different names.
+     They both may be called deep and profound.
+     Deeper and more profound,
+     The door of all subtleties!
+""")
+
+LAO = split_lines("""     The Way that can be told of is not the eternal Way;
+     The name that can be named is not the eternal name.
+     The Nameless is the origin of Heaven and Earth;
+     The Named is the mother of all things.
+     Therefore let there always be non-being,
+       so we may see their subtlety,
+     And let there always be being,
+       so we may see their outcome.
+     The two are the same,
+     But after they are produced,
+       they have different names.
+""")
+
+
+TAO = split_lines("""     The Way that can be told of is not the eternal Way;
+     The name that can be named is not the eternal name.
+     The Nameless is the origin of Heaven and Earth;
+     The named is the mother of all things.
+     
+     Therefore let there always be non-being,
+       so we may see their subtlety,
+     And let there always be being,
+       so we may see their result.
+     The two are the same,
+     But after they are produced,
+       they have different names.
+     
+       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
+
+""")
+
+MERGED_RESULT = split_lines("""     The Way that can be told of is not the eternal Way;
+     The name that can be named is not the eternal name.
+     The Nameless is the origin of Heaven and Earth;
+     The Named is the mother of all things.
+     Therefore let there always be non-being,
+       so we may see their subtlety,
+     And let there always be being,
+       so we may see their result.
+     The two are the same,
+     But after they are produced,
+       they have different names.
+<<<<<<<< LAO
+========
+     
+       -- The Way of Lao-Tzu, tr. Wing-tsit Chan
+
+>>>>>>>> TAO
+""")
+
+
+
+class MergePoem(TestBase):
+    """Test case from diff3 manual"""
+    def runTest(self):
         m3 = Merge3(TZU, LAO, TAO)
         ml = list(m3.merge_lines('LAO', 'TAO'))
         self.log('merge result:')
         self.log(''.join(ml))
         self.assertEquals(ml, MERGED_RESULT)
+
+
+
+TEST_CLASSES = [
+    NoChanges,
+    FrontInsert,
+    NullInsert,
+    NoConflicts,
+    AppendA,
+    AppendB,
+    AppendAgreement,
+    AppendClash,
+    InsertAgreement,
+    InsertClash,
+    ReplaceClash,
+    ReplaceMulti,
+    MergePoem,
+    ]

=== modified file 'bzrlib/selftest/testrevision.py'
--- bzrlib/selftest/testrevision.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/testrevision.py	2005-08-04 21:39:23 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
 
 def make_branches():
@@ -23,31 +23,24 @@
     import os
     os.mkdir("branch1")
     br1 = Branch("branch1", init=True)
-    
-    commit(br1, "Commit one", rev_id="a@u-0-0")
-    commit(br1, "Commit two", rev_id="a@u-0-1")
-    commit(br1, "Commit three", rev_id="a@u-0-2")
+    commit(br1, "Commit one")
+    commit(br1, "Commit two")
+    commit(br1, "Commit three")
 
     os.mkdir("branch2")
     br2 = Branch("branch2", init=True)
     br2.update_revisions(br1)
-    commit(br2, "Commit four", rev_id="b@u-0-3")
-    commit(br2, "Commit five", rev_id="b@u-0-4")
+    commit(br2, "Commit four")
+    commit(br2, "Commit five")
     revisions_2 = br2.revision_history()
     br1.add_pending_merge(revisions_2[4])
-    commit(br1, "Commit six", rev_id="a@u-0-3")
-    commit(br1, "Commit seven", rev_id="a@u-0-4")
-    commit(br2, "Commit eight", rev_id="b@u-0-5")
-    br1.add_pending_merge(br2.revision_history()[5])
-    commit(br1, "Commit nine", rev_id="a@u-0-5")
-    br2.add_pending_merge(br1.revision_history()[4])
-    commit(br2, "Commit ten", rev_id="b@u-0-6")
+    commit(br1, "Commit six")
     return br1, br2
 
 
-class TestIsAncestor(TestCaseInTempDir):
-    def test_is_ancestor(self):
-        """Test checking whether a revision is an ancestor of another revision"""
+class TestIsAncestor(InTempDir):
+    """Test checking whether a revision is an ancestor of another revision"""
+    def runTest(self):
         from bzrlib.revision import is_ancestor, MultipleRevisionSources
         from bzrlib.errors import NoSuchRevision
         br1, br2 = make_branches()
@@ -66,106 +59,7 @@
         assert is_ancestor(revisions[3], revisions_2[3], sources)
         assert not is_ancestor(revisions[3], revisions_2[3], br1)
 
-class TestIntermediateRevisions(TestCaseInTempDir):
-
-    def setUp(self):
-        from bzrlib.commit import commit
-        TestCaseInTempDir.setUp(self)
-        self.br1, self.br2 = make_branches()
-        commit(self.br2, "Commit eleven", rev_id="b@u-0-7")
-        commit(self.br2, "Commit twelve", rev_id="b@u-0-8")
-        commit(self.br2, "Commit thirtteen", rev_id="b@u-0-9")
-        self.br1.add_pending_merge(self.br2.revision_history()[6])
-        commit(self.br1, "Commit fourtten", rev_id="a@u-0-6")
-        self.br2.add_pending_merge(self.br1.revision_history()[6])
-        commit(self.br2, "Commit fifteen", rev_id="b@u-0-10")
-
-        from bzrlib.revision import MultipleRevisionSources
-        self.sources = MultipleRevisionSources(self.br1, self.br2)
-
-    def intervene(self, ancestor, revision, revision_history=None):
-        from bzrlib.revision import get_intervening_revisions
-        return get_intervening_revisions(ancestor,revision, self.sources, 
-                                         revision_history)
-
-    def test_intervene(self):
-        """Find intermediate revisions, without requiring history"""
-        from bzrlib.errors import NotAncestor, NoSuchRevision
-        assert len(self.intervene('a@u-0-0', 'a@u-0-0')) == 0
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-1'), ['a@u-0-1'])
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-2'), 
-                         ['a@u-0-1', 'a@u-0-2'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-3'), 
-                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3'])
-        self.assertEqual(self.intervene('b@u-0-3', 'a@u-0-3'), 
-                         ['b@u-0-4', 'a@u-0-3'])
-        self.assertEqual(self.intervene('a@u-0-2', 'a@u-0-3', 
-                                        self.br1.revision_history()), 
-                         ['a@u-0-3'])
-        self.assertEqual(self.intervene('a@u-0-0', 'a@u-0-5', 
-                                        self.br1.revision_history()), 
-                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
-                          'a@u-0-5'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-6', 
-                         self.br1.revision_history()), 
-                         ['a@u-0-1', 'a@u-0-2', 'a@u-0-3', 'a@u-0-4', 
-                          'b@u-0-6'])
-        self.assertEqual(self.intervene('a@u-0-0', 'b@u-0-5'), 
-                         ['a@u-0-1', 'a@u-0-2', 'b@u-0-3', 'b@u-0-4', 
-                          'b@u-0-5'])
-        self.assertEqual(self.intervene('b@u-0-3', 'b@u-0-6', 
-                         self.br2.revision_history()), 
-                         ['b@u-0-4', 'b@u-0-5', 'b@u-0-6'])
-        self.assertEqual(self.intervene('b@u-0-6', 'b@u-0-10'), 
-                         ['b@u-0-7', 'b@u-0-8', 'b@u-0-9', 'b@u-0-10'])
-        self.assertEqual(self.intervene('b@u-0-6', 'b@u-0-10', 
-                                        self.br2.revision_history()), 
-                         ['b@u-0-7', 'b@u-0-8', 'b@u-0-9', 'b@u-0-10'])
-        self.assertRaises(NotAncestor, self.intervene, 'b@u-0-10', 'b@u-0-6', 
-                          self.br2.revision_history())
-        self.assertRaises(NoSuchRevision, self.intervene, 'c@u-0-10', 
-                          'b@u-0-6', self.br2.revision_history())
-        self.assertRaises(NoSuchRevision, self.intervene, 'b@u-0-10', 
-                          'c@u-0-6', self.br2.revision_history())
-
-
-class TestCommonAncestor(TestCaseInTempDir):
-    """Test checking whether a revision is an ancestor of another revision"""
-
-    def test_common_ancestor(self):
-        from bzrlib.revision import find_present_ancestors, common_ancestor
-        from bzrlib.revision import MultipleRevisionSources
-        br1, br2 = make_branches()
-        revisions = br1.revision_history()
-        revisions_2 = br2.revision_history()
-        sources = MultipleRevisionSources(br1, br2)
-
-        expected_ancestors_list = {revisions[3]:(0, 0), 
-                                   revisions[2]:(1, 1),
-                                   revisions_2[4]:(2, 1), 
-                                   revisions[1]:(3, 2),
-                                   revisions_2[3]:(4, 2),
-                                   revisions[0]:(5, 3) }
-        ancestors_list = find_present_ancestors(revisions[3], sources)
-        assert len(expected_ancestors_list) == len(ancestors_list)
-        for key, value in expected_ancestors_list.iteritems():
-            self.assertEqual(ancestors_list[key], value, 
-                              "key %r, %r != %r" % (key, ancestors_list[key],
-                                                    value))
-
-        self.assertEqual(common_ancestor(revisions[0], revisions[0], sources),
-                          revisions[0])
-        self.assertEqual(common_ancestor(revisions[1], revisions[2], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[1], revisions[1], sources),
-                          revisions[1])
-        self.assertEqual(common_ancestor(revisions[2], revisions_2[4], sources),
-                          revisions[2])
-        self.assertEqual(common_ancestor(revisions[3], revisions_2[4], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[4], revisions_2[5], sources),
-                          revisions_2[4])
-        self.assertEqual(common_ancestor(revisions[5], revisions_2[6], sources),
-                          revisions[4])
-        self.assertEqual(common_ancestor(revisions_2[6], revisions[5], sources),
-                          revisions_2[5])
+
+TEST_CLASSES = [
+    TestIsAncestor,
+    ]

=== modified file 'bzrlib/selftest/testrevisionnamespaces.py'
--- bzrlib/selftest/testrevisionnamespaces.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/testrevisionnamespaces.py	2005-07-11 06:13:18 +0000
@@ -14,14 +14,16 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import os
-from bzrlib.selftest import TestCaseInTempDir
-
-class TestRevisionNamespaces(TestCaseInTempDir):
-    def test_revision_namespaces(self):
-        """Functional tests for hashcache"""
-        from bzrlib.errors import NoSuchRevision
+
+from bzrlib.selftest import InTempDir, TestBase
+
+class TestRevisionNamespaces(InTempDir):
+    """Functional tests for hashcache"""
+    def runTest(self):
+        from bzrlib.errors import BzrError
         from bzrlib.branch import Branch
+        import os
+        import time
 
         b = Branch('.', init=True)
 
@@ -29,19 +31,16 @@
         b.commit('Commit two', rev_id='a@r-0-2')
         b.commit('Commit three', rev_id='a@r-0-3')
 
-        self.assertEquals(b.get_revision_info(None), (0, None))
         self.assertEquals(b.get_revision_info(1), (1, 'a@r-0-1'))
         self.assertEquals(b.get_revision_info('revno:1'), (1, 'a@r-0-1'))
         self.assertEquals(b.get_revision_info('revid:a@r-0-1'), (1, 'a@r-0-1'))
-        self.assertRaises(NoSuchRevision, b.get_revision_info, 'revid:a@r-0-0')
-        self.assertRaises(TypeError, b.get_revision_info, object)
+        self.assertRaises(BzrError, b.get_revision_info, 'revid:a@r-0-0')
 
         self.assertEquals(b.get_revision_info('date:-tomorrow'), (3, 'a@r-0-3'))
         self.assertEquals(b.get_revision_info('date:+today'), (1, 'a@r-0-1'))
 
         self.assertEquals(b.get_revision_info('last:1'), (3, 'a@r-0-3'))
-        self.assertEquals(b.get_revision_info('-1'), (3, 'a@r-0-3'))
 
-        os.mkdir('newbranch')
-        b2 = Branch('newbranch', init=True)
-        self.assertEquals(b2.lookup_revision('revid:a@r-0-1'), 'a@r-0-1')
+TEST_CLASSES = [
+    TestRevisionNamespaces
+    ]

=== modified file 'bzrlib/selftest/teststatus.py'
--- bzrlib/selftest/teststatus.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/teststatus.py	2005-07-12 01:44:23 +0000
@@ -21,11 +21,10 @@
 """
 
 
-from bzrlib.selftest import TestCaseInTempDir
+from bzrlib.selftest import InTempDir
 
-class BranchStatus(TestCaseInTempDir):
-    
-    def test_branch_status(self): 
+class BranchStatus(InTempDir):
+    def runTest(self): 
         """Basic 'bzr mkdir' operation"""
         from cStringIO import StringIO
         from bzrlib.status import show_status
@@ -40,14 +39,11 @@
 
         tof = StringIO()
         self.build_tree(['hello.c', 'bye.c'])
-        b.add_pending_merge('pending@pending-0-0')
         show_status(b, to_file=tof)
         tof.seek(0)
         self.assertEquals(tof.readlines(),
                           ['unknown:\n',
                            '  bye.c\n',
                            '  hello.c\n',
-                           'pending merges:\n',
-                           '  pending@pending-0-0\n'
                            ])
 

=== removed file 'bzrlib/selftest/teststore.py'
--- bzrlib/selftest/teststore.py	2005-09-04 02:59:56 +0000
+++ bzrlib/selftest/teststore.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright (C) 2005 by Canonical Development Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Test Store implementation
-"""
-from bzrlib.store import ImmutableStore
-from bzrlib.selftest import TestCaseInTempDir
-from StringIO import StringIO
-from bzrlib.errors import BzrError
-
-class TestStore(TestCaseInTempDir):
-    def test_multiple_add(self):
-        """Multiple add with same ID should raise a BzrError"""
-        store = ImmutableStore('.')
-        store.add(StringIO('goodbye'), '123123')
-        self.assertRaises(BzrError, store.add, StringIO('goodbye'), '123123')
-
-TEST_CLASSES = [
-    TestStore,
-    ]

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-08-30 03:10:32 +0000
+++ bzrlib/selftest/versioning.py	2005-08-01 20:39:06 +0000
@@ -22,18 +22,12 @@
 
 
 import os
-
-from bzrlib.selftest import BzrTestBase, TestCaseInTempDir
+from bzrlib.selftest import InTempDir, BzrTestBase
 from bzrlib.branch import Branch
 
-import logging
-logger = logging.getLogger('bzr.test.versioning')
-debug = logger.debug
-
-
-class TestVersioning(TestCaseInTempDir):
-    
-    def test_mkdir(self): 
+
+class Mkdir(InTempDir):
+    def runTest(self): 
         """Basic 'bzr mkdir' operation"""
         from bzrlib.commands import run_bzr
 
@@ -55,7 +49,10 @@
         self.assertEquals(delta.added[0][0], 'foo')
         self.failIf(delta.modified)
 
-    def test_add_in_unversioned(self):
+
+
+class AddInUnversioned(InTempDir):
+    def runTest(self):
         """Try to add a file in an unversioned directory.
 
         smart_add may eventually add the parent as necessary, but simple
@@ -73,68 +70,9 @@
                           b.add,
                           'foo/hello')
         
-        self.check_and_upgrade()
-
-        
-    def test_subdir_add(self):
-        """Add in subdirectory should add only things from there down"""
-        
-        from bzrlib.branch import Branch
-        from bzrlib.commands import run_bzr
-        
-        eq = self.assertEqual
-        ass = self.assert_
-        chdir = os.chdir
-        
-        b = Branch('.', init=True)
-        self.build_tree(['src/', 'README'])
-        
-        eq(sorted(b.unknowns()),
-           ['README', 'src'])
-        
-        eq(run_bzr(['add', 'src']), 0)
-        
-        self.build_tree(['src/foo.c'])
-        
-        chdir('src')
-        eq(run_bzr(['add']), 0)
-        
-        eq(sorted(b.unknowns()), 
-           ['README'])
-        eq(len(b.inventory), 3)
-                
-        chdir('..')
-        eq(run_bzr(['add']), 0)
-        eq(list(b.unknowns()), [])
-
-        self.check_and_upgrade()
-
-
-    def check_and_upgrade(self):
-        """After all the above changes, run the check and upgrade commands.
-
-        The upgrade should be a no-op."""
-        b = Branch('.')
-        debug('branch has %d revisions', b.revno())
-        
-        debug('check branch...')
-        from bzrlib.check import check
-        check(b)
-        
-        debug('upgrade branch...')
-        from bzrlib.upgrade import upgrade
-        upgrade(b)
-        
-        debug('check branch...')
-        from bzrlib.check import check
-        check(b)
-        
-
-        
-        
-class SubdirCommit(TestCaseInTempDir):
-
-    def test_subdir_commit(self):
+        
+class SubdirCommit(BzrTestBase):
+    def runTest(self):
         """Test committing a subdirectory, and committing within a directory."""
         run_bzr = self.run_bzr
         eq = self.assertEqual
@@ -178,3 +116,37 @@
         
         # TODO: factor out some kind of assert_tree_state() method
         
+        
+        
+class SubdirAdd(InTempDir):
+    def runTest(self):
+        """Add in subdirectory should add only things from there down"""
+        
+        from bzrlib.branch import Branch
+        from bzrlib.commands import run_bzr
+        
+        eq = self.assertEqual
+        ass = self.assert_
+        chdir = os.chdir
+        
+        b = Branch('.', init=True)
+        self.build_tree(['src/', 'README'])
+        
+        eq(sorted(b.unknowns()),
+           ['README', 'src'])
+        
+        eq(run_bzr(['add', 'src']), 0)
+        
+        self.build_tree(['src/foo.c'])
+        
+        chdir('src')
+        eq(run_bzr(['add']), 0)
+        
+        eq(sorted(b.unknowns()), 
+           ['README'])
+        eq(len(b.inventory), 3)
+                
+        chdir('..')
+        eq(run_bzr(['add']), 0)
+        eq(list(b.unknowns()), [])
+        

=== modified file 'bzrlib/selftest/whitebox.py'
--- bzrlib/selftest/whitebox.py	2005-08-30 01:35:40 +0000
+++ bzrlib/selftest/whitebox.py	2005-07-11 22:20:04 +0000
@@ -3,14 +3,13 @@
 import os
 import unittest
 
-from bzrlib.selftest import TestCaseInTempDir, TestCase
+from bzrlib.selftest import InTempDir, TestBase
 from bzrlib.branch import ScratchBranch, Branch
 from bzrlib.errors import NotBranchError, NotVersionedError
 
 
-class TestBranch(TestCaseInTempDir):
-
-    def test_unknowns(self):
+class Unknowns(InTempDir):
+    def runTest(self):
         b = Branch('.', init=True)
 
         self.build_tree(['hello.txt',
@@ -19,7 +18,10 @@
         self.assertEquals(list(b.unknowns()),
                           ['hello.txt'])
 
-    def test_no_changes(self):
+
+
+class NoChanges(InTempDir):
+    def runTest(self):
         from bzrlib.errors import PointlessCommit
         
         b = Branch('.', init=True)
@@ -53,52 +55,69 @@
         
 
 
-class TestRevisionId(TestCase):
-    
-    def test_validate_revision_id(self):
+class ValidateRevisionId(TestBase):
+    def runTest(self):
         from bzrlib.revision import validate_revision_id
         validate_revision_id('mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe')
+        
         self.assertRaises(ValueError,
                           validate_revision_id,
                           ' asdkjas')
+
+
         self.assertRaises(ValueError,
                           validate_revision_id,
                           'mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe\n')
+
+
         self.assertRaises(ValueError,
                           validate_revision_id,
                           ' mbp@sourcefrog.net-20050311061123-96a255005c7c9dbe')
+
         self.assertRaises(ValueError,
                           validate_revision_id,
                           'Martin Pool <mbp@sourcefrog.net>-20050311061123-96a255005c7c9dbe')
 
 
-class PendingMerges(TestCaseInTempDir):
 
-    def test_pending_merges(self):
-        """Tracking pending-merged revisions."""
+class PendingMerges(InTempDir):
+    """Tracking pending-merged revisions."""
+    def runTest(self):
         b = Branch('.', init=True)
 
         self.assertEquals(b.pending_merges(), [])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
-        b.add_pending_merge('foo@azkhazan-123123-abcabc')
-        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+        
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+    
+        b.add_pending_merge('foo@azkhazan-123123-abcabc')
+        
+        self.assertEquals(b.pending_merges(), ['foo@azkhazan-123123-abcabc'])
+
         b.add_pending_merge('wibble@fofof--20050401--1928390812')
         self.assertEquals(b.pending_merges(),
                           ['foo@azkhazan-123123-abcabc',
                            'wibble@fofof--20050401--1928390812'])
+
         b.commit("commit from base with two merges")
+
         rev = b.get_revision(b.revision_history()[0])
         self.assertEquals(len(rev.parents), 2)
         self.assertEquals(rev.parents[0].revision_id,
                           'foo@azkhazan-123123-abcabc')
         self.assertEquals(rev.parents[1].revision_id,
                            'wibble@fofof--20050401--1928390812')
+
         # list should be cleared when we do a commit
         self.assertEquals(b.pending_merges(), [])
         
-    def test_revert(self):
-        """Test selected-file revert"""
+        
+        
+
+class Revert(InTempDir):
+    """Test selected-file revert"""
+    def runTest(self):
         b = Branch('.', init=True)
 
         self.build_tree(['hello.txt'])
@@ -124,8 +143,11 @@
         self.check_file_contents('hello.txt', 'initial hello')
         self.check_file_contents('hello.txt~', 'initial hello')
 
-    def test_rename_dirs(self):
-        """Test renaming directories and the files within them."""
+
+
+class RenameDirs(InTempDir):
+    """Test renaming directories and the files within them."""
+    def runTest(self):
         b = Branch('.', init=True)
         self.build_tree(['dir/', 'dir/sub/', 'dir/sub/file'])
         b.add(['dir', 'dir/sub', 'dir/sub/file'])
@@ -154,13 +176,18 @@
                                    ['newdir', 'newdir/newsub',
                                     'newdir/newsub/file'])
 
-    def test_relpath(self):
-        """test for branch path lookups
-    
-        Branch.relpath and bzrlib.branch._relpath do a simple but subtle
-        job: given a path (either relative to cwd or absolute), work out
-        if it is inside a branch and return the path relative to the base.
-        """
+        
+
+
+class BranchPathTestCase(TestBase):
+    """test for branch path lookups
+
+    Branch.relpath and bzrlib.branch._relpath do a simple but subtle
+    job: given a path (either relative to cwd or absolute), work out
+    if it is inside a branch and return the path relative to the base.
+    """
+
+    def runTest(self):
         from bzrlib.branch import _relpath
         import tempfile, shutil
         
@@ -211,3 +238,14 @@
         finally:
             os.chdir(savedir)
             shutil.rmtree(dtmp)
+
+
+
+
+TEST_CLASSES = [Unknowns,
+                ValidateRevisionId,
+                PendingMerges,
+                Revert,
+                RenameDirs,
+                BranchPathTestCase,
+                ]

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-08-27 04:42:41 +0000
+++ bzrlib/status.py	2005-07-29 22:21:25 +0000
@@ -19,8 +19,7 @@
 def show_status(branch, show_unchanged=False,
                 specific_files=None,
                 show_ids=False,
-                to_file=None,
-                show_pending=True):
+                to_file=None):
     """Display single-line status for non-ignored working files.
 
     show_all
@@ -63,10 +62,6 @@
                 print >>to_file, 'unknown:'
                 done_header = True
             print >>to_file, ' ', path
-        if show_pending and len(branch.pending_merges()) > 0:
-            print >>to_file, 'pending merges:'
-            for merge in branch.pending_merges():
-                print >> to_file, ' ', merge
     finally:
         branch.unlock()
         

=== modified file 'bzrlib/store.py'
--- bzrlib/store.py	2005-09-06 23:19:08 +0000
+++ bzrlib/store.py	2005-08-02 23:14:41 +0000
@@ -24,9 +24,7 @@
 import os, tempfile, types, osutils, gzip, errno
 from stat import ST_SIZE
 from StringIO import StringIO
-from bzrlib.errors import BzrError
-from bzrlib.trace import mutter
-import bzrlib.ui
+from trace import mutter
 
 ######################################################################
 # stores
@@ -68,12 +66,10 @@
     def __init__(self, basedir):
         self._basedir = basedir
 
-    def _path(self, entry_id):
-        if not isinstance(entry_id, basestring):
-            raise TypeError(type(entry_id))
-        if '\\' in entry_id or '/' in entry_id:
-            raise ValueError("invalid store id %r" % entry_id)
-        return os.path.join(self._basedir, entry_id)
+    def _path(self, id):
+        if '\\' in id or '/' in id:
+            raise ValueError("invalid store id %r" % id)
+        return os.path.join(self._basedir, id)
 
     def __repr__(self):
         return "%s(%r)" % (self.__class__.__name__, self._basedir)
@@ -94,6 +90,7 @@
             
         p = self._path(fileid)
         if os.access(p, os.F_OK) or os.access(p + '.gz', os.F_OK):
+            from bzrlib.errors import bailout
             raise BzrError("store %r already contains id %r" % (self._basedir, fileid))
 
         fn = p
@@ -113,44 +110,31 @@
             af.close()
 
 
-    def copy_multi(self, other, ids, permit_failure=False):
+    def copy_multi(self, other, ids):
         """Copy texts for ids from other into self.
 
-        If an id is present in self, it is skipped.
-
-        Returns (count_copied, failed), where failed is a collection of ids
-        that could not be copied.
+        If an id is present in self, it is skipped.  A count of copied
+        ids is returned, which may be less than len(ids).
         """
-        pb = bzrlib.ui.ui_factory.progress_bar()
-        
+        from bzrlib.progress import ProgressBar
+        pb = ProgressBar()
         pb.update('preparing to copy')
         to_copy = [id for id in ids if id not in self]
         if isinstance(other, ImmutableStore):
             return self.copy_multi_immutable(other, to_copy, pb)
         count = 0
-        failed = set()
         for id in to_copy:
             count += 1
             pb.update('copy', count, len(to_copy))
-            if not permit_failure:
-                self.add(other[id], id)
-            else:
-                try:
-                    entry = other[id]
-                except IndexError:
-                    failed.add(id)
-                    continue
-                self.add(entry, id)
-                
-        if not permit_failure:
-            assert count == len(to_copy)
+            self.add(other[id], id)
+        assert count == len(to_copy)
         pb.clear()
-        return count, failed
-
-    def copy_multi_immutable(self, other, to_copy, pb, permit_failure=False):
+        return count
+
+
+    def copy_multi_immutable(self, other, to_copy, pb):
         from shutil import copyfile
         count = 0
-        failed = set()
         for id in to_copy:
             p = self._path(id)
             other_p = other._path(id)
@@ -158,16 +142,7 @@
                 copyfile(other_p, p)
             except IOError, e:
                 if e.errno == errno.ENOENT:
-                    if not permit_failure:
-                        copyfile(other_p+".gz", p+".gz")
-                    else:
-                        try:
-                            copyfile(other_p+".gz", p+".gz")
-                        except IOError, e:
-                            if e.errno == errno.ENOENT:
-                                failed.add(id)
-                            else:
-                                raise
+                    copyfile(other_p+".gz", p+".gz")
                 else:
                     raise
             
@@ -175,7 +150,7 @@
             pb.update('copy', count, len(to_copy))
         assert count == len(to_copy)
         pb.clear()
-        return count, failed
+        return count
     
 
     def __contains__(self, fileid):

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-08-29 10:57:01 +0000
+++ bzrlib/trace.py	2005-07-20 17:31:25 +0000
@@ -13,85 +13,69 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+
+# TODO: Could probably replace this with something based on Python logging
+# module.
+
+
+
+
+__copyright__ = "Copyright (C) 2005 Canonical Ltd."
+__author__ = "Martin Pool <mbp@canonical.com>"
+
+
 """Messages and logging for bazaar-ng
 
-Messages are sent out through the Python logging library.
-
-They can be sent to two places: to stderr, and to ~/.bzr.log.
-
-~/.bzr.log gets all messages, and tracebacks of all uncaught
-exceptions.
-
-Normally stderr only gets messages of level INFO and higher, and gets
-only a summary of exceptions, not the traceback.
+Nothing is actually logged unless you call bzrlib.open_tracefile().
 """
 
 
-# TODO: in debug mode, stderr should get full tracebacks and also
-# debug messages.  (Is this really needed?)
-
-# TODO: When running the test suites, we should add an additional
-# logger that sends messages into the test log file.
-
-
-import sys
-import os
-import logging
-import traceback
-
-
-_file_handler = None
-_stderr_handler = None
-
-
-class QuietFormatter(logging.Formatter):
-    """Formatter that supresses the details of errors.
-
-    This is used by default on stderr so as not to scare the user.
-    """
-    # At first I tried overriding formatException to suppress the
-    # exception details, but that has global effect: no loggers
-    # can get the exception details is we suppress them here.
-
-    def format(self, record):
-        s = 'bzr: '
-        if record.levelno >= logging.WARNING:
-            s += record.levelname + ': '
-            
-        s += record.getMessage() 
-            
-        if record.exc_info:
-            # give just a summary of the exception, not the whole thing
-            exinfo = traceback.extract_tb(record.exc_info[2])
-            # the format of this string matches one of the REs
-            s += '\n'
-            s += ('  at %s line %d, in %s()\n' % exinfo[-1][:3])
-            s += '  see ~/.bzr.log for debug information'
-
-        return s
-        
-
-
-
-################
-# configure convenient aliases for output routines
-
-_bzr_logger = logging.getLogger('bzr')
-_bzr_logger.setLevel(logging.DEBUG) 
-
-info = note = _bzr_logger.info
-warning =   _bzr_logger.warning
-log_error = _bzr_logger.error
-error =     _bzr_logger.error
-mutter =    _bzr_logger.debug
-debug =     _bzr_logger.debug
-
-
-
-
-# we do the rollover using this code, rather than the default from python
-# logging, because we only want to rollover at program startup, not on each
-# message.  maybe that's not a good enough reason.
+import sys, os
+
+######################################################################
+# messages and logging
+
+global _tracefile, _starttime
+_tracefile = None
+
+# used to have % (os.environ['USER'], time.time(), os.getpid()), 'w')
+_starttime = None
+
+# If false, notes also go to stdout; should replace this with --silent
+# at some point.
+silent = False
+
+
+# fix this if we ever fork within python
+_mypid = os.getpid()
+_logprefix = '[%d] ' % _mypid
+
+
+def _write_trace(msg):
+    if 0:
+        if _tracefile:
+            _tracefile.write(_logprefix + msg + '\n')
+
+
+def warning(msg):
+    sys.stderr.write('bzr: warning: ' + msg + '\n')
+    _write_trace('warning: ' + msg)
+
+
+mutter = _write_trace
+
+
+def note(msg):
+    b = '* ' + str(msg) + '\n'
+    if not silent:
+        sys.stderr.write(b)
+    _write_trace('note: ' + msg)
+
+
+def log_error(msg):
+    sys.stderr.write(msg + '\n')
+    _write_trace(msg)
+
 
 def _rollover_trace_maybe(trace_fname):
     import stat
@@ -117,95 +101,51 @@
 
 
 
-def open_tracefile(tracefilename='~/.bzr.log'):
+def open_tracefile(argv=[], tracefilename='~/.bzr.log'):
     # Messages are always written to here, so that we have some
     # information if something goes wrong.  In a future version this
     # file will be removed on successful completion.
-    global _file_handler
+    global _starttime, _tracefile
     import stat, codecs
 
+    _starttime = os.times()[4]
+
     trace_fname = os.path.join(os.path.expanduser(tracefilename))
     _rollover_trace_maybe(trace_fname)
 
     # buffering=1 means line buffered
     try:
-        tf = codecs.open(trace_fname, 'at', 'utf8', buffering=1)
-
-        if os.fstat(tf.fileno())[stat.ST_SIZE] == 0:
-            tf.write("\nthis is a debug log for diagnosing/reporting problems in bzr\n")
-            tf.write("you can delete or truncate this file, or include sections in\n")
-            tf.write("bug reports to bazaar-ng@lists.canonical.com\n\n")
-        
-        _file_handler = logging.StreamHandler(tf)
-        fmt = r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s'
-        datefmt = r'%a %H:%M:%S'
-        _file_handler.setFormatter(logging.Formatter(fmt, datefmt))
-        _file_handler.setLevel(logging.DEBUG)
-        logging.getLogger('').addHandler(_file_handler)
-
+        _tracefile = codecs.open(trace_fname, 'at', 'utf8', buffering=1)
+        t = _tracefile
+
+        if os.fstat(t.fileno())[stat.ST_SIZE] == 0:
+            t.write("\nthis is a debug log for diagnosing/reporting problems in bzr\n")
+            t.write("you can delete or truncate this file, or include sections in\n")
+            t.write("bug reports to bazaar-ng@lists.canonical.com\n\n")
+
+        import bzrlib
+        _write_trace('bzr %s invoked on python %s (%s)'
+                     % (bzrlib.__version__,
+                        '.'.join(map(str, sys.version_info)),
+                        sys.platform))
+
+        _write_trace('  arguments: %r' % argv)
+        _write_trace('  working dir: ' + os.getcwdu())
     except IOError, e:
         warning("failed to open trace file: %s" % (e))
 
-
-def log_startup(argv):
-    import bzrlib
-
-    debug('bzr %s invoked on python %s (%s)',
-          bzrlib.__version__,
-          '.'.join(map(str, sys.version_info)),
-          sys.platform)
-
-    debug('  arguments: %r', argv)
-    debug('  working dir: %s', os.getcwdu())
-
-
-def log_exception(msg=None):
-    """Log the last exception into the trace file.
-
-    The exception string representation is used as the error
-    summary, unless msg is given.
-    """
-    if msg == None:
-        ei = sys.exc_info()
-        msg = str(ei[1])
-
-    if msg and (msg[-1] == '\n'):
-        msg = msg[:-1]
+def close_trace():
+    times = os.times()
+    mutter("finished, %.3fu/%.3fs cpu, %.3fu/%.3fs cum, %.3f elapsed"
+           % (times[:4] + ((times[4] - _starttime),)))
+
+
+
+def log_exception():
+    """Log the last exception into the trace file."""
+    import cgitb
+    s = cgitb.text(sys.exc_info())
+    for l in s.split('\n'):
+        _write_trace(l)
         
-    _bzr_logger.exception(msg)
-
-
-
-def enable_default_logging():
-    """Configure default logging to stderr and .bzr.log"""
-    global _stderr_handler, _file_handler
-
-    _stderr_handler = logging.StreamHandler()
-    _stderr_handler.setFormatter(QuietFormatter())
-
-    if not _file_handler:
-        open_tracefile()
-
-    if os.environ.get('BZR_DEBUG'):
-        level = logging.DEBUG
-    else:
-        level = logging.INFO
-
-    _stderr_handler.setLevel(logging.INFO)
-    _file_handler.setLevel(level)
-
-    logging.getLogger('').addHandler(_stderr_handler)
-
-
-
-def disable_default_logging():
-    """Turn off default log handlers.
-
-    This is intended to be used by the test framework, which doesn't
-    want leakage from the code-under-test into the main logs.
-    """
-
-    l = logging.getLogger('')
-    l.removeHandler(_stderr_handler)
-    if _file_handler:
-        l.removeHandler(_file_handler)
+    

=== removed file 'bzrlib/ui.py'
--- bzrlib/ui.py	2005-08-25 12:46:42 +0000
+++ bzrlib/ui.py	1970-01-01 00:00:00 +0000
@@ -1,51 +0,0 @@
-# Copyright (C) 2005 Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-
-"""UI abstraction.
-
-This tells the library how to display things to the user.  Through this
-layer different applications can choose the style of UI.
-
-At the moment this layer is almost trivial: the application can just
-choose the style of progress bar.
-
-Set the ui_factory member to define the behaviour.  The default
-displays no output.
-"""
-
-
-
-
-
-import bzrlib.progress
-
-
-class TextUIFactory(object):
-    def progress_bar(self):
-
-        # this in turn is abstract, and creates either a tty or dots
-        # bar depending on what we think of the terminal
-        return bzrlib.progress.ProgressBar()
-
-
-class SilentUIFactory(object):
-    def progress_bar(self):
-        return bzrlib.progress.DummyProgress()
-
-
-ui_factory = SilentUIFactory()

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-09-05 09:27:11 +0000
+++ bzrlib/upgrade.py	2005-06-28 05:33:40 +0000
@@ -15,11 +15,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import tempfile, os, errno
-                
-import bzrlib.errors
-import bzrlib.progress
-from bzrlib.xml import serializer_v4
+
 
 
 def upgrade(branch):
@@ -38,13 +34,12 @@
 
     from bzrlib.trace import mutter
     from bzrlib.errors import BzrCheckError
-    import bzrlib.ui
+    from bzrlib.progress import ProgressBar
 
     branch.lock_write()
 
-    pb = bzrlib.ui.ui_factory.progress_bar()
-
     try:
+        pb = ProgressBar(show_spinner=True)
         last_rev_id = None
 
         history = branch.revision_history()
@@ -76,20 +71,17 @@
                 mutter("  set inventory_sha1 on {%s}" % rev_id)
 
             for prr in rev.parents:
-                try:
-                    actual_sha1 = branch.get_revision_sha1(prr.revision_id)
-                except bzrlib.errors.NoSuchRevision:
-                    mutter("parent {%s} of {%s} not present in branch; skipped"
-                           % (prr.revision_id, rev_id))
-                    continue
-                    
-                if actual_sha1 != prr.revision_sha1:
-                    mutter("parent {%s} of {%s} sha1 mismatch: "
-                           "%s vs %s; fixed"
-                           % (prr.revision_id, rev_id,
-                              actual_sha1, prr.revision_sha1))
-                    prr.revision_sha1 = actual_sha1
-                    updated = True
+                actual_sha1 = branch.get_revision_sha1(prr.revision_id)
+                if (updated_previous_revision
+                    or prr.revision_sha1 is None):
+                    if prr.revision_sha1 != actual_sha1:
+                        prr.revision_sha1 = actual_sha1
+                        updated = True
+                elif actual_sha1 != prr.revision_sha1:
+                    raise BzrCheckError("parent {%s} of {%s} sha1 mismatch: "
+                                        "%s vs %s"
+                                        % (prr.revision_id, rev_id,
+                                           actual_sha1, prr.revision_sha1))
 
             if updated:
                 updated_previous_revision = True
@@ -99,8 +91,11 @@
                 # revision entry. I'm not supremely happy about it, but
                 # there should be *some* way of making old entries have
                 # the full meta information.
+                import tempfile, os, errno
+                from bzrlib.xml import pack_xml
+                
                 rev_tmp = tempfile.TemporaryFile()
-                serializer_v4.write_revision(rev, rev_tmp)
+                pack_xml(rev, rev_tmp)
                 rev_tmp.seek(0)
 
                 tmpfd, tmp_path = tempfile.mkstemp(prefix=rev_id, suffix='.gz',

=== modified file 'bzrlib/weavefile.py'
--- bzrlib/weavefile.py	2005-08-25 12:46:42 +0000
+++ bzrlib/weavefile.py	2005-08-18 07:51:58 +0000
@@ -102,6 +102,7 @@
     from weave import Weave, WeaveFormatError
     w = Weave()
 
+    wfe = WeaveFormatError
     l = f.readline()
     if l != FORMAT_1:
         raise WeaveFormatError('invalid weave file header: %r' % l)

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-08-29 13:51:52 +0000
+++ bzrlib/workingtree.py	2005-07-22 19:32:52 +0000
@@ -21,12 +21,10 @@
 # it's not predictable when it will be written out.
 
 import os
-import fnmatch
-        
+    
 import bzrlib.tree
-from bzrlib.osutils import appendpath, file_kind, isdir, splitpath
-from bzrlib.errors import BzrCheckError
-from bzrlib.trace import mutter
+from errors import BzrCheckError
+from trace import mutter
 
 class WorkingTree(bzrlib.tree.Tree):
     """Working copy tree.
@@ -137,6 +135,9 @@
 
         Skips the control directory.
         """
+        from osutils import appendpath, file_kind
+        import os
+
         inv = self._inventory
 
         def descend(from_dir_relpath, from_dir_id, dp):
@@ -204,6 +205,8 @@
         Currently returned depth-first, sorted by name within directories.
         """
         ## TODO: Work from given directory downwards
+        from osutils import isdir, appendpath
+        
         for path, dir_entry in self.inventory.directories():
             mutter("search for unknowns in %r" % path)
             dirabs = self.abspath(path)
@@ -266,6 +269,9 @@
         # Eventually it should be replaced with something more
         # accurate.
         
+        import fnmatch
+        from osutils import splitpath
+        
         for pat in self.get_ignore_list():
             if '/' in pat or '\\' in pat:
                 
@@ -284,4 +290,4 @@
                     return pat
         else:
             return None
-        
+        
\ No newline at end of file

=== modified file 'bzrlib/xml.py'
--- bzrlib/xml.py	2005-09-06 06:44:11 +0000
+++ bzrlib/xml.py	2005-08-17 02:06:19 +0000
@@ -20,344 +20,21 @@
 # "XML is like violence: if it doesn't solve your problem, you aren't
 # using enough of it." -- various
 
-# importing this module is fairly slow because it has to load several
-# ElementTree bits
-
+# importing this module is fairly slow because it has to load several ElementTree bits
 try:
     from util.cElementTree import ElementTree, SubElement, Element
 except ImportError:
     from util.elementtree.ElementTree import ElementTree, SubElement, Element
 
-from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
-from bzrlib.revision import Revision, RevisionReference        
-from bzrlib.errors import BzrError
-
-
-class Serializer(object):
-    """Abstract object serialize/deserialize"""
-    def write_inventory(self, inv, f):
-        """Write inventory to a file"""
-        elt = self._pack_inventory(inv)
-        self._write_element(elt, f)
-
-    def read_inventory(self, f):
-        return self._unpack_inventory(self._read_element(f))
-
-    def write_revision(self, rev, f):
-        self._write_element(self._pack_revision(rev), f)
-
-    def read_revision(self, f):
-        return self._unpack_revision(self._read_element(f))
-
-    def _write_element(self, elt, f):
-        ElementTree(elt).write(f, 'utf-8')
-        f.write('\n')
-
-    def _read_element(self, f):
-        return ElementTree().parse(f)
-
-
-
-class _Serializer_v4(Serializer):
-    """Version 0.0.4 serializer
-
-    You should use the serialzer_v4 singleton."""
-    
-    __slots__ = []
-    
-    def _pack_inventory(self, inv):
-        """Convert to XML Element"""
-        e = Element('inventory')
-        e.text = '\n'
-        if inv.root.file_id not in (None, ROOT_ID):
-            e.set('file_id', inv.root.file_id)
-        for path, ie in inv.iter_entries():
-            e.append(self._pack_entry(ie))
-        return e
-
-
-    def _pack_entry(self, ie):
-        """Convert InventoryEntry to XML element"""
-        e = Element('entry')
-        e.set('name', ie.name)
-        e.set('file_id', ie.file_id)
-        e.set('kind', ie.kind)
-
-        if ie.text_size != None:
-            e.set('text_size', '%d' % ie.text_size)
-
-        for f in ['text_id', 'text_sha1']:
-            v = getattr(ie, f)
-            if v != None:
-                e.set(f, v)
-
-        # to be conservative, we don't externalize the root pointers
-        # for now, leaving them as null in the xml form.  in a future
-        # version it will be implied by nested elements.
-        if ie.parent_id != ROOT_ID:
-            assert isinstance(ie.parent_id, basestring)
-            e.set('parent_id', ie.parent_id)
-
-        e.tail = '\n'
-
-        return e
-
-
-    def _unpack_inventory(self, elt):
-        """Construct from XML Element
-        """
-        assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        inv = Inventory(root_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            if ie.parent_id == ROOT_ID:
-                ie.parent_id = root_id
-            inv.add(ie)
-        return inv
-
-
-    def _unpack_entry(self, elt):
-        assert elt.tag == 'entry'
-
-        ## original format inventories don't have a parent_id for
-        ## nodes in the root directory, but it's cleaner to use one
-        ## internally.
-        parent_id = elt.get('parent_id')
-        if parent_id == None:
-            parent_id = ROOT_ID
-
-        ie = InventoryEntry(elt.get('file_id'),
-                              elt.get('name'),
-                              elt.get('kind'),
-                              parent_id)
-        ie.text_id = elt.get('text_id')
-        ie.text_sha1 = elt.get('text_sha1')
-
-        ## mutter("read inventoryentry: %r" % (elt.attrib))
-
-        v = elt.get('text_size')
-        ie.text_size = v and int(v)
-
-        return ie
-
-
-    def _pack_revision(self, rev):
-        """Revision object -> xml tree"""
-        root = Element('revision',
-                       committer = rev.committer,
-                       timestamp = '%.9f' % rev.timestamp,
-                       revision_id = rev.revision_id,
-                       inventory_id = rev.inventory_id,
-                       inventory_sha1 = rev.inventory_sha1,
-                       )
-        if rev.timezone:
-            root.set('timezone', str(rev.timezone))
-        root.text = '\n'
-
-        msg = SubElement(root, 'message')
-        msg.text = rev.message
-        msg.tail = '\n'
-
-        if rev.parents:
-            pelts = SubElement(root, 'parents')
-            pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
-                p = SubElement(pelts, 'revision_ref')
-                p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-                if rr.revision_sha1:
-                    p.set('revision_sha1', rr.revision_sha1)
-
-        return root
-
-    
-    def _unpack_revision(self, elt):
-        """XML Element -> Revision object"""
-        
-        # <changeset> is deprecated...
-        if elt.tag not in ('revision', 'changeset'):
-            raise BzrError("unexpected tag in revision file: %r" % elt)
-
-        rev = Revision(committer = elt.get('committer'),
-                       timestamp = float(elt.get('timestamp')),
-                       revision_id = elt.get('revision_id'),
-                       inventory_id = elt.get('inventory_id'),
-                       inventory_sha1 = elt.get('inventory_sha1')
-                       )
-
-        precursor = elt.get('precursor')
-        precursor_sha1 = elt.get('precursor_sha1')
-
-        pelts = elt.find('parents')
-
-        if pelts:
-            for p in pelts:
-                assert p.tag == 'revision_ref', \
-                       "bad parent node tag %r" % p.tag
-                rev_ref = RevisionReference(p.get('revision_id'),
-                                            p.get('revision_sha1'))
-                rev.parents.append(rev_ref)
-
-            if precursor:
-                # must be consistent
-                prec_parent = rev.parents[0].revision_id
-                assert prec_parent == precursor
-        elif precursor:
-            # revisions written prior to 0.0.5 have a single precursor
-            # give as an attribute
-            rev_ref = RevisionReference(precursor, precursor_sha1)
-            rev.parents.append(rev_ref)
-
-        v = elt.get('timezone')
-        rev.timezone = v and int(v)
-
-        rev.message = elt.findtext('message') # text of <message>
-        return rev
-
-
-
-class _Serializer_v5(Serializer):
-    """Version 5 serializer
-
-    Packs objects into XML and vice versa.
-
-    You should use the serialzer_v5 singleton."""
-    
-    __slots__ = []
-    
-    def _pack_inventory(self, inv):
-        """Convert to XML Element"""
-        e = Element('inventory')
-        e.text = '\n'
-        if inv.root.file_id not in (None, ROOT_ID):
-            e.set('file_id', inv.root.file_id)
-        for path, ie in inv.iter_entries():
-            e.append(self._pack_entry(ie))
-        return e
-
-
-    def _pack_entry(self, ie):
-        """Convert InventoryEntry to XML element"""
-        assert ie.kind == 'directory' or ie.kind == 'file'
-        e = Element(ie.kind)
-        e.set('name', ie.name)
-        e.set('file_id', ie.file_id)
-
-        if ie.text_size != None:
-            e.set('text_size', '%d' % ie.text_size)
-
-        for f in ['text_version', 'text_sha1', 'entry_version']:
-            v = getattr(ie, f)
-            if v != None:
-                e.set(f, v)
-
-        # to be conservative, we don't externalize the root pointers
-        # for now, leaving them as null in the xml form.  in a future
-        # version it will be implied by nested elements.
-        if ie.parent_id != ROOT_ID:
-            assert isinstance(ie.parent_id, basestring)
-            e.set('parent_id', ie.parent_id)
-
-        e.tail = '\n'
-
-        return e
-
-
-    def _pack_revision(self, rev):
-        """Revision object -> xml tree"""
-        root = Element('revision',
-                       committer = rev.committer,
-                       timestamp = '%.9f' % rev.timestamp,
-                       revision_id = rev.revision_id,
-                       inventory_id = rev.inventory_id,
-                       inventory_sha1 = rev.inventory_sha1,
-                       )
-        if rev.timezone:
-            root.set('timezone', str(rev.timezone))
-        root.text = '\n'
-
-        msg = SubElement(root, 'message')
-        msg.text = rev.message
-        msg.tail = '\n'
-
-        if rev.parents:
-            pelts = SubElement(root, 'parents')
-            pelts.tail = pelts.text = '\n'
-            for rr in rev.parents:
-                assert isinstance(rr, RevisionReference)
-                p = SubElement(pelts, 'revision_ref')
-                p.tail = '\n'
-                assert rr.revision_id
-                p.set('revision_id', rr.revision_id)
-
-        return root
-
-    
-
-    def _unpack_inventory(self, elt):
-        """Construct from XML Element
-        """
-        assert elt.tag == 'inventory'
-        root_id = elt.get('file_id') or ROOT_ID
-        inv = Inventory(root_id)
-        for e in elt:
-            ie = self._unpack_entry(e)
-            if ie.parent_id == ROOT_ID:
-                ie.parent_id = root_id
-            inv.add(ie)
-        return inv
-
-
-    def _unpack_entry(self, elt):
-        kind = elt.tag
-        assert kind == 'directory' or kind == 'file'
-
-        parent_id = elt.get('parent_id')
-        if parent_id == None:
-            parent_id = ROOT_ID
-
-        ie = InventoryEntry(elt.get('file_id'),
-                            elt.get('name'),
-                            kind,
-                            parent_id)
-        ie.text_version = elt.get('text_version')
-        ie.entry_version = elt.get('entry_version')
-        ie.text_sha1 = elt.get('text_sha1')
-        v = elt.get('text_size')
-        ie.text_size = v and int(v)
-
-        return ie
-
-
-    def _unpack_revision(self, elt):
-        """XML Element -> Revision object"""
-        assert elt.tag == 'revision'
-        
-        rev = Revision(committer = elt.get('committer'),
-                       timestamp = float(elt.get('timestamp')),
-                       revision_id = elt.get('revision_id'),
-                       inventory_id = elt.get('inventory_id'),
-                       inventory_sha1 = elt.get('inventory_sha1')
-                       )
-
-        for p in elt.find('parents'):
-            assert p.tag == 'revision_ref', \
-                   "bad parent node tag %r" % p.tag
-            rev_ref = RevisionReference(p.get('revision_id'))
-            rev.parents.append(rev_ref)
-
-        v = elt.get('timezone')
-        rev.timezone = v and int(v)
-
-        rev.message = elt.findtext('message') # text of <message>
-        return rev
-
-
-
-"""singleton instance"""
-serializer_v4 = _Serializer_v4()
-
-serializer_v5 = _Serializer_v5()
+
+def pack_xml(o, f):
+    """Write object o to file f as XML.
+
+    o must provide a to_element method.
+    """
+    ElementTree(o.to_element()).write(f, 'utf-8')
+    f.write('\n')
+
+
+def unpack_xml(cls, f):
+    return cls.from_element(ElementTree().parse(f))

=== modified file 'doc/index.txt'
--- doc/index.txt	2005-09-01 02:39:02 +0000
+++ doc/index.txt	2005-05-17 00:33:59 +0000
@@ -14,9 +14,10 @@
 __ http://canonical.com/
 
 
-**Note: These documents describe the initial design and are out of
-date in parts.**  For more up-to-date information see the wiki at
-http://bazaar.canonical.com/
+**Note:** These documents are in a very preliminary state, and so may
+be internally or externally inconsistent or redundant.  Comments are
+still very welcome.  Please send them to <mbp@sourcefrog.net>.
+
 
 For more information, see the homepage at http://bazaar-ng.org/
 

=== modified file 'doc/todo-from-arch.txt'
--- doc/todo-from-arch.txt	2005-09-01 02:34:38 +0000
+++ doc/todo-from-arch.txt	2005-04-15 01:31:21 +0000
@@ -2,11 +2,10 @@
 Opportunities for improvement on GNU Arch
 ***************************************** 
 
-[note that this document is rather out of date in 2005-08]
 
-GNU Arch is one influence on bazaar-ng.  There are several things we
-would change from Arch in Bazaar to (we hope) improve the user
-experience.
+Bazaar-NG is based on the GNU Arch system, and inherits a lot of its
+design from Arch.  However, there are several things we will change in
+Baz to (we hope) improve the user experience.
 
 The core design of Arch is good, brilliant even.  It can scale from
 small projects too large ones, and is a good foundation for building

=== modified file 'setup.py'
--- setup.py	2005-09-04 03:32:17 +0000
+++ setup.py	2005-08-17 23:26:41 +0000
@@ -19,5 +19,5 @@
                 'bzrlib.util',
                 'bzrlib.util.elementtree',
                 'bzrlib.util.effbot.org',
-                ],
+                'bzrlib.util.urlgrabber'],
       scripts=['bzr'])

=== modified file 'testsweet.py'
--- testsweet.py	2005-08-30 01:35:40 +0000
+++ testsweet.py	2005-07-29 12:29:27 +0000
@@ -30,16 +30,15 @@
 * utilities to run external commands and check their return code
   and/or output
 
-Test cases should normally subclass testsweet.TestCase.  The test runner should
+Test cases should normally subclass TestBase.  The test runner should
 call runsuite().
 
 This is meant to become independent of bzr, though that's not quite
 true yet.
 """  
 
-import unittest
-import sys
-from bzrlib.selftest import TestUtil
+
+from unittest import TestResult, TestCase
 
 # XXX: Don't need this anymore now we depend on python2.4
 def _need_subprocess():
@@ -51,130 +50,325 @@
     pass
 
 
+
 class TestSkipped(Exception):
     """Indicates that a test was intentionally skipped, rather than failing."""
     # XXX: Not used yet
 
 
-
-class EarlyStoppingTestResultAdapter(object):
-    """An adapter for TestResult to stop at the first first failure or error"""
-
-    def __init__(self, result):
-        self._result = result
-
-    def addError(self, test, err):
-        self._result.addError(test, err)
-        self._result.stop()
-
-    def addFailure(self, test, err):
-        self._result.addFailure(test, err)
-        self._result.stop()
-
-    def __getattr__(self, name):
-        return getattr(self._result, name)
-
-    def __setattr__(self, name, value):
-        if name == '_result':
-            object.__setattr__(self, name, value)
-        return setattr(self._result, name, value)
-
-
-class _MyResult(unittest._TextTestResult):
+class TestBase(TestCase):
+    """Base class for bzr test cases.
+
+    Just defines some useful helper functions; doesn't actually test
+    anything.
+    """
+    
+    # TODO: Special methods to invoke bzr, so that we can run it
+    # through a specified Python intepreter
+
+    OVERRIDE_PYTHON = None # to run with alternative python 'python'
+    BZRPATH = 'bzr'
+
+    _log_buf = ""
+
+
+    def setUp(self):
+        super(TestBase, self).setUp()
+        self.log("%s setup" % self.id())
+
+
+    def tearDown(self):
+        super(TestBase, self).tearDown()
+        self.log("%s teardown" % self.id())
+        self.log('')
+
+
+    def formcmd(self, cmd):
+        if isinstance(cmd, basestring):
+            cmd = cmd.split()
+
+        if cmd[0] == 'bzr':
+            cmd[0] = self.BZRPATH
+            if self.OVERRIDE_PYTHON:
+                cmd.insert(0, self.OVERRIDE_PYTHON)
+
+        self.log('$ %r' % cmd)
+
+        return cmd
+
+
+    def runcmd(self, cmd, retcode=0):
+        """Run one command and check the return code.
+
+        Returns a tuple of (stdout,stderr) strings.
+
+        If a single string is based, it is split into words.
+        For commands that are not simple space-separated words, please
+        pass a list instead."""
+        try:
+            import shutil
+            from subprocess import call
+        except ImportError, e:
+            _need_subprocess()
+            raise
+
+
+        cmd = self.formcmd(cmd)
+
+        self.log('$ ' + ' '.join(cmd))
+        actual_retcode = call(cmd, stdout=self.TEST_LOG, stderr=self.TEST_LOG)
+
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+
+    def backtick(self, cmd, retcode=0):
+        """Run a command and return its output"""
+        try:
+            import shutil
+            from subprocess import Popen, PIPE
+        except ImportError, e:
+            _need_subprocess()
+            raise
+
+        cmd = self.formcmd(cmd)
+        child = Popen(cmd, stdout=PIPE, stderr=self.TEST_LOG)
+        outd, errd = child.communicate()
+        self.log(outd)
+        actual_retcode = child.wait()
+
+        outd = outd.replace('\r', '')
+
+        if retcode != actual_retcode:
+            raise CommandFailed("test failed: %r returned %d, expected %d"
+                                % (cmd, actual_retcode, retcode))
+
+        return outd
+
+
+
+    def build_tree(self, shape):
+        """Build a test tree according to a pattern.
+
+        shape is a sequence of file specifications.  If the final
+        character is '/', a directory is created.
+
+        This doesn't add anything to a branch.
+        """
+        # XXX: It's OK to just create them using forward slashes on windows?
+        import os
+        for name in shape:
+            assert isinstance(name, basestring)
+            if name[-1] == '/':
+                os.mkdir(name[:-1])
+            else:
+                f = file(name, 'wt')
+                print >>f, "contents of", name
+                f.close()
+
+
+    def log(self, msg):
+        """Log a message to a progress file"""
+        # XXX: The problem with this is that code that writes straight
+        # to the log file won't be shown when we display the log
+        # buffer; would be better to not have the in-memory buffer and
+        # instead just a log file per test, which is read in and
+        # displayed if the test fails.  That seems to imply one log
+        # per test case, not globally.  OK?
+        self._log_buf = self._log_buf + str(msg) + '\n'
+        print >>self.TEST_LOG, msg
+
+
+    def check_inventory_shape(self, inv, shape):
+        """
+        Compare an inventory to a list of expected names.
+
+        Fail if they are not precisely equal.
+        """
+        extras = []
+        shape = list(shape)             # copy
+        for path, ie in inv.entries():
+            name = path.replace('\\', '/')
+            if ie.kind == 'dir':
+                name = name + '/'
+            if name in shape:
+                shape.remove(name)
+            else:
+                extras.append(name)
+        if shape:
+            self.fail("expected paths not found in inventory: %r" % shape)
+        if extras:
+            self.fail("unexpected paths found in inventory: %r" % extras)
+
+
+    def check_file_contents(self, filename, expect):
+        self.log("check contents of file %s" % filename)
+        contents = file(filename, 'r').read()
+        if contents != expect:
+            self.log("expected: %r" % expect)
+            self.log("actually: %r" % contents)
+            self.fail("contents of %s not as expected")
+            
+
+
+class InTempDir(TestBase):
+    """Base class for tests run in a temporary branch."""
+    def setUp(self):
+        import os
+        self.test_dir = os.path.join(self.TEST_ROOT, self.__class__.__name__)
+        os.mkdir(self.test_dir)
+        os.chdir(self.test_dir)
+        
+    def tearDown(self):
+        import os
+        os.chdir(self.TEST_ROOT)
+
+
+
+
+
+class _MyResult(TestResult):
     """
     Custom TestResult.
 
     No special behaviour for now.
     """
+    def __init__(self, out, style):
+        self.out = out
+        TestResult.__init__(self)
+        assert style in ('none', 'progress', 'verbose')
+        self.style = style
+
 
     def startTest(self, test):
-        unittest.TestResult.startTest(self, test)
         # TODO: Maybe show test.shortDescription somewhere?
         what = test.id()
         # python2.3 has the bad habit of just "runit" for doctests
         if what == 'runit':
             what = test.shortDescription()
-        if self.showAll:
-            self.stream.write('%-60.60s' % what)
-        self.stream.flush()
+        
+        if self.style == 'verbose':
+            print >>self.out, '%-60.60s' % what,
+            self.out.flush()
+        elif self.style == 'progress':
+            self.out.write('~')
+            self.out.flush()
+        TestResult.startTest(self, test)
+
+
+    def stopTest(self, test):
+        # print
+        TestResult.stopTest(self, test)
+
 
     def addError(self, test, err):
-        super(_MyResult, self).addError(test, err)
-        self.stream.flush()
+        if self.style == 'verbose':
+            print >>self.out, 'ERROR'
+        TestResult.addError(self, test, err)
+        _show_test_failure('error', test, err, self.out)
 
     def addFailure(self, test, err):
-        super(_MyResult, self).addFailure(test, err)
-        self.stream.flush()
+        if self.style == 'verbose':
+            print >>self.out, 'FAILURE'
+        TestResult.addFailure(self, test, err)
+        _show_test_failure('failure', test, err, self.out)
 
     def addSuccess(self, test):
-        if self.showAll:
-            self.stream.writeln('OK')
-        elif self.dots:
-            self.stream.write('~')
-        self.stream.flush()
-        unittest.TestResult.addSuccess(self, test)
-
-    def printErrorList(self, flavour, errors):
-        for test, err in errors:
-            self.stream.writeln(self.separator1)
-            self.stream.writeln("%s: %s" % (flavour,self.getDescription(test)))
-            self.stream.writeln(self.separator2)
-            self.stream.writeln("%s" % err)
-            if hasattr(test, '_get_log'):
-                self.stream.writeln()
-                self.stream.writeln('log from this test:')
-                print >>self.stream, test._get_log()
-
-
-class TextTestRunner(unittest.TextTestRunner):
-
-    def _makeResult(self):
-        result = _MyResult(self.stream, self.descriptions, self.verbosity)
-        return EarlyStoppingTestResultAdapter(result)
-
-
-class filteringVisitor(TestUtil.TestVisitor):
-    """I accruse all the testCases I visit that pass a regexp filter on id
-    into my suite
-    """
-
-    def __init__(self, filter):
-        import re
-        TestUtil.TestVisitor.__init__(self)
-        self._suite=None
-        self.filter=re.compile(filter)
-
-    def suite(self):
-        """answer the suite we are building"""
-        if self._suite is None:
-            self._suite=TestUtil.TestSuite()
-        return self._suite
-
-    def visitCase(self, aCase):
-        if self.filter.match(aCase.id()):
-            self.suite().addTest(aCase)
-
-
-def run_suite(suite, name='test', verbose=False, pattern=".*"):
+        if self.style == 'verbose':
+            print >>self.out, 'OK'
+        TestResult.addSuccess(self, test)
+
+
+
+def run_suite(suite, name='test', verbose=False):
+    import os
     import shutil
-    from bzrlib.selftest import TestCaseInTempDir
-    TestCaseInTempDir._TEST_NAME = name
-    if verbose:
-        verbosity = 2
-    else:
-        verbosity = 1
-    runner = TextTestRunner(stream=sys.stdout,
-                            descriptions=0,
-                            verbosity=verbosity)
-    visitor = filteringVisitor(pattern)
-    suite.visit(visitor)
-    result = runner.run(visitor.suite())
-    # This is still a little bogus, 
-    # but only a little. Folk not using our testrunner will
-    # have to delete their temp directories themselves.
-    if result.wasSuccessful():
-        if TestCaseInTempDir.TEST_ROOT:
-            shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
-    else:
-        print "Failed tests working directories are in '%s'\n" % TestCaseInTempDir.TEST_ROOT
+    import time
+    import sys
+    
+    _setup_test_log(name)
+    _setup_test_dir(name)
+    print
+
+    # save stdout & stderr so there's no leakage from code-under-test
+    real_stdout = sys.stdout
+    real_stderr = sys.stderr
+    sys.stdout = sys.stderr = TestBase.TEST_LOG
+    try:
+        if verbose:
+            style = 'verbose'
+        else:
+            style = 'progress'
+        result = _MyResult(real_stdout, style)
+        suite.run(result)
+    finally:
+        sys.stdout = real_stdout
+        sys.stderr = real_stderr
+
+    _show_results(result)
+
     return result.wasSuccessful()
+
+
+
+def _setup_test_log(name):
+    import time
+    import os
+    
+    log_filename = os.path.abspath(name + '.log')
+    TestBase.TEST_LOG = open(log_filename, 'wt', buffering=1) # line buffered
+
+    print >>TestBase.TEST_LOG, "tests run at " + time.ctime()
+    print '%-30s %s' % ('test log', log_filename)
+
+
+def _setup_test_dir(name):
+    import os
+    import shutil
+    
+    TestBase.ORIG_DIR = os.getcwdu()
+    TestBase.TEST_ROOT = os.path.abspath(name + '.tmp')
+
+    print '%-30s %s' % ('running tests in', TestBase.TEST_ROOT)
+
+    if os.path.exists(TestBase.TEST_ROOT):
+        shutil.rmtree(TestBase.TEST_ROOT)
+    os.mkdir(TestBase.TEST_ROOT)
+    os.chdir(TestBase.TEST_ROOT)
+
+    # make a fake bzr directory there to prevent any tests propagating
+    # up onto the source directory's real branch
+    os.mkdir(os.path.join(TestBase.TEST_ROOT, '.bzr'))
+
+    
+
+def _show_results(result):
+     print
+     print '%4d tests run' % result.testsRun
+     print '%4d errors' % len(result.errors)
+     print '%4d failures' % len(result.failures)
+
+
+
+def _show_test_failure(kind, case, exc_info, out):
+    from traceback import print_exception
+
+    print >>out
+    print >>out, '-' * 60
+    print >>out, case
+    
+    desc = case.shortDescription()
+    if desc:
+        print >>out, '   (%s)' % desc
+         
+    print_exception(exc_info[0], exc_info[1], exc_info[2], None, out)
+        
+    if isinstance(case, TestBase):
+        print >>out
+        print >>out, 'log from this test:'
+        print >>out, case._log_buf
+         
+    print >>out, '-' * 60
+    
+

=== modified file 'tools/history2weaves.py'
--- tools/history2weaves.py	2005-08-29 04:53:09 +0000
+++ tools/history2weaves.py	2005-08-22 14:14:01 +0000
@@ -25,22 +25,17 @@
     pass
 
 
-import logging
-
 import bzrlib.branch
 from bzrlib.revfile import Revfile
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave
 from bzrlib.progress import ProgressBar
 from bzrlib.atomicfile import AtomicFile
-import bzrlib.trace
 import tempfile
 import hotshot, hotshot.stats
 import sys
 
 def convert():
-    bzrlib.trace.enable_default_logging()
-
     pb = ProgressBar()
 
     inv_weave = Weave()

=== modified file 'tools/http_client.py'
--- tools/http_client.py	2005-08-25 12:46:42 +0000
+++ tools/http_client.py	2005-08-19 22:42:40 +0000
@@ -68,22 +68,12 @@
 # The content is written into temporary files.  It returns a list of
 # readable file objects.
 
-# TODO: If we try pipelined or keepalive and the connection drop out
-# then retry the request on a new connection; eventually we should perhaps
-# learn that a given host or network just won't allow keepalive.
-
-
 import asyncore
 import socket, string, time, sys
 import StringIO
 import mimetools, urlparse, urllib
 import logging
 
-logging.basicConfig(level=logging.DEBUG,
-                    format='%(asctime)s %(levelname)s %(message)s',
-                    filename='/tmp/http_client.log',
-                    filemode='w')
-
 logger = logging.getLogger('bzr.http_client')
 debug = logger.debug
 info = logger.info
@@ -125,7 +115,7 @@
         self.channels = []
         self.try_pipelined = False
         self.try_keepalive = False
-        self.max_channels = 5
+        self.max_channels = 3
 
 
     def enqueue(self, url, consumer):
@@ -144,9 +134,10 @@
 
     def _make_channel(self):
         # proxy2 203.17.154.69
-        # return HttpChannel('82.211.81.161', 80, self)         # bazaar-ng.org 
+        # bazaar-ng.org 
+        return HttpChannel('82.211.81.161', 80, self)
         # return HttpChannel('203.17.154.69', 8080, self)
-        return HttpChannel('127.0.0.1', 8000, self)  # forwarded
+        # return HttpChannel('localhost', 8000, self)
             
 
     def _wake_up_channel(self):
@@ -181,7 +172,7 @@
             choice(self.channels).take_one()
 
 
-        # debug("request postponed until a channel's idle")
+        debug("request left until a channel's idle")
         
 
 
@@ -403,20 +394,15 @@
                 
                 assert got_data
 
+                debug('pass back %d bytes of %s' % (len(got_data),
+                                                    self.sent_requests[0][0]))
+                consumer.feed(data)
+
                 self.content_remaining -= len(got_data)
 
-                debug('pass back %d bytes of %s, %d remain'
-                      % (len(got_data),
-                         self.sent_requests[0][0],
-                         self.content_remaining))
-                consumer.feed(data)
-
             if self.content_remaining == 0:
                 del self.sent_requests[0]
 
-                debug('content complete')
-                consumer.content_complete()
-                
                 # reset lots of things and try to get the next response header
                 if self.response.connection_reply == 'close':
                     debug('server requested close')
@@ -428,6 +414,7 @@
                     self.close()
                 else:
                     debug("ready for next header...")
+                    consumer.content_complete()
                     self.take_one()
                 self.response = None
 
@@ -441,61 +428,44 @@
         self.close()
 
 
-class DummyConsumer:
-    def __init__(self, url, pb):
-        self.url = url
-        self.outf = None
-        self._pb = pb
-
-    def feed(self, data):
-        # print "feed", repr(data)
-        # print "feed", repr(data[:20]), repr(data[-20:]), len(data)
-        if not self.outf:
-            base = self.url[self.url.rindex('/')+1:]
-            self.outf = file('/tmp/download/' + base, 'wb')
-        self.outf.write(data)
-
-    def error(self, err_info):
-        import traceback
-        error('error reported to consumer')
-        traceback.print_exception(err_info[0], err_info[1], err_info[2])
-        sys.exit(1)
-
-    def content_complete(self):
-        info('content complete from %s' % self.url)
-        self.outf.close()
-        self.outf = None
-        # using last_cnt is cheating
-        self._pb.update('downloading inventory',
-                        self._pb.last_cnt+1,
-                        self._pb.last_total)
-
-
-
 if __name__ == "__main__":
+    class dummy_consumer:
+        def __init__(self, url):
+            self.url = url
+
+        def feed(self, data):
+            # print "feed", repr(data)
+            # print "feed", repr(data[:20]), repr(data[-20:]), len(data)
+            pass
+            
+        def error(self, err_info):
+            import traceback
+            traceback.print_exception(err_info[0], err_info[1], err_info[2])
+
+        def content_complete(self):
+            debug('content complete from %s' % self.url)
+            
+
     logging.basicConfig(level=logging.DEBUG)
 
     mgr = DownloadManager()
 
     from bzrlib.branch import Branch
-    from bzrlib.progress import ProgressBar
-
-    pb = ProgressBar()
     revs = Branch('/home/mbp/work/bzr').revision_history()
-    pb.update('downloading inventories', 0, len(revs))
-
-    for rev in revs:
-        url = 'http://www.bazaar-ng.org/bzr/bzr.dev/.bzr/inventory-store/' \
-              + rev + '.gz'
-        mgr.enqueue(url, DummyConsumer(url, pb))
-
-    mgr.run()
-    
-
-
+
+        
     
 #     for url in ['http://www.bazaar-ng.org/',
 #                 'http://www.bazaar-ng.org/tutorial.html',
 #                 'http://www.bazaar-ng.org/download.html',
 #                 'http://www.bazaar-ng.org/bzr/bzr.dev/.bzr/revision-store/mbp@hope-20050415013653-3b3c9c3d33fae0a6.gz',
 #                 ]:
+
+    for rev in revs:
+#        url = 'http://www.bazaar-ng.org/bzr/bzr.dev/.bzr/revision-store/' \
+        url = 'http://www.bazaar-ng.org/bzr/bzr.dev/.bzr/inventory-store/' \
+              + rev + '.gz'
+        mgr.enqueue(url, dummy_consumer(url))
+
+    mgr.run()
+    

=== modified file 'tools/weavebench.py'
--- tools/weavebench.py	2005-08-25 07:48:27 +0000
+++ tools/weavebench.py	2005-07-18 11:23:40 +0000
@@ -51,7 +51,7 @@
             if lines:
                 del lines[randrange(0, len(lines))]
 
-        rev_id = wf.add("%s" % i, parents, lines)
+        rev_id = wf.add(parents, lines)
         parents = [rev_id]
 
     write_weave(wf, file(WEAVE_NAME, 'wb'))

=== modified file 'tutorial.txt'
--- tutorial.txt	2005-09-01 12:34:34 +0000
+++ tutorial.txt	2005-08-12 15:24:19 +0000
@@ -5,8 +5,11 @@
 current for bzr 0.0.6pre, July 2005
 
 
-*NOTE* For a more current and user-editable version of this 
-document, see the wiki at http://bazaar.canonical.com/IntroductionToBzr
+*Note:* This tutorial is a work in 
+progress, and describes code that is itself still evolving. 
+If you have comments on either the design or the tutorial, 
+please send them to the bazaar-ng@lists.canonical.com mailing list.
+
 
 
 Introduction
@@ -51,7 +54,7 @@
 Some people want to avoid sharing their email address so as not to
 get spam.  bzr will never
 disclose your email address unless you tell it to by publishing an
-archive or transmitting a changeset.  It's recommended that you do use
+archive or transmiting a changeset.  It's recommended that you do use
 a real address, so that people can contact you about your work, but
 it's not required.  You can use an address which is obfuscated, which
 bounces, or which goes through an anti-spam service such as spamgourmet.com.
@@ -289,8 +292,8 @@
 a copy.  Because this new copy is potentially a new branch, the
 command is called *branch*::
 
-    % bzr branch http://bazaar-ng.org/bzr/bzr.dev 
-    % cd bzr.dev
+    % bzr branch http://bazaar-ng.org/bzr/main ./bzr-main
+    % cd bzr-main
 
 This copies down the complete history of this branch, so we can
 do all operations on it locally: log, annotate, making and merging
@@ -307,6 +310,6 @@
 
     % bzr pull
 
-This only works if your local branch includes only changes from the
-parent branch.  Otherwise, the branches are said to have *diverged*,
-and they must be merged instead.
+This only works if the local branch if your branch includes only
+changes from the parent branch.  Otherwise, the branches are said to
+have *diverged*, and they must be merged instead.

